/*===========================================================================*/
/*   (Llib/socket.scm)                                                       */
/*   Bigloo (3.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jul 1 12:14:45 CEST 2010        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -srfi enable-gmp -srfi bigloo-unsafe -O3 -q +rm -lib-dir /users/serrano/prgm/project/bigloo/lib/3.4a -mklib -cc gcc -fsharing -q -no-hello -copt -fPIC -unsafe -safee -O4 -c Llib/socket.scm -indent -o objs/obj_u/Llib/socket.c)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif
	BGL_EXPORTED_DECL obj_t BGl_getzd2protocolzd2zz__socketz00(obj_t);
	static obj_t BGl__socketzd2closezd2zz__socketz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__socketz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t bgl_getprotobynumber(long);
	static obj_t BGl_toplevelzd2initzd2zz__socketz00();
	static obj_t BGl__socketzd2acceptzd2manyz00zz__socketz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_socketzd2shutdownzd2zz__socketz00(obj_t, obj_t);
	static obj_t BGl_list2304z00zz__socketz00 = BUNSPEC;
	static obj_t BGl_list2309z00zz__socketz00 = BUNSPEC;
	extern obj_t bgl_getsockopt(obj_t, obj_t);
	static obj_t BGl__socketzd2optionzd2setz12z12zz__socketz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t bstring_to_symbol(obj_t);
	static obj_t BGl__socketzd2acceptzd2zz__socketz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_makezd2serverzd2socketz00zz__socketz00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_z52socketzd2initz12z92zz__socketz00();
	static obj_t BGl__socketzd2downzf3z21zz__socketz00(obj_t, obj_t);
	static obj_t BGl__socketzd2optionzd2zz__socketz00(obj_t, obj_t, obj_t);
	static obj_t BGl_keyword2286z00zz__socketz00 = BUNSPEC;
	static obj_t BGl_keyword2288z00zz__socketz00 = BUNSPEC;
	static obj_t BGl_requirezd2initializa7ationz75zz__socketz00 = BUNSPEC;
	static obj_t BGl_keyword2290z00zz__socketz00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t BGl_getzd2protocolszd2zz__socketz00();
	static obj_t BGl_keyword2292z00zz__socketz00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t BGl_socketzd2inputzd2zz__socketz00(obj_t);
	extern obj_t bgl_host(obj_t);
	static obj_t BGl_keyword2305z00zz__socketz00 = BUNSPEC;
	static obj_t BGl_keyword2307z00zz__socketz00 = BUNSPEC;
	static obj_t BGl_keyword2310z00zz__socketz00 = BUNSPEC;
	extern obj_t make_vector(int, obj_t);
	static obj_t BGl_keyword2315z00zz__socketz00 = BUNSPEC;
	static obj_t BGl__hostinfoz00zz__socketz00(obj_t, obj_t);
	static obj_t BGl_keyword2317z00zz__socketz00 = BUNSPEC;
	static obj_t BGl__socketzd2clientzf3z21zz__socketz00(obj_t, obj_t);
	extern obj_t bgl_hostinfo(obj_t);
	extern obj_t socket_local_addr(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_socketzd2closezd2zz__socketz00(obj_t);
	static obj_t BGl__hostz00zz__socketz00(obj_t, obj_t);
	static obj_t BGl__socketzd2hostnamezd2zz__socketz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_socketzd2acceptzd2manyz00zz__socketz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	extern obj_t socket_shutdown(obj_t, bool_t);
	static obj_t BGl_genericzd2initzd2zz__socketz00();
	extern obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern obj_t bgl_make_client_socket(obj_t, int, int, obj_t, obj_t);
	static obj_t BGl__socketzf3zf3zz__socketz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_socketzd2optionzd2setz12z12zz__socketz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_zc3anonymousza31874ze3z83zz__socketz00(obj_t, obj_t);
	static obj_t BGl_za2socketzd2mutexza2zd2zz__socketz00 = BUNSPEC;
	extern void socket_cleanup();
	BGL_EXPORTED_DECL bool_t BGl_socketzf3zf3zz__socketz00(obj_t);
	extern bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
	static obj_t BGl__hostnamez00zz__socketz00(obj_t);
	static obj_t BGl__socketzd2shutdownzd2zz__socketz00(obj_t, obj_t);
	static obj_t BGl__makezd2clientzd2socketz00zz__socketz00(obj_t, obj_t);
	BGL_EXPORTED_DECL bool_t BGl_socketzd2downzf3z21zz__socketz00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_socketzd2acceptzd2zz__socketz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t bgl_make_unix_socket(obj_t, int, obj_t, obj_t);
	extern void socket_startup();
	BGL_EXPORTED_DECL obj_t BGl_socketzd2optionzd2zz__socketz00(obj_t, obj_t);
	static obj_t BGl__socketzd2outputzd2zz__socketz00(obj_t, obj_t);
	static obj_t BGl__socketzd2serverzf3z21zz__socketz00(obj_t, obj_t);
	extern obj_t BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(obj_t, obj_t, obj_t);
	extern obj_t bgl_getprotoents();
	BGL_EXPORTED_DECL obj_t BGl_socketzd2localzd2addressz00zz__socketz00(obj_t);
	extern obj_t bgl_setsockopt(obj_t, obj_t, obj_t);
	extern obj_t bgl_getprotobyname(char *);
	static obj_t BGl__socketzd2portzd2numberz00zz__socketz00(obj_t, obj_t);
	extern obj_t socket_close(obj_t);
	static obj_t BGl_cnstzd2initzd2zz__socketz00();
	extern obj_t BGl_getzd2portzd2bufferz00zz__r4_ports_6_10_1z00(obj_t, obj_t,
		int);
	BGL_EXPORTED_DECL obj_t BGl_makezd2clientzd2socketz00zz__socketz00(obj_t, int,
		obj_t, obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL bool_t BGl_socketzd2clientzf3z21zz__socketz00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_hostinfoz00zz__socketz00(obj_t);
	static obj_t BGl__socketzd2localzd2addressz00zz__socketz00(obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zz__socketz00();
	static obj_t BGl__getzd2protocolzd2zz__socketz00(obj_t, obj_t);
	extern obj_t BGl_registerzd2exitzd2functionz12z12zz__biglooz00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_socketzd2outputzd2zz__socketz00(obj_t);
	extern obj_t BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_socketzd2portzd2numberz00zz__socketz00(obj_t);
	extern obj_t BGl_dssslzd2checkzd2keyzd2argsz12zc0zz__dssslz00(obj_t, obj_t);
	extern obj_t bgl_socket_accept(obj_t, bool_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_hostnamez00zz__socketz00();
	extern obj_t bgl_make_server_socket(obj_t, int, int);
	BGL_EXPORTED_DECL obj_t BGl_hostz00zz__socketz00(obj_t);
	extern obj_t bgl_gethostname();
	BGL_EXPORTED_DECL obj_t BGl_socketzd2hostzd2addressz00zz__socketz00(obj_t);
	extern obj_t bstring_to_keyword(obj_t);
	static obj_t BGl__socketzd2hostzd2addressz00zz__socketz00(obj_t, obj_t);
	static obj_t BGl__z52socketzd2initz12z92zz__socketz00(obj_t);
	static bool_t BGl_za2socketzd2initializa7edza2z75zz__socketz00;
	static obj_t BGl_symbol2284z00zz__socketz00 = BUNSPEC;
	static obj_t BGl__getzd2protocolszd2zz__socketz00(obj_t);
	static obj_t BGl_symbol2301z00zz__socketz00 = BUNSPEC;
	BGL_EXPORTED_DECL bool_t BGl_socketzd2serverzf3z21zz__socketz00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_socketzd2hostnamezd2zz__socketz00(obj_t);
	static obj_t BGl_symbol2297z00zz__socketz00 = BUNSPEC;
	static obj_t BGl_methodzd2initzd2zz__socketz00();
	static obj_t BGl_symbol2299z00zz__socketz00 = BUNSPEC;
	static obj_t BGl__socketzd2inputzd2zz__socketz00(obj_t, obj_t);
	static obj_t BGl_symbol2313z00zz__socketz00 = BUNSPEC;
	static obj_t BGl__makezd2serverzd2socketz00zz__socketz00(obj_t, obj_t);
	extern long bgl_socket_accept_many(obj_t, bool_t, obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2321z00zz__socketz00 = BUNSPEC;
	static obj_t *__cnst;


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_hostinfozd2envzd2zz__socketz00,
		BgL_bgl__hostinfoza700za7za7__2334za7, BGl__hostinfoz00zz__socketz00, 0L,
		BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_socketzd2localzd2addresszd2envzd2zz__socketz00,
		BgL_bgl__socketza7d2localza72335z00,
		BGl__socketzd2localzd2addressz00zz__socketz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_socketzf3zd2envz21zz__socketz00,
		BgL_bgl__socketza7f3za7f3za7za7_2336z00, BGl__socketzf3zf3zz__socketz00, 0L,
		BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_socketzd2hostnamezd2envz00zz__socketz00,
		BgL_bgl__socketza7d2hostna2337za7, BGl__socketzd2hostnamezd2zz__socketz00,
		0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_hostnamezd2envzd2zz__socketz00,
		BgL_bgl__hostnameza700za7za7__2338za7, BGl__hostnamez00zz__socketz00, 0L,
		BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_socketzd2hostzd2addresszd2envzd2zz__socketz00,
		BgL_bgl__socketza7d2hostza7d2339z00,
		BGl__socketzd2hostzd2addressz00zz__socketz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_socketzd2portzd2numberzd2envzd2zz__socketz00,
		BgL_bgl__socketza7d2portza7d2340z00,
		BGl__socketzd2portzd2numberz00zz__socketz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_makezd2clientzd2socketzd2envzd2zz__socketz00,
		BgL_bgl__makeza7d2clientza7d2341z00, opt_generic_entry,
		BGl__makezd2clientzd2socketz00zz__socketz00, BFALSE, -1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_getzd2protocolzd2envz00zz__socketz00,
		BgL_bgl__getza7d2protocolza72342z00, BGl__getzd2protocolzd2zz__socketz00,
		0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_makezd2serverzd2socketzd2envzd2zz__socketz00,
		BgL_bgl__makeza7d2serverza7d2343z00, va_generic_entry,
		BGl__makezd2serverzd2socketz00zz__socketz00, BUNSPEC, -1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_z52socketzd2initz12zd2envz40zz__socketz00,
		BgL_bgl__za752socketza7d2ini2344z00,
		BGl__z52socketzd2initz12z92zz__socketz00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_socketzd2serverzf3zd2envzf3zz__socketz00,
		BgL_bgl__socketza7d2server2345za7, BGl__socketzd2serverzf3z21zz__socketz00,
		0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_socketzd2shutdownzd2envz00zz__socketz00,
		BgL_bgl__socketza7d2shutdo2346za7, opt_generic_entry,
		BGl__socketzd2shutdownzd2zz__socketz00, BFALSE, -1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_socketzd2acceptzd2manyzd2envzd2zz__socketz00,
		BgL_bgl__socketza7d2accept2347za7, opt_generic_entry,
		BGl__socketzd2acceptzd2manyz00zz__socketz00, BFALSE, -1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_socketzd2acceptzd2envz00zz__socketz00,
		BgL_bgl__socketza7d2accept2348za7, opt_generic_entry,
		BGl__socketzd2acceptzd2zz__socketz00, BFALSE, -1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_getzd2protocolszd2envz00zz__socketz00,
		BgL_bgl__getza7d2protocols2349za7, BGl__getzd2protocolszd2zz__socketz00, 0L,
		BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2275z00zz__socketz00,
		BgL_bgl_za7c3anonymousza7a312350z00,
		BGl_zc3anonymousza31874ze3z83zz__socketz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_socketzd2clientzf3zd2envzf3zz__socketz00,
		BgL_bgl__socketza7d2client2351za7, BGl__socketzd2clientzf3z21zz__socketz00,
		0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_socketzd2outputzd2envz00zz__socketz00,
		BgL_bgl__socketza7d2output2352za7, BGl__socketzd2outputzd2zz__socketz00, 0L,
		BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_socketzd2closezd2envz00zz__socketz00,
		BgL_bgl__socketza7d2closeza72353z00, BGl__socketzd2closezd2zz__socketz00,
		0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_socketzd2downzf3zd2envzf3zz__socketz00,
		BgL_bgl__socketza7d2downza7f2354z00, BGl__socketzd2downzf3z21zz__socketz00,
		0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_socketzd2inputzd2envz00zz__socketz00,
		BgL_bgl__socketza7d2inputza72355z00, BGl__socketzd2inputzd2zz__socketz00,
		0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2274z00zz__socketz00,
		BgL_bgl_string2274za700za7za7_2356za7, "socket", 6);
	      DEFINE_STRING(BGl_string2276z00zz__socketz00,
		BgL_bgl_string2276za700za7za7_2357za7, "_socket-hostname", 16);
	      DEFINE_STRING(BGl_string2277z00zz__socketz00,
		BgL_bgl_string2277za700za7za7_2358za7,
		"/tmp/bigloo/runtime/Llib/socket.scm", 35);
	      DEFINE_STRING(BGl_string2278z00zz__socketz00,
		BgL_bgl_string2278za700za7za7_2359za7, "_socket-host-address", 20);
	      DEFINE_STRING(BGl_string2280z00zz__socketz00,
		BgL_bgl_string2280za700za7za7_2360za7, "_socket-down?", 13);
	      DEFINE_STRING(BGl_string2279z00zz__socketz00,
		BgL_bgl_string2279za700za7za7_2361za7, "_socket-local-address", 21);
	      DEFINE_STRING(BGl_string2281z00zz__socketz00,
		BgL_bgl_string2281za700za7za7_2362za7, "_socket-port-number", 19);
	      DEFINE_STRING(BGl_string2282z00zz__socketz00,
		BgL_bgl_string2282za700za7za7_2363za7, "_socket-input", 13);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_socketzd2optionzd2envz00zz__socketz00,
		BgL_bgl__socketza7d2option2364za7, BGl__socketzd2optionzd2zz__socketz00, 0L,
		BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2283z00zz__socketz00,
		BgL_bgl_string2283za700za7za7_2365za7, "_socket-output", 14);
	      DEFINE_STRING(BGl_string2285z00zz__socketz00,
		BgL_bgl_string2285za700za7za7_2366za7, "inet", 4);
	      DEFINE_STRING(BGl_string2287z00zz__socketz00,
		BgL_bgl_string2287za700za7za7_2367za7, "domain", 6);
	      DEFINE_STRING(BGl_string2300z00zz__socketz00,
		BgL_bgl_string2300za700za7za7_2368za7, "unix", 4);
	      DEFINE_STRING(BGl_string2289z00zz__socketz00,
		BgL_bgl_string2289za700za7za7_2369za7, "inbuf", 5);
	      DEFINE_STRING(BGl_string2291z00zz__socketz00,
		BgL_bgl_string2291za700za7za7_2370za7, "outbuf", 6);
	      DEFINE_STRING(BGl_string2302z00zz__socketz00,
		BgL_bgl_string2302za700za7za7_2371za7, "local", 5);
	      DEFINE_STRING(BGl_string2303z00zz__socketz00,
		BgL_bgl_string2303za700za7za7_2372za7, "Unknown socket domain", 21);
	      DEFINE_STRING(BGl_string2293z00zz__socketz00,
		BgL_bgl_string2293za700za7za7_2373za7, "timeout", 7);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_socketzd2optionzd2setz12zd2envzc0zz__socketz00,
		BgL_bgl__socketza7d2option2374za7,
		BGl__socketzd2optionzd2setz12z12zz__socketz00, 0L, BUNSPEC, 3);
	      DEFINE_STRING(BGl_string2294z00zz__socketz00,
		BgL_bgl_string2294za700za7za7_2375za7, "_make-client-socket", 19);
	      DEFINE_STRING(BGl_string2295z00zz__socketz00,
		BgL_bgl_string2295za700za7za7_2376za7, "bstring", 7);
	      DEFINE_STRING(BGl_string2306z00zz__socketz00,
		BgL_bgl_string2306za700za7za7_2377za7, "backlog", 7);
	      DEFINE_STRING(BGl_string2296z00zz__socketz00,
		BgL_bgl_string2296za700za7za7_2378za7, "int", 3);
	      DEFINE_STRING(BGl_string2308z00zz__socketz00,
		BgL_bgl_string2308za700za7za7_2379za7, "name", 4);
	      DEFINE_STRING(BGl_string2298z00zz__socketz00,
		BgL_bgl_string2298za700za7za7_2380za7, "make-client-socket", 18);
	      DEFINE_STRING(BGl_string2311z00zz__socketz00,
		BgL_bgl_string2311za700za7za7_2381za7, "errp", 4);
	      DEFINE_STRING(BGl_string2312z00zz__socketz00,
		BgL_bgl_string2312za700za7za7_2382za7, "_socket-accept", 14);
	      DEFINE_STRING(BGl_string2314z00zz__socketz00,
		BgL_bgl_string2314za700za7za7_2383za7, "socket-accept", 13);
	      DEFINE_STRING(BGl_string2316z00zz__socketz00,
		BgL_bgl_string2316za700za7za7_2384za7, "inbufs", 6);
	      DEFINE_STRING(BGl_string2318z00zz__socketz00,
		BgL_bgl_string2318za700za7za7_2385za7, "outbufs", 7);
	      DEFINE_STRING(BGl_string2320z00zz__socketz00,
		BgL_bgl_string2320za700za7za7_2386za7, "vector", 6);
	      DEFINE_STRING(BGl_string2319z00zz__socketz00,
		BgL_bgl_string2319za700za7za7_2387za7, "_socket-accept-many", 19);
	      DEFINE_STRING(BGl_string2322z00zz__socketz00,
		BgL_bgl_string2322za700za7za7_2388za7, "socket-accept-many", 18);
	      DEFINE_STRING(BGl_string2323z00zz__socketz00,
		BgL_bgl_string2323za700za7za7_2389za7, "_socket-shutdown", 16);
	      DEFINE_STRING(BGl_string2324z00zz__socketz00,
		BgL_bgl_string2324za700za7za7_2390za7, "_socket-close", 13);
	      DEFINE_STRING(BGl_string2325z00zz__socketz00,
		BgL_bgl_string2325za700za7za7_2391za7, "_host", 5);
	      DEFINE_STRING(BGl_string2326z00zz__socketz00,
		BgL_bgl_string2326za700za7za7_2392za7, "_hostinfo", 9);
	      DEFINE_STRING(BGl_string2327z00zz__socketz00,
		BgL_bgl_string2327za700za7za7_2393za7, "_socket-option", 14);
	      DEFINE_STRING(BGl_string2328z00zz__socketz00,
		BgL_bgl_string2328za700za7za7_2394za7, "keyword", 7);
	      DEFINE_STRING(BGl_string2330z00zz__socketz00,
		BgL_bgl_string2330za700za7za7_2395za7, "__socket", 8);
	      DEFINE_STRING(BGl_string2329z00zz__socketz00,
		BgL_bgl_string2329za700za7za7_2396za7, "_socket-option-set!", 19);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_hostzd2envzd2zz__socketz00,
		BgL_bgl__hostza700za7za7__sock2397za7, BGl__hostz00zz__socketz00, 0L,
		BUNSPEC, 1);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__socketz00(long
		BgL_checksumz00_1932, char *BgL_fromz00_1933)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zz__socketz00))
				{
					BGl_requirezd2initializa7ationz75zz__socketz00 = BBOOL(((bool_t) 0));
					BGl_cnstzd2initzd2zz__socketz00();
					BGl_importedzd2moduleszd2initz00zz__socketz00();
					BGl_toplevelzd2initzd2zz__socketz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zz__socketz00()
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 14 */
			BGl_symbol2284z00zz__socketz00 =
				bstring_to_symbol(BGl_string2285z00zz__socketz00);
			BGl_keyword2286z00zz__socketz00 =
				bstring_to_keyword(BGl_string2287z00zz__socketz00);
			BGl_keyword2288z00zz__socketz00 =
				bstring_to_keyword(BGl_string2289z00zz__socketz00);
			BGl_keyword2290z00zz__socketz00 =
				bstring_to_keyword(BGl_string2291z00zz__socketz00);
			BGl_keyword2292z00zz__socketz00 =
				bstring_to_keyword(BGl_string2293z00zz__socketz00);
			BGl_symbol2297z00zz__socketz00 =
				bstring_to_symbol(BGl_string2298z00zz__socketz00);
			BGl_symbol2299z00zz__socketz00 =
				bstring_to_symbol(BGl_string2300z00zz__socketz00);
			BGl_symbol2301z00zz__socketz00 =
				bstring_to_symbol(BGl_string2302z00zz__socketz00);
			BGl_keyword2305z00zz__socketz00 =
				bstring_to_keyword(BGl_string2306z00zz__socketz00);
			BGl_keyword2307z00zz__socketz00 =
				bstring_to_keyword(BGl_string2308z00zz__socketz00);
			BGl_list2304z00zz__socketz00 =
				MAKE_PAIR(BGl_keyword2305z00zz__socketz00,
				MAKE_PAIR(BGl_keyword2307z00zz__socketz00, BNIL));
			BGl_list2309z00zz__socketz00 =
				MAKE_PAIR(BGl_keyword2307z00zz__socketz00,
				MAKE_PAIR(BGl_keyword2305z00zz__socketz00, BNIL));
			BGl_keyword2310z00zz__socketz00 =
				bstring_to_keyword(BGl_string2311z00zz__socketz00);
			BGl_symbol2313z00zz__socketz00 =
				bstring_to_symbol(BGl_string2314z00zz__socketz00);
			BGl_keyword2315z00zz__socketz00 =
				bstring_to_keyword(BGl_string2316z00zz__socketz00);
			BGl_keyword2317z00zz__socketz00 =
				bstring_to_keyword(BGl_string2318z00zz__socketz00);
			return (BGl_symbol2321z00zz__socketz00 =
				bstring_to_symbol(BGl_string2322z00zz__socketz00), BUNSPEC);
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zz__socketz00()
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 14 */
			BGl_za2socketzd2initializa7edza2z75zz__socketz00 = ((bool_t) 0);
			return (BGl_za2socketzd2mutexza2zd2zz__socketz00 =
				bgl_make_mutex(BGl_string2274z00zz__socketz00), BUNSPEC);
		}
	}



/* %socket-init! */
	BGL_EXPORTED_DEF obj_t BGl_z52socketzd2initz12z92zz__socketz00()
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 178 */
			{	/* Llib/socket.scm 179 */
				obj_t BgL_g1865z00_774;

				BgL_g1865z00_774 = BGl_za2socketzd2mutexza2zd2zz__socketz00;
				{	/* Llib/thread.scm 201 */

					if ((((long) 0) == ((long) 0)))
						{	/* Llib/thread.scm 201 */
							bgl_mutex_lock(BgL_g1865z00_774);
						}
					else
						{	/* Llib/thread.scm 201 */
							bgl_mutex_timed_lock(BgL_g1865z00_774, ((long) 0));
			}}}
			if (BGl_za2socketzd2initializa7edza2z75zz__socketz00)
				{	/* Llib/socket.scm 180 */
					BFALSE;
				}
			else
				{	/* Llib/socket.scm 180 */
					BGl_za2socketzd2initializa7edza2z75zz__socketz00 = ((bool_t) 1);
					socket_startup();
					BUNSPEC;
					BGl_registerzd2exitzd2functionz12z12zz__biglooz00
						(BGl_proc2275z00zz__socketz00);
					BUNSPEC;
				}
			{	/* Llib/socket.scm 190 */
				obj_t BgL_mz00_1367;

				BgL_mz00_1367 = BGl_za2socketzd2mutexza2zd2zz__socketz00;
				return BBOOL(bgl_mutex_unlock(BgL_mz00_1367));
			}
		}
	}



/* _%socket-init! */
	obj_t BGl__z52socketzd2initz12z92zz__socketz00(obj_t BgL_envz00_1811)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 178 */
			return BGl_z52socketzd2initz12z92zz__socketz00();
		}
	}



/* <anonymous:1874> */
	obj_t BGl_zc3anonymousza31874ze3z83zz__socketz00(obj_t BgL_envz00_1812,
		obj_t BgL_xz00_1813)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 184 */
			{
				obj_t BgL_xz00_777;

				BgL_xz00_777 = BgL_xz00_1813;
				socket_cleanup();
				BUNSPEC;
				return BgL_xz00_777;
			}
		}
	}



/* socket? */
	BGL_EXPORTED_DEF bool_t BGl_socketzf3zf3zz__socketz00(obj_t BgL_objz00_1)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 195 */
			return SOCKETP(BgL_objz00_1);
		}
	}



/* _socket? */
	obj_t BGl__socketzf3zf3zz__socketz00(obj_t BgL_envz00_1814,
		obj_t BgL_objz00_1815)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 195 */
			return BBOOL(SOCKETP(BgL_objz00_1815));
		}
	}



/* socket-server? */
	BGL_EXPORTED_DEF bool_t BGl_socketzd2serverzf3z21zz__socketz00(obj_t
		BgL_objz00_2)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 201 */
			return BGL_SOCKET_SERVERP(BgL_objz00_2);
		}
	}



/* _socket-server? */
	obj_t BGl__socketzd2serverzf3z21zz__socketz00(obj_t BgL_envz00_1816,
		obj_t BgL_objz00_1817)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 201 */
			return BBOOL(BGL_SOCKET_SERVERP(BgL_objz00_1817));
		}
	}



/* socket-client? */
	BGL_EXPORTED_DEF bool_t BGl_socketzd2clientzf3z21zz__socketz00(obj_t
		BgL_objz00_3)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 207 */
			return BGL_SOCKET_CLIENTP(BgL_objz00_3);
		}
	}



/* _socket-client? */
	obj_t BGl__socketzd2clientzf3z21zz__socketz00(obj_t BgL_envz00_1818,
		obj_t BgL_objz00_1819)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 207 */
			return BBOOL(BGL_SOCKET_CLIENTP(BgL_objz00_1819));
		}
	}



/* socket-hostname */
	BGL_EXPORTED_DEF obj_t BGl_socketzd2hostnamezd2zz__socketz00(obj_t
		BgL_socketz00_4)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 213 */
			return SOCKET_HOSTNAME(BgL_socketz00_4);
		}
	}



/* _socket-hostname */
	obj_t BGl__socketzd2hostnamezd2zz__socketz00(obj_t BgL_envz00_1820,
		obj_t BgL_socketz00_1821)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 213 */
			{	/* Llib/socket.scm 214 */
				obj_t BgL_socketz00_1906;

				if (SOCKETP(BgL_socketz00_1821))
					{	/* Llib/socket.scm 214 */
						BgL_socketz00_1906 = BgL_socketz00_1821;
					}
				else
					{	/* Llib/socket.scm 214 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string2276z00zz__socketz00, BGl_string2274z00zz__socketz00,
							BgL_socketz00_1821, BGl_string2277z00zz__socketz00,
							BINT(((long) 8747)));
						exit(-1);
					}
				return SOCKET_HOSTNAME(BgL_socketz00_1906);
			}
		}
	}



/* socket-host-address */
	BGL_EXPORTED_DEF obj_t BGl_socketzd2hostzd2addressz00zz__socketz00(obj_t
		BgL_socketz00_5)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 219 */
			return SOCKET_HOSTIP(BgL_socketz00_5);
		}
	}



/* _socket-host-address */
	obj_t BGl__socketzd2hostzd2addressz00zz__socketz00(obj_t BgL_envz00_1822,
		obj_t BgL_socketz00_1823)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 219 */
			{	/* Llib/socket.scm 220 */
				obj_t BgL_socketz00_1907;

				if (SOCKETP(BgL_socketz00_1823))
					{	/* Llib/socket.scm 220 */
						BgL_socketz00_1907 = BgL_socketz00_1823;
					}
				else
					{	/* Llib/socket.scm 220 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string2278z00zz__socketz00, BGl_string2274z00zz__socketz00,
							BgL_socketz00_1823, BGl_string2277z00zz__socketz00,
							BINT(((long) 9045)));
						exit(-1);
					}
				return SOCKET_HOSTIP(BgL_socketz00_1907);
			}
		}
	}



/* socket-local-address */
	BGL_EXPORTED_DEF obj_t BGl_socketzd2localzd2addressz00zz__socketz00(obj_t
		BgL_socketz00_6)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 225 */
			return socket_local_addr(BgL_socketz00_6);
		}
	}



/* _socket-local-address */
	obj_t BGl__socketzd2localzd2addressz00zz__socketz00(obj_t BgL_envz00_1824,
		obj_t BgL_socketz00_1825)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 225 */
			{	/* Llib/socket.scm 226 */
				obj_t BgL_socketz00_1908;

				if (SOCKETP(BgL_socketz00_1825))
					{	/* Llib/socket.scm 226 */
						BgL_socketz00_1908 = BgL_socketz00_1825;
					}
				else
					{	/* Llib/socket.scm 226 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string2279z00zz__socketz00, BGl_string2274z00zz__socketz00,
							BgL_socketz00_1825, BGl_string2277z00zz__socketz00,
							BINT(((long) 9350)));
						exit(-1);
					}
				return socket_local_addr(BgL_socketz00_1908);
			}
		}
	}



/* socket-down? */
	BGL_EXPORTED_DEF bool_t BGl_socketzd2downzf3z21zz__socketz00(obj_t
		BgL_socketz00_7)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 231 */
			return SOCKET_DOWNP(BgL_socketz00_7);
		}
	}



/* _socket-down? */
	obj_t BGl__socketzd2downzf3z21zz__socketz00(obj_t BgL_envz00_1826,
		obj_t BgL_socketz00_1827)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 231 */
			{	/* Llib/socket.scm 232 */
				bool_t BgL_auxz00_2002;

				{	/* Llib/socket.scm 232 */
					obj_t BgL_socketz00_1909;

					if (SOCKETP(BgL_socketz00_1827))
						{	/* Llib/socket.scm 232 */
							BgL_socketz00_1909 = BgL_socketz00_1827;
						}
					else
						{	/* Llib/socket.scm 232 */
							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
								(BGl_string2280z00zz__socketz00, BGl_string2274z00zz__socketz00,
								BgL_socketz00_1827, BGl_string2277z00zz__socketz00,
								BINT(((long) 9657)));
							exit(-1);
						}
					BgL_auxz00_2002 = SOCKET_DOWNP(BgL_socketz00_1909);
				}
				return BBOOL(BgL_auxz00_2002);
			}
		}
	}



/* socket-port-number */
	BGL_EXPORTED_DEF obj_t BGl_socketzd2portzd2numberz00zz__socketz00(obj_t
		BgL_socketz00_8)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 237 */
			return BINT(SOCKET_PORT(BgL_socketz00_8));
		}
	}



/* _socket-port-number */
	obj_t BGl__socketzd2portzd2numberz00zz__socketz00(obj_t BgL_envz00_1828,
		obj_t BgL_socketz00_1829)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 237 */
			{	/* Llib/socket.scm 238 */
				obj_t BgL_socketz00_1910;

				if (SOCKETP(BgL_socketz00_1829))
					{	/* Llib/socket.scm 238 */
						BgL_socketz00_1910 = BgL_socketz00_1829;
					}
				else
					{	/* Llib/socket.scm 238 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string2281z00zz__socketz00, BGl_string2274z00zz__socketz00,
							BgL_socketz00_1829, BGl_string2277z00zz__socketz00,
							BINT(((long) 9965)));
						exit(-1);
					}
				return BINT(SOCKET_PORT(BgL_socketz00_1910));
			}
		}
	}



/* socket-input */
	BGL_EXPORTED_DEF obj_t BGl_socketzd2inputzd2zz__socketz00(obj_t
		BgL_socketz00_9)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 243 */
			return SOCKET_INPUT(BgL_socketz00_9);
		}
	}



/* _socket-input */
	obj_t BGl__socketzd2inputzd2zz__socketz00(obj_t BgL_envz00_1830,
		obj_t BgL_socketz00_1831)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 243 */
			{	/* Llib/socket.scm 244 */
				obj_t BgL_socketz00_1911;

				if (SOCKETP(BgL_socketz00_1831))
					{	/* Llib/socket.scm 244 */
						BgL_socketz00_1911 = BgL_socketz00_1831;
					}
				else
					{	/* Llib/socket.scm 244 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string2282z00zz__socketz00, BGl_string2274z00zz__socketz00,
							BgL_socketz00_1831, BGl_string2277z00zz__socketz00,
							BINT(((long) 10267)));
						exit(-1);
					}
				return SOCKET_INPUT(BgL_socketz00_1911);
			}
		}
	}



/* socket-output */
	BGL_EXPORTED_DEF obj_t BGl_socketzd2outputzd2zz__socketz00(obj_t
		BgL_socketz00_10)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 249 */
			return SOCKET_OUTPUT(BgL_socketz00_10);
		}
	}



/* _socket-output */
	obj_t BGl__socketzd2outputzd2zz__socketz00(obj_t BgL_envz00_1832,
		obj_t BgL_socketz00_1833)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 249 */
			{	/* Llib/socket.scm 250 */
				obj_t BgL_socketz00_1912;

				if (SOCKETP(BgL_socketz00_1833))
					{	/* Llib/socket.scm 250 */
						BgL_socketz00_1912 = BgL_socketz00_1833;
					}
				else
					{	/* Llib/socket.scm 250 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string2283z00zz__socketz00, BGl_string2274z00zz__socketz00,
							BgL_socketz00_1833, BGl_string2277z00zz__socketz00,
							BINT(((long) 10564)));
						exit(-1);
					}
				return SOCKET_OUTPUT(BgL_socketz00_1912);
			}
		}
	}



/* _make-client-socket */
	obj_t BGl__makezd2clientzd2socketz00zz__socketz00(obj_t BgL_envz00_18,
		obj_t BgL_opt1811z00_17)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 255 */
			{	/* Llib/socket.scm 255 */
				int BgL_l1812z00_780;

				BgL_l1812z00_780 = VECTOR_LENGTH(BgL_opt1811z00_17);
				{	/* Llib/socket.scm 255 */
					obj_t BgL_g1820z00_784;

					obj_t BgL_g1821z00_785;

					BgL_g1820z00_784 = VECTOR_REF(BgL_opt1811z00_17, (int) (((long) 0)));
					BgL_g1821z00_785 = VECTOR_REF(BgL_opt1811z00_17, (int) (((long) 1)));
					{	/* Llib/socket.scm 255 */
						obj_t BgL_domainz00_786;

						BgL_domainz00_786 = BGl_symbol2284z00zz__socketz00;
						{	/* Llib/socket.scm 255 */
							obj_t BgL_inbufz00_787;

							BgL_inbufz00_787 = BTRUE;
							{	/* Llib/socket.scm 255 */
								obj_t BgL_outbufz00_788;

								BgL_outbufz00_788 = BTRUE;
								{	/* Llib/socket.scm 255 */
									obj_t BgL_timeoutz00_789;

									BgL_timeoutz00_789 = BINT(((long) 0));
									{	/* Llib/socket.scm 255 */

										{	/* Llib/socket.scm 255 */
											long BgL_index1816z00_790;

											{
												long BgL_iz00_1370;

												BgL_iz00_1370 = ((long) 2);
											BgL_search1813z00_1369:
												if ((BgL_iz00_1370 == (long) (BgL_l1812z00_780)))
													{	/* Llib/socket.scm 255 */
														BgL_index1816z00_790 = ((long) -1);
													}
												else
													{	/* Llib/socket.scm 255 */
														obj_t BgL_vz00_1372;

														BgL_vz00_1372 =
															VECTOR_REF(BgL_opt1811z00_17,
															(int) (BgL_iz00_1370));
														if (
															(BgL_vz00_1372 ==
																BGl_keyword2286z00zz__socketz00))
															{	/* Llib/socket.scm 255 */
																BgL_index1816z00_790 =
																	(BgL_iz00_1370 + ((long) 1));
															}
														else
															{
																long BgL_iz00_2047;

																BgL_iz00_2047 = (BgL_iz00_1370 + ((long) 2));
																BgL_iz00_1370 = BgL_iz00_2047;
																goto BgL_search1813z00_1369;
															}
													}
											}
											if ((BgL_index1816z00_790 >= ((long) 0)))
												{	/* Llib/socket.scm 255 */
													BgL_domainz00_786 =
														VECTOR_REF(BgL_opt1811z00_17,
														(int) (BgL_index1816z00_790));
												}
											else
												{	/* Llib/socket.scm 255 */
													BFALSE;
												}
										}
										{	/* Llib/socket.scm 255 */
											long BgL_index1817z00_792;

											{
												long BgL_iz00_1384;

												BgL_iz00_1384 = ((long) 2);
											BgL_search1813z00_1383:
												if ((BgL_iz00_1384 == (long) (BgL_l1812z00_780)))
													{	/* Llib/socket.scm 255 */
														BgL_index1817z00_792 = ((long) -1);
													}
												else
													{	/* Llib/socket.scm 255 */
														obj_t BgL_vz00_1386;

														BgL_vz00_1386 =
															VECTOR_REF(BgL_opt1811z00_17,
															(int) (BgL_iz00_1384));
														if (
															(BgL_vz00_1386 ==
																BGl_keyword2288z00zz__socketz00))
															{	/* Llib/socket.scm 255 */
																BgL_index1817z00_792 =
																	(BgL_iz00_1384 + ((long) 1));
															}
														else
															{
																long BgL_iz00_2061;

																BgL_iz00_2061 = (BgL_iz00_1384 + ((long) 2));
																BgL_iz00_1384 = BgL_iz00_2061;
																goto BgL_search1813z00_1383;
															}
													}
											}
											if ((BgL_index1817z00_792 >= ((long) 0)))
												{	/* Llib/socket.scm 255 */
													BgL_inbufz00_787 =
														VECTOR_REF(BgL_opt1811z00_17,
														(int) (BgL_index1817z00_792));
												}
											else
												{	/* Llib/socket.scm 255 */
													BFALSE;
												}
										}
										{	/* Llib/socket.scm 255 */
											long BgL_index1818z00_794;

											{
												long BgL_iz00_1398;

												BgL_iz00_1398 = ((long) 2);
											BgL_search1813z00_1397:
												if ((BgL_iz00_1398 == (long) (BgL_l1812z00_780)))
													{	/* Llib/socket.scm 255 */
														BgL_index1818z00_794 = ((long) -1);
													}
												else
													{	/* Llib/socket.scm 255 */
														obj_t BgL_vz00_1400;

														BgL_vz00_1400 =
															VECTOR_REF(BgL_opt1811z00_17,
															(int) (BgL_iz00_1398));
														if (
															(BgL_vz00_1400 ==
																BGl_keyword2290z00zz__socketz00))
															{	/* Llib/socket.scm 255 */
																BgL_index1818z00_794 =
																	(BgL_iz00_1398 + ((long) 1));
															}
														else
															{
																long BgL_iz00_2075;

																BgL_iz00_2075 = (BgL_iz00_1398 + ((long) 2));
																BgL_iz00_1398 = BgL_iz00_2075;
																goto BgL_search1813z00_1397;
															}
													}
											}
											if ((BgL_index1818z00_794 >= ((long) 0)))
												{	/* Llib/socket.scm 255 */
													BgL_outbufz00_788 =
														VECTOR_REF(BgL_opt1811z00_17,
														(int) (BgL_index1818z00_794));
												}
											else
												{	/* Llib/socket.scm 255 */
													BFALSE;
												}
										}
										{	/* Llib/socket.scm 255 */
											long BgL_index1819z00_796;

											{
												long BgL_iz00_1412;

												BgL_iz00_1412 = ((long) 2);
											BgL_search1813z00_1411:
												if ((BgL_iz00_1412 == (long) (BgL_l1812z00_780)))
													{	/* Llib/socket.scm 255 */
														BgL_index1819z00_796 = ((long) -1);
													}
												else
													{	/* Llib/socket.scm 255 */
														obj_t BgL_vz00_1414;

														BgL_vz00_1414 =
															VECTOR_REF(BgL_opt1811z00_17,
															(int) (BgL_iz00_1412));
														if (
															(BgL_vz00_1414 ==
																BGl_keyword2292z00zz__socketz00))
															{	/* Llib/socket.scm 255 */
																BgL_index1819z00_796 =
																	(BgL_iz00_1412 + ((long) 1));
															}
														else
															{
																long BgL_iz00_2089;

																BgL_iz00_2089 = (BgL_iz00_1412 + ((long) 2));
																BgL_iz00_1412 = BgL_iz00_2089;
																goto BgL_search1813z00_1411;
															}
													}
											}
											if ((BgL_index1819z00_796 >= ((long) 0)))
												{	/* Llib/socket.scm 255 */
													BgL_timeoutz00_789 =
														VECTOR_REF(BgL_opt1811z00_17,
														(int) (BgL_index1819z00_796));
												}
											else
												{	/* Llib/socket.scm 255 */
													BFALSE;
												}
										}
										{	/* Llib/socket.scm 255 */
											obj_t BgL_arg1879z00_798;

											obj_t BgL_arg1880z00_799;

											BgL_arg1879z00_798 =
												VECTOR_REF(BgL_opt1811z00_17, (int) (((long) 0)));
											BgL_arg1880z00_799 =
												VECTOR_REF(BgL_opt1811z00_17, (int) (((long) 1)));
											{	/* Llib/socket.scm 255 */
												obj_t BgL_domainz00_800;

												BgL_domainz00_800 = BgL_domainz00_786;
												{	/* Llib/socket.scm 255 */
													obj_t BgL_inbufz00_801;

													BgL_inbufz00_801 = BgL_inbufz00_787;
													{	/* Llib/socket.scm 255 */
														obj_t BgL_outbufz00_802;

														BgL_outbufz00_802 = BgL_outbufz00_788;
														{	/* Llib/socket.scm 255 */
															obj_t BgL_timeoutz00_803;

															BgL_timeoutz00_803 = BgL_timeoutz00_789;
															{	/* Llib/socket.scm 255 */
																obj_t BgL_res2215z00_1439;

																{	/* Llib/socket.scm 255 */
																	obj_t BgL_hostz00_1425;

																	int BgL_portz00_1426;

																	if (STRINGP(BgL_arg1879z00_798))
																		{	/* Llib/socket.scm 255 */
																			BgL_hostz00_1425 = BgL_arg1879z00_798;
																		}
																	else
																		{	/* Llib/socket.scm 255 */
																			BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
																				(BGl_string2294z00zz__socketz00,
																				BGl_string2295z00zz__socketz00,
																				BgL_arg1879z00_798,
																				BGl_string2277z00zz__socketz00,
																				BINT(((long) 10813)));
																			exit(-1);
																		}
																	{	/* Llib/socket.scm 255 */
																		obj_t BgL_auxz00_2104;

																		if (INTEGERP(BgL_arg1880z00_799))
																			{	/* Llib/socket.scm 255 */
																				BgL_auxz00_2104 = BgL_arg1880z00_799;
																			}
																		else
																			{	/* Llib/socket.scm 255 */
																				BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
																					(BGl_string2294z00zz__socketz00,
																					BGl_string2296z00zz__socketz00,
																					BgL_arg1880z00_799,
																					BGl_string2277z00zz__socketz00,
																					BINT(((long) 10813)));
																				exit(-1);
																			}
																		BgL_portz00_1426 = CINT(BgL_auxz00_2104);
																	}
																	BGl_z52socketzd2initz12z92zz__socketz00();
																	{	/* Llib/socket.scm 255 */
																		obj_t BgL_inbufz00_1431;

																		obj_t BgL_outbufz00_1432;

																		BgL_inbufz00_1431 =
																			BGl_getzd2portzd2bufferz00zz__r4_ports_6_10_1z00
																			(BGl_symbol2297z00zz__socketz00,
																			BgL_inbufz00_801, (int) (((long) 512)));
																		BgL_outbufz00_1432 =
																			BGl_getzd2portzd2bufferz00zz__r4_ports_6_10_1z00
																			(BGl_symbol2297z00zz__socketz00,
																			BgL_outbufz00_802, (int) (((long) 1024)));
																		if ((BgL_domainz00_800 ==
																				BGl_symbol2284z00zz__socketz00))
																			{	/* Llib/socket.scm 255 */
																				int BgL_auxz00_2118;

																				{	/* Llib/socket.scm 255 */
																					obj_t BgL_auxz00_2119;

																					if (INTEGERP(BgL_timeoutz00_803))
																						{	/* Llib/socket.scm 255 */
																							BgL_auxz00_2119 =
																								BgL_timeoutz00_803;
																						}
																					else
																						{	/* Llib/socket.scm 255 */
																							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
																								(BGl_string2294z00zz__socketz00,
																								BGl_string2296z00zz__socketz00,
																								BgL_timeoutz00_803,
																								BGl_string2277z00zz__socketz00,
																								BINT(((long) 10813)));
																							exit(-1);
																						}
																					BgL_auxz00_2118 =
																						CINT(BgL_auxz00_2119);
																				}
																				BgL_res2215z00_1439 =
																					bgl_make_client_socket
																					(BgL_hostz00_1425, BgL_portz00_1426,
																					BgL_auxz00_2118, BgL_inbufz00_1431,
																					BgL_outbufz00_1432);
																			}
																		else
																			{	/* Llib/socket.scm 255 */
																				bool_t BgL_testz00_2127;

																				{	/* Llib/socket.scm 255 */
																					bool_t BgL__ortest_1770z00_1436;

																					BgL__ortest_1770z00_1436 =
																						(BgL_domainz00_800 ==
																						BGl_symbol2299z00zz__socketz00);
																					if (BgL__ortest_1770z00_1436)
																						{	/* Llib/socket.scm 255 */
																							BgL_testz00_2127 =
																								BgL__ortest_1770z00_1436;
																						}
																					else
																						{	/* Llib/socket.scm 255 */
																							BgL_testz00_2127 =
																								(BgL_domainz00_800 ==
																								BGl_symbol2301z00zz__socketz00);
																						}
																				}
																				if (BgL_testz00_2127)
																					{	/* Llib/socket.scm 255 */
																						int BgL_auxz00_2131;

																						{	/* Llib/socket.scm 255 */
																							obj_t BgL_auxz00_2132;

																							if (INTEGERP(BgL_timeoutz00_803))
																								{	/* Llib/socket.scm 255 */
																									BgL_auxz00_2132 =
																										BgL_timeoutz00_803;
																								}
																							else
																								{	/* Llib/socket.scm 255 */
																									BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
																										(BGl_string2294z00zz__socketz00,
																										BGl_string2296z00zz__socketz00,
																										BgL_timeoutz00_803,
																										BGl_string2277z00zz__socketz00,
																										BINT(((long) 10813)));
																									exit(-1);
																								}
																							BgL_auxz00_2131 =
																								CINT(BgL_auxz00_2132);
																						}
																						BgL_res2215z00_1439 =
																							bgl_make_unix_socket
																							(BgL_hostz00_1425,
																							BgL_auxz00_2131,
																							BgL_inbufz00_1431,
																							BgL_outbufz00_1432);
																					}
																				else
																					{	/* Llib/socket.scm 255 */
																						obj_t BgL_aux2248z00_1875;

																						BgL_aux2248z00_1875 =
																							BGl_errorz00zz__errorz00
																							(BGl_symbol2297z00zz__socketz00,
																							BGl_string2303z00zz__socketz00,
																							BgL_domainz00_800);
																						if (SOCKETP(BgL_aux2248z00_1875))
																							{	/* Llib/socket.scm 255 */
																								BgL_res2215z00_1439 =
																									BgL_aux2248z00_1875;
																							}
																						else
																							{	/* Llib/socket.scm 255 */
																								BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
																									(BGl_string2294z00zz__socketz00,
																									BGl_string2274z00zz__socketz00,
																									BgL_aux2248z00_1875,
																									BGl_string2277z00zz__socketz00,
																									BINT(((long) 10813)));
																								exit(-1);
																}}}}}
																return BgL_res2215z00_1439;
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* make-client-socket */
	BGL_EXPORTED_DEF obj_t BGl_makezd2clientzd2socketz00zz__socketz00(obj_t
		BgL_hostz00_11, int BgL_portz00_12, obj_t BgL_domainz00_13,
		obj_t BgL_inbufz00_14, obj_t BgL_outbufz00_15, obj_t BgL_timeoutz00_16)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 255 */
			BGl_z52socketzd2initz12z92zz__socketz00();
			{	/* Llib/socket.scm 257 */
				obj_t BgL_inbufz00_1462;

				obj_t BgL_outbufz00_1463;

				BgL_inbufz00_1462 =
					BGl_getzd2portzd2bufferz00zz__r4_ports_6_10_1z00
					(BGl_symbol2297z00zz__socketz00, BgL_inbufz00_14,
					(int) (((long) 512)));
				BgL_outbufz00_1463 =
					BGl_getzd2portzd2bufferz00zz__r4_ports_6_10_1z00
					(BGl_symbol2297z00zz__socketz00, BgL_outbufz00_15,
					(int) (((long) 1024)));
				if ((BgL_domainz00_13 == BGl_symbol2284z00zz__socketz00))
					{	/* Llib/socket.scm 257 */
						return
							bgl_make_client_socket(BgL_hostz00_11, BgL_portz00_12,
							CINT(BgL_timeoutz00_16), BgL_inbufz00_1462, BgL_outbufz00_1463);
					}
				else
					{	/* Llib/socket.scm 257 */
						bool_t BgL_testz00_2155;

						{	/* Llib/socket.scm 257 */
							bool_t BgL__ortest_1770z00_1467;

							BgL__ortest_1770z00_1467 =
								(BgL_domainz00_13 == BGl_symbol2299z00zz__socketz00);
							if (BgL__ortest_1770z00_1467)
								{	/* Llib/socket.scm 257 */
									BgL_testz00_2155 = BgL__ortest_1770z00_1467;
								}
							else
								{	/* Llib/socket.scm 257 */
									BgL_testz00_2155 =
										(BgL_domainz00_13 == BGl_symbol2301z00zz__socketz00);
								}
						}
						if (BgL_testz00_2155)
							{	/* Llib/socket.scm 257 */
								return
									bgl_make_unix_socket(BgL_hostz00_11,
									CINT(BgL_timeoutz00_16), BgL_inbufz00_1462,
									BgL_outbufz00_1463);
							}
						else
							{	/* Llib/socket.scm 257 */
								return
									BGl_errorz00zz__errorz00(BGl_symbol2297z00zz__socketz00,
									BGl_string2303z00zz__socketz00, BgL_domainz00_13);
							}
					}
			}
		}
	}



/* make-server-socket */
	BGL_EXPORTED_DEF obj_t BGl_makezd2serverzd2socketz00zz__socketz00(obj_t
		BgL_portz00_19)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 272 */
			{	/* Llib/socket.scm 272 */
				obj_t BgL_dsssl1822z00_814;

				BgL_dsssl1822z00_814 = BgL_portz00_19;
				{	/* Llib/socket.scm 272 */
					obj_t BgL_portz00_815;

					{	/* Llib/socket.scm 272 */
						bool_t BgL_testz00_2162;

						if (NULLP(BgL_dsssl1822z00_814))
							{	/* Llib/socket.scm 272 */
								BgL_testz00_2162 = ((bool_t) 1);
							}
						else
							{	/* Llib/socket.scm 272 */
								BgL_testz00_2162 =
									CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00(CAR
										(BgL_dsssl1822z00_814), BGl_list2304z00zz__socketz00));
							}
						if (BgL_testz00_2162)
							{	/* Llib/socket.scm 272 */
								BgL_portz00_815 = BINT(((long) 0));
							}
						else
							{	/* Llib/socket.scm 272 */
								obj_t BgL_tmp1823z00_819;

								BgL_tmp1823z00_819 = CAR(BgL_dsssl1822z00_814);
								BgL_dsssl1822z00_814 = CDR(BgL_dsssl1822z00_814);
								BgL_portz00_815 = BgL_tmp1823z00_819;
							}
					}
					BGl_dssslzd2checkzd2keyzd2argsz12zc0zz__dssslz00(BgL_dsssl1822z00_814,
						BGl_list2309z00zz__socketz00);
					{	/* Llib/socket.scm 272 */
						obj_t BgL_namez00_816;

						BgL_namez00_816 =
							BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_dsssl1822z00_814,
							BGl_keyword2307z00zz__socketz00, BFALSE);
						{	/* Llib/socket.scm 274 */
							obj_t BgL_backlogz00_817;

							BgL_backlogz00_817 =
								BGl_dssslzd2getzd2keyzd2argzd2zz__dssslz00(BgL_dsssl1822z00_814,
								BGl_keyword2305z00zz__socketz00, BINT(((long) 5)));
							BGl_z52socketzd2initz12z92zz__socketz00();
							return
								bgl_make_server_socket(BgL_namez00_816,
								CINT(BgL_portz00_815), CINT(BgL_backlogz00_817));
						}
					}
				}
			}
		}
	}



/* _make-server-socket */
	obj_t BGl__makezd2serverzd2socketz00zz__socketz00(obj_t BgL_envz00_1834,
		obj_t BgL_portz00_1835)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 272 */
			return BGl_makezd2serverzd2socketz00zz__socketz00(BgL_portz00_1835);
		}
	}



/* _socket-accept */
	obj_t BGl__socketzd2acceptzd2zz__socketz00(obj_t BgL_envz00_25,
		obj_t BgL_opt1824z00_24)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 279 */
			{	/* Llib/socket.scm 279 */
				int BgL_l1825z00_823;

				BgL_l1825z00_823 = VECTOR_LENGTH(BgL_opt1824z00_24);
				{	/* Llib/socket.scm 279 */
					obj_t BgL_g1832z00_827;

					BgL_g1832z00_827 = VECTOR_REF(BgL_opt1824z00_24, (int) (((long) 0)));
					{	/* Llib/socket.scm 279 */
						obj_t BgL_errpz00_828;

						BgL_errpz00_828 = BTRUE;
						{	/* Llib/socket.scm 279 */
							obj_t BgL_inbufz00_829;

							BgL_inbufz00_829 = BTRUE;
							{	/* Llib/socket.scm 279 */
								obj_t BgL_outbufz00_830;

								BgL_outbufz00_830 = BTRUE;
								{	/* Llib/socket.scm 279 */

									{	/* Llib/socket.scm 279 */
										long BgL_index1829z00_831;

										{
											long BgL_iz00_1476;

											BgL_iz00_1476 = ((long) 1);
										BgL_search1826z00_1475:
											if ((BgL_iz00_1476 == (long) (BgL_l1825z00_823)))
												{	/* Llib/socket.scm 279 */
													BgL_index1829z00_831 = ((long) -1);
												}
											else
												{	/* Llib/socket.scm 279 */
													obj_t BgL_vz00_1478;

													BgL_vz00_1478 =
														VECTOR_REF(BgL_opt1824z00_24,
														(int) (BgL_iz00_1476));
													if (
														(BgL_vz00_1478 == BGl_keyword2310z00zz__socketz00))
														{	/* Llib/socket.scm 279 */
															BgL_index1829z00_831 =
																(BgL_iz00_1476 + ((long) 1));
														}
													else
														{
															long BgL_iz00_2191;

															BgL_iz00_2191 = (BgL_iz00_1476 + ((long) 2));
															BgL_iz00_1476 = BgL_iz00_2191;
															goto BgL_search1826z00_1475;
														}
												}
										}
										if ((BgL_index1829z00_831 >= ((long) 0)))
											{	/* Llib/socket.scm 279 */
												BgL_errpz00_828 =
													VECTOR_REF(BgL_opt1824z00_24,
													(int) (BgL_index1829z00_831));
											}
										else
											{	/* Llib/socket.scm 279 */
												BFALSE;
											}
									}
									{	/* Llib/socket.scm 279 */
										long BgL_index1830z00_833;

										{
											long BgL_iz00_1490;

											BgL_iz00_1490 = ((long) 1);
										BgL_search1826z00_1489:
											if ((BgL_iz00_1490 == (long) (BgL_l1825z00_823)))
												{	/* Llib/socket.scm 279 */
													BgL_index1830z00_833 = ((long) -1);
												}
											else
												{	/* Llib/socket.scm 279 */
													obj_t BgL_vz00_1492;

													BgL_vz00_1492 =
														VECTOR_REF(BgL_opt1824z00_24,
														(int) (BgL_iz00_1490));
													if (
														(BgL_vz00_1492 == BGl_keyword2288z00zz__socketz00))
														{	/* Llib/socket.scm 279 */
															BgL_index1830z00_833 =
																(BgL_iz00_1490 + ((long) 1));
														}
													else
														{
															long BgL_iz00_2205;

															BgL_iz00_2205 = (BgL_iz00_1490 + ((long) 2));
															BgL_iz00_1490 = BgL_iz00_2205;
															goto BgL_search1826z00_1489;
														}
												}
										}
										if ((BgL_index1830z00_833 >= ((long) 0)))
											{	/* Llib/socket.scm 279 */
												BgL_inbufz00_829 =
													VECTOR_REF(BgL_opt1824z00_24,
													(int) (BgL_index1830z00_833));
											}
										else
											{	/* Llib/socket.scm 279 */
												BFALSE;
											}
									}
									{	/* Llib/socket.scm 279 */
										long BgL_index1831z00_835;

										{
											long BgL_iz00_1504;

											BgL_iz00_1504 = ((long) 1);
										BgL_search1826z00_1503:
											if ((BgL_iz00_1504 == (long) (BgL_l1825z00_823)))
												{	/* Llib/socket.scm 279 */
													BgL_index1831z00_835 = ((long) -1);
												}
											else
												{	/* Llib/socket.scm 279 */
													obj_t BgL_vz00_1506;

													BgL_vz00_1506 =
														VECTOR_REF(BgL_opt1824z00_24,
														(int) (BgL_iz00_1504));
													if (
														(BgL_vz00_1506 == BGl_keyword2290z00zz__socketz00))
														{	/* Llib/socket.scm 279 */
															BgL_index1831z00_835 =
																(BgL_iz00_1504 + ((long) 1));
														}
													else
														{
															long BgL_iz00_2219;

															BgL_iz00_2219 = (BgL_iz00_1504 + ((long) 2));
															BgL_iz00_1504 = BgL_iz00_2219;
															goto BgL_search1826z00_1503;
														}
												}
										}
										if ((BgL_index1831z00_835 >= ((long) 0)))
											{	/* Llib/socket.scm 279 */
												BgL_outbufz00_830 =
													VECTOR_REF(BgL_opt1824z00_24,
													(int) (BgL_index1831z00_835));
											}
										else
											{	/* Llib/socket.scm 279 */
												BFALSE;
											}
									}
									{	/* Llib/socket.scm 279 */
										obj_t BgL_arg1894z00_837;

										BgL_arg1894z00_837 =
											VECTOR_REF(BgL_opt1824z00_24, (int) (((long) 0)));
										{	/* Llib/socket.scm 279 */
											obj_t BgL_errpz00_838;

											BgL_errpz00_838 = BgL_errpz00_828;
											{	/* Llib/socket.scm 279 */
												obj_t BgL_inbufz00_839;

												BgL_inbufz00_839 = BgL_inbufz00_829;
												{	/* Llib/socket.scm 279 */
													obj_t BgL_outbufz00_840;

													BgL_outbufz00_840 = BgL_outbufz00_830;
													{	/* Llib/socket.scm 279 */
														obj_t BgL_socketz00_1517;

														if (SOCKETP(BgL_arg1894z00_837))
															{	/* Llib/socket.scm 279 */
																BgL_socketz00_1517 = BgL_arg1894z00_837;
															}
														else
															{	/* Llib/socket.scm 279 */
																BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
																	(BGl_string2312z00zz__socketz00,
																	BGl_string2274z00zz__socketz00,
																	BgL_arg1894z00_837,
																	BGl_string2277z00zz__socketz00,
																	BINT(((long) 11982)));
																exit(-1);
															}
														return
															bgl_socket_accept(BgL_socketz00_1517,
															CBOOL(BgL_errpz00_838),
															BGl_getzd2portzd2bufferz00zz__r4_ports_6_10_1z00
															(BGl_symbol2313z00zz__socketz00, BgL_inbufz00_839,
																(int) (((long) 512))),
															BGl_getzd2portzd2bufferz00zz__r4_ports_6_10_1z00
															(BGl_symbol2313z00zz__socketz00,
																BgL_outbufz00_840, (int) (((long) 1024))));
		}}}}}}}}}}}}
	}



/* socket-accept */
	BGL_EXPORTED_DEF obj_t BGl_socketzd2acceptzd2zz__socketz00(obj_t
		BgL_socketz00_20, obj_t BgL_errpz00_21, obj_t BgL_inbufz00_22,
		obj_t BgL_outbufz00_23)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 279 */
			return
				bgl_socket_accept(BgL_socketz00_20,
				CBOOL(BgL_errpz00_21),
				BGl_getzd2portzd2bufferz00zz__r4_ports_6_10_1z00
				(BGl_symbol2313z00zz__socketz00, BgL_inbufz00_22, (int) (((long) 512))),
				BGl_getzd2portzd2bufferz00zz__r4_ports_6_10_1z00
				(BGl_symbol2313z00zz__socketz00, BgL_outbufz00_23,
					(int) (((long) 1024))));
		}
	}



/* _socket-accept-many */
	obj_t BGl__socketzd2acceptzd2manyz00zz__socketz00(obj_t BgL_envz00_32,
		obj_t BgL_opt1833z00_31)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 290 */
			{	/* Llib/socket.scm 290 */
				int BgL_l1834z00_847;

				BgL_l1834z00_847 = VECTOR_LENGTH(BgL_opt1833z00_31);
				{	/* Llib/socket.scm 290 */
					obj_t BgL_g1841z00_851;

					obj_t BgL_g1842z00_852;

					BgL_g1841z00_851 = VECTOR_REF(BgL_opt1833z00_31, (int) (((long) 0)));
					BgL_g1842z00_852 = VECTOR_REF(BgL_opt1833z00_31, (int) (((long) 1)));
					{	/* Llib/socket.scm 290 */
						obj_t BgL_errpz00_853;

						BgL_errpz00_853 = BTRUE;
						{	/* Llib/socket.scm 290 */
							obj_t BgL_inbufsz00_854;

							BgL_inbufsz00_854 = BTRUE;
							{	/* Llib/socket.scm 290 */
								obj_t BgL_outbufsz00_855;

								BgL_outbufsz00_855 = BTRUE;
								{	/* Llib/socket.scm 290 */

									{	/* Llib/socket.scm 290 */
										long BgL_index1838z00_856;

										{
											long BgL_iz00_1549;

											BgL_iz00_1549 = ((long) 2);
										BgL_search1835z00_1548:
											if ((BgL_iz00_1549 == (long) (BgL_l1834z00_847)))
												{	/* Llib/socket.scm 290 */
													BgL_index1838z00_856 = ((long) -1);
												}
											else
												{	/* Llib/socket.scm 290 */
													obj_t BgL_vz00_1551;

													BgL_vz00_1551 =
														VECTOR_REF(BgL_opt1833z00_31,
														(int) (BgL_iz00_1549));
													if (
														(BgL_vz00_1551 == BGl_keyword2310z00zz__socketz00))
														{	/* Llib/socket.scm 290 */
															BgL_index1838z00_856 =
																(BgL_iz00_1549 + ((long) 1));
														}
													else
														{
															long BgL_iz00_2257;

															BgL_iz00_2257 = (BgL_iz00_1549 + ((long) 2));
															BgL_iz00_1549 = BgL_iz00_2257;
															goto BgL_search1835z00_1548;
														}
												}
										}
										if ((BgL_index1838z00_856 >= ((long) 0)))
											{	/* Llib/socket.scm 290 */
												BgL_errpz00_853 =
													VECTOR_REF(BgL_opt1833z00_31,
													(int) (BgL_index1838z00_856));
											}
										else
											{	/* Llib/socket.scm 290 */
												BFALSE;
											}
									}
									{	/* Llib/socket.scm 290 */
										long BgL_index1839z00_858;

										{
											long BgL_iz00_1563;

											BgL_iz00_1563 = ((long) 2);
										BgL_search1835z00_1562:
											if ((BgL_iz00_1563 == (long) (BgL_l1834z00_847)))
												{	/* Llib/socket.scm 290 */
													BgL_index1839z00_858 = ((long) -1);
												}
											else
												{	/* Llib/socket.scm 290 */
													obj_t BgL_vz00_1565;

													BgL_vz00_1565 =
														VECTOR_REF(BgL_opt1833z00_31,
														(int) (BgL_iz00_1563));
													if (
														(BgL_vz00_1565 == BGl_keyword2315z00zz__socketz00))
														{	/* Llib/socket.scm 290 */
															BgL_index1839z00_858 =
																(BgL_iz00_1563 + ((long) 1));
														}
													else
														{
															long BgL_iz00_2271;

															BgL_iz00_2271 = (BgL_iz00_1563 + ((long) 2));
															BgL_iz00_1563 = BgL_iz00_2271;
															goto BgL_search1835z00_1562;
														}
												}
										}
										if ((BgL_index1839z00_858 >= ((long) 0)))
											{	/* Llib/socket.scm 290 */
												BgL_inbufsz00_854 =
													VECTOR_REF(BgL_opt1833z00_31,
													(int) (BgL_index1839z00_858));
											}
										else
											{	/* Llib/socket.scm 290 */
												BFALSE;
											}
									}
									{	/* Llib/socket.scm 290 */
										long BgL_index1840z00_860;

										{
											long BgL_iz00_1577;

											BgL_iz00_1577 = ((long) 2);
										BgL_search1835z00_1576:
											if ((BgL_iz00_1577 == (long) (BgL_l1834z00_847)))
												{	/* Llib/socket.scm 290 */
													BgL_index1840z00_860 = ((long) -1);
												}
											else
												{	/* Llib/socket.scm 290 */
													obj_t BgL_vz00_1579;

													BgL_vz00_1579 =
														VECTOR_REF(BgL_opt1833z00_31,
														(int) (BgL_iz00_1577));
													if (
														(BgL_vz00_1579 == BGl_keyword2317z00zz__socketz00))
														{	/* Llib/socket.scm 290 */
															BgL_index1840z00_860 =
																(BgL_iz00_1577 + ((long) 1));
														}
													else
														{
															long BgL_iz00_2285;

															BgL_iz00_2285 = (BgL_iz00_1577 + ((long) 2));
															BgL_iz00_1577 = BgL_iz00_2285;
															goto BgL_search1835z00_1576;
														}
												}
										}
										if ((BgL_index1840z00_860 >= ((long) 0)))
											{	/* Llib/socket.scm 290 */
												BgL_outbufsz00_855 =
													VECTOR_REF(BgL_opt1833z00_31,
													(int) (BgL_index1840z00_860));
											}
										else
											{	/* Llib/socket.scm 290 */
												BFALSE;
											}
									}
									{	/* Llib/socket.scm 290 */
										obj_t BgL_arg1901z00_862;

										obj_t BgL_arg1902z00_863;

										BgL_arg1901z00_862 =
											VECTOR_REF(BgL_opt1833z00_31, (int) (((long) 0)));
										BgL_arg1902z00_863 =
											VECTOR_REF(BgL_opt1833z00_31, (int) (((long) 1)));
										{	/* Llib/socket.scm 290 */
											obj_t BgL_errpz00_864;

											BgL_errpz00_864 = BgL_errpz00_853;
											{	/* Llib/socket.scm 290 */
												obj_t BgL_inbufsz00_865;

												BgL_inbufsz00_865 = BgL_inbufsz00_854;
												{	/* Llib/socket.scm 290 */
													obj_t BgL_outbufsz00_866;

													BgL_outbufsz00_866 = BgL_outbufsz00_855;
													{	/* Llib/socket.scm 290 */
														obj_t BgL_auxz00_2301;

														obj_t BgL_auxz00_2295;

														if (VECTORP(BgL_arg1902z00_863))
															{	/* Llib/socket.scm 290 */
																BgL_auxz00_2301 = BgL_arg1902z00_863;
															}
														else
															{	/* Llib/socket.scm 290 */
																BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
																	(BGl_string2319z00zz__socketz00,
																	BGl_string2320z00zz__socketz00,
																	BgL_arg1902z00_863,
																	BGl_string2277z00zz__socketz00,
																	BINT(((long) 12672)));
																exit(-1);
															}
														if (SOCKETP(BgL_arg1901z00_862))
															{	/* Llib/socket.scm 290 */
																BgL_auxz00_2295 = BgL_arg1901z00_862;
															}
														else
															{	/* Llib/socket.scm 290 */
																BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
																	(BGl_string2319z00zz__socketz00,
																	BGl_string2274z00zz__socketz00,
																	BgL_arg1901z00_862,
																	BGl_string2277z00zz__socketz00,
																	BINT(((long) 12672)));
																exit(-1);
															}
														return
															BGl_socketzd2acceptzd2manyz00zz__socketz00
															(BgL_auxz00_2295, BgL_auxz00_2301,
															BgL_errpz00_864, BgL_inbufsz00_865,
															BgL_outbufsz00_866);
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* socket-accept-many */
	BGL_EXPORTED_DEF obj_t BGl_socketzd2acceptzd2manyz00zz__socketz00(obj_t
		BgL_socketz00_26, obj_t BgL_resultz00_27, obj_t BgL_errpz00_28,
		obj_t BgL_inbufsz00_29, obj_t BgL_outbufsz00_30)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 290 */
			if (VECTORP(BgL_inbufsz00_29))
				{	/* Llib/socket.scm 291 */
					((bool_t) 0);
				}
			else
				{	/* Llib/socket.scm 291 */
					{	/* Llib/socket.scm 292 */
						int BgL_arg1908z00_872;

						BgL_arg1908z00_872 = VECTOR_LENGTH(BgL_resultz00_27);
						BgL_inbufsz00_29 = make_vector(BgL_arg1908z00_872, BUNSPEC);
					}
					{
						long BgL_iz00_875;

						BgL_iz00_875 = ((long) 0);
					BgL_zc3anonymousza31910ze3z83_876:
						{	/* Llib/socket.scm 294 */
							bool_t BgL_testz00_2312;

							{	/* Llib/socket.scm 294 */
								int BgL_arg1913z00_880;

								BgL_arg1913z00_880 = VECTOR_LENGTH(BgL_resultz00_27);
								BgL_testz00_2312 = (BgL_iz00_875 < (long) (BgL_arg1913z00_880));
							}
							if (BgL_testz00_2312)
								{	/* Llib/socket.scm 295 */
									obj_t BgL_bufz00_878;

									BgL_bufz00_878 =
										BGl_getzd2portzd2bufferz00zz__r4_ports_6_10_1z00
										(BGl_symbol2321z00zz__socketz00, BTRUE,
										(int) (((long) 512)));
									VECTOR_SET(BgL_inbufsz00_29, (int) (BgL_iz00_875),
										BgL_bufz00_878);
									{
										long BgL_iz00_2320;

										BgL_iz00_2320 = (BgL_iz00_875 + ((long) 1));
										BgL_iz00_875 = BgL_iz00_2320;
										goto BgL_zc3anonymousza31910ze3z83_876;
									}
								}
							else
								{	/* Llib/socket.scm 294 */
									((bool_t) 0);
								}
						}
					}
				}
			if (VECTORP(BgL_outbufsz00_30))
				{	/* Llib/socket.scm 298 */
					((bool_t) 0);
				}
			else
				{	/* Llib/socket.scm 298 */
					{	/* Llib/socket.scm 299 */
						int BgL_arg1915z00_883;

						BgL_arg1915z00_883 = VECTOR_LENGTH(BgL_resultz00_27);
						BgL_outbufsz00_30 = make_vector(BgL_arg1915z00_883, BUNSPEC);
					}
					{
						long BgL_iz00_886;

						BgL_iz00_886 = ((long) 0);
					BgL_zc3anonymousza31917ze3z83_887:
						{	/* Llib/socket.scm 301 */
							bool_t BgL_testz00_2326;

							{	/* Llib/socket.scm 301 */
								int BgL_arg1920z00_891;

								BgL_arg1920z00_891 = VECTOR_LENGTH(BgL_resultz00_27);
								BgL_testz00_2326 = (BgL_iz00_886 < (long) (BgL_arg1920z00_891));
							}
							if (BgL_testz00_2326)
								{	/* Llib/socket.scm 302 */
									obj_t BgL_bufz00_889;

									BgL_bufz00_889 =
										BGl_getzd2portzd2bufferz00zz__r4_ports_6_10_1z00
										(BGl_symbol2321z00zz__socketz00, BTRUE,
										(int) (((long) 512)));
									VECTOR_SET(BgL_outbufsz00_30, (int) (BgL_iz00_886),
										BgL_bufz00_889);
									{
										long BgL_iz00_2334;

										BgL_iz00_2334 = (BgL_iz00_886 + ((long) 1));
										BgL_iz00_886 = BgL_iz00_2334;
										goto BgL_zc3anonymousza31917ze3z83_887;
									}
								}
							else
								{	/* Llib/socket.scm 301 */
									((bool_t) 0);
								}
						}
					}
				}
			return
				BINT(bgl_socket_accept_many(BgL_socketz00_26,
					CBOOL(BgL_errpz00_28), BgL_inbufsz00_29, BgL_outbufsz00_30,
					BgL_resultz00_27));
		}
	}



/* _socket-shutdown */
	obj_t BGl__socketzd2shutdownzd2zz__socketz00(obj_t BgL_envz00_36,
		obj_t BgL_optz00_35)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 318 */
			{	/* Llib/socket.scm 318 */
				obj_t BgL_g1843z00_1913;

				BgL_g1843z00_1913 = VECTOR_REF(BgL_optz00_35, (int) (((long) 0)));
				{	/* Llib/socket.scm 318 */
					int BgL_aux1845z00_1914;

					BgL_aux1845z00_1914 = VECTOR_LENGTH(BgL_optz00_35);
					switch ((long) (BgL_aux1845z00_1914))
						{
						case ((long) 1):

							{	/* Llib/socket.scm 318 */

								{	/* Llib/socket.scm 318 */
									obj_t BgL_arg1922z00_1915;

									BgL_arg1922z00_1915 =
										VECTOR_REF(BgL_optz00_35, (int) (((long) 0)));
									{	/* Llib/socket.scm 318 */
										obj_t BgL_socketz00_1916;

										if (SOCKETP(BgL_arg1922z00_1915))
											{	/* Llib/socket.scm 318 */
												BgL_socketz00_1916 = BgL_arg1922z00_1915;
											}
										else
											{	/* Llib/socket.scm 318 */
												BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
													(BGl_string2323z00zz__socketz00,
													BGl_string2274z00zz__socketz00, BgL_arg1922z00_1915,
													BGl_string2277z00zz__socketz00, BINT(((long) 13804)));
												exit(-1);
											}
										return socket_shutdown(BgL_socketz00_1916, CBOOL(BTRUE));
									}
								}
							}
							break;
						case ((long) 2):

							{	/* Llib/socket.scm 318 */
								obj_t BgL_closez00_1918;

								BgL_closez00_1918 =
									VECTOR_REF(BgL_optz00_35, (int) (((long) 1)));
								{	/* Llib/socket.scm 318 */

									{	/* Llib/socket.scm 318 */
										obj_t BgL_arg1923z00_1919;

										BgL_arg1923z00_1919 =
											VECTOR_REF(BgL_optz00_35, (int) (((long) 0)));
										{	/* Llib/socket.scm 318 */
											obj_t BgL_socketz00_1920;

											if (SOCKETP(BgL_arg1923z00_1919))
												{	/* Llib/socket.scm 318 */
													BgL_socketz00_1920 = BgL_arg1923z00_1919;
												}
											else
												{	/* Llib/socket.scm 318 */
													BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
														(BGl_string2323z00zz__socketz00,
														BGl_string2274z00zz__socketz00, BgL_arg1923z00_1919,
														BGl_string2277z00zz__socketz00,
														BINT(((long) 13804)));
													exit(-1);
												}
											return
												socket_shutdown(BgL_socketz00_1920,
												CBOOL(BgL_closez00_1918));
										}
									}
								}
							}
							break;
						default:
							return BUNSPEC;
						}
				}
			}
		}
	}



/* socket-shutdown */
	BGL_EXPORTED_DEF obj_t BGl_socketzd2shutdownzd2zz__socketz00(obj_t
		BgL_socketz00_33, obj_t BgL_closez00_34)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 318 */
			return socket_shutdown(BgL_socketz00_33, CBOOL(BgL_closez00_34));
		}
	}



/* socket-close */
	BGL_EXPORTED_DEF obj_t BGl_socketzd2closezd2zz__socketz00(obj_t
		BgL_socketz00_37)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 324 */
			return socket_close(BgL_socketz00_37);
		}
	}



/* _socket-close */
	obj_t BGl__socketzd2closezd2zz__socketz00(obj_t BgL_envz00_1836,
		obj_t BgL_socketz00_1837)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 324 */
			{	/* Llib/socket.scm 325 */
				obj_t BgL_socketz00_1921;

				if (SOCKETP(BgL_socketz00_1837))
					{	/* Llib/socket.scm 325 */
						BgL_socketz00_1921 = BgL_socketz00_1837;
					}
				else
					{	/* Llib/socket.scm 325 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string2324z00zz__socketz00, BGl_string2274z00zz__socketz00,
							BgL_socketz00_1837, BGl_string2277z00zz__socketz00,
							BINT(((long) 14182)));
						exit(-1);
					}
				return socket_close(BgL_socketz00_1921);
			}
		}
	}



/* host */
	BGL_EXPORTED_DEF obj_t BGl_hostz00zz__socketz00(obj_t BgL_hostnamez00_38)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 330 */
			BGl_z52socketzd2initz12z92zz__socketz00();
			return bgl_host(BgL_hostnamez00_38);
		}
	}



/* _host */
	obj_t BGl__hostz00zz__socketz00(obj_t BgL_envz00_1838,
		obj_t BgL_hostnamez00_1839)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 330 */
			{	/* Llib/socket.scm 333 */
				obj_t BgL_res2331z00_1923;

				{	/* Llib/socket.scm 333 */
					obj_t BgL_hostnamez00_1922;

					if (STRINGP(BgL_hostnamez00_1839))
						{	/* Llib/socket.scm 333 */
							BgL_hostnamez00_1922 = BgL_hostnamez00_1839;
						}
					else
						{	/* Llib/socket.scm 333 */
							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
								(BGl_string2325z00zz__socketz00, BGl_string2295z00zz__socketz00,
								BgL_hostnamez00_1839, BGl_string2277z00zz__socketz00,
								BINT(((long) 14515)));
							exit(-1);
						}
					BGl_z52socketzd2initz12z92zz__socketz00();
					BgL_res2331z00_1923 = bgl_host(BgL_hostnamez00_1922);
				}
				return BgL_res2331z00_1923;
			}
		}
	}



/* hostinfo */
	BGL_EXPORTED_DEF obj_t BGl_hostinfoz00zz__socketz00(obj_t BgL_hostnamez00_39)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 338 */
			BGl_z52socketzd2initz12z92zz__socketz00();
			return bgl_hostinfo(BgL_hostnamez00_39);
		}
	}



/* _hostinfo */
	obj_t BGl__hostinfoz00zz__socketz00(obj_t BgL_envz00_1840,
		obj_t BgL_hostnamez00_1841)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 338 */
			{	/* Llib/socket.scm 341 */
				obj_t BgL_res2332z00_1925;

				{	/* Llib/socket.scm 341 */
					obj_t BgL_hostnamez00_1924;

					if (STRINGP(BgL_hostnamez00_1841))
						{	/* Llib/socket.scm 341 */
							BgL_hostnamez00_1924 = BgL_hostnamez00_1841;
						}
					else
						{	/* Llib/socket.scm 341 */
							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
								(BGl_string2326z00zz__socketz00, BGl_string2295z00zz__socketz00,
								BgL_hostnamez00_1841, BGl_string2277z00zz__socketz00,
								BINT(((long) 14834)));
							exit(-1);
						}
					BGl_z52socketzd2initz12z92zz__socketz00();
					BgL_res2332z00_1925 = bgl_hostinfo(BgL_hostnamez00_1924);
				}
				return BgL_res2332z00_1925;
			}
		}
	}



/* hostname */
	BGL_EXPORTED_DEF obj_t BGl_hostnamez00zz__socketz00()
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 346 */
			BGl_z52socketzd2initz12z92zz__socketz00();
			return bgl_gethostname();
		}
	}



/* _hostname */
	obj_t BGl__hostnamez00zz__socketz00(obj_t BgL_envz00_1842)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 346 */
			{	/* Llib/socket.scm 349 */
				obj_t BgL_res2333z00_1926;

				BGl_z52socketzd2initz12z92zz__socketz00();
				BgL_res2333z00_1926 = bgl_gethostname();
				return BgL_res2333z00_1926;
			}
		}
	}



/* get-protocols */
	BGL_EXPORTED_DEF obj_t BGl_getzd2protocolszd2zz__socketz00()
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 354 */
			return bgl_getprotoents();
		}
	}



/* _get-protocols */
	obj_t BGl__getzd2protocolszd2zz__socketz00(obj_t BgL_envz00_1843)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 354 */
			return bgl_getprotoents();
		}
	}



/* get-protocol */
	BGL_EXPORTED_DEF obj_t BGl_getzd2protocolzd2zz__socketz00(obj_t
		BgL_protocolz00_40)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 360 */
			if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_protocolz00_40))
				{	/* Llib/socket.scm 362 */
					return bgl_getprotobynumber((long) CINT(BgL_protocolz00_40));
				}
			else
				{	/* Llib/socket.scm 362 */
					if (STRINGP(BgL_protocolz00_40))
						{	/* Llib/socket.scm 362 */
							return bgl_getprotobyname(BSTRING_TO_STRING(BgL_protocolz00_40));
						}
					else
						{	/* Llib/socket.scm 362 */
							return BFALSE;
						}
				}
		}
	}



/* _get-protocol */
	obj_t BGl__getzd2protocolzd2zz__socketz00(obj_t BgL_envz00_1844,
		obj_t BgL_protocolz00_1845)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 360 */
			return BGl_getzd2protocolzd2zz__socketz00(BgL_protocolz00_1845);
		}
	}



/* socket-option */
	BGL_EXPORTED_DEF obj_t BGl_socketzd2optionzd2zz__socketz00(obj_t
		BgL_socketz00_41, obj_t BgL_optionz00_42)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 372 */
			return bgl_getsockopt(BgL_socketz00_41, BgL_optionz00_42);
		}
	}



/* _socket-option */
	obj_t BGl__socketzd2optionzd2zz__socketz00(obj_t BgL_envz00_1846,
		obj_t BgL_socketz00_1847, obj_t BgL_optionz00_1848)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 372 */
			{	/* Llib/socket.scm 373 */
				obj_t BgL_socketz00_1927;

				obj_t BgL_optionz00_1928;

				if (SOCKETP(BgL_socketz00_1847))
					{	/* Llib/socket.scm 373 */
						BgL_socketz00_1927 = BgL_socketz00_1847;
					}
				else
					{	/* Llib/socket.scm 373 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string2327z00zz__socketz00, BGl_string2274z00zz__socketz00,
							BgL_socketz00_1847, BGl_string2277z00zz__socketz00,
							BINT(((long) 16101)));
						exit(-1);
					}
				if (KEYWORDP(BgL_optionz00_1848))
					{	/* Llib/socket.scm 373 */
						BgL_optionz00_1928 = BgL_optionz00_1848;
					}
				else
					{	/* Llib/socket.scm 373 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string2327z00zz__socketz00, BGl_string2328z00zz__socketz00,
							BgL_optionz00_1848, BGl_string2277z00zz__socketz00,
							BINT(((long) 16101)));
						exit(-1);
					}
				return bgl_getsockopt(BgL_socketz00_1927, BgL_optionz00_1928);
			}
		}
	}



/* socket-option-set! */
	BGL_EXPORTED_DEF obj_t BGl_socketzd2optionzd2setz12z12zz__socketz00(obj_t
		BgL_socketz00_43, obj_t BgL_optionz00_44, obj_t BgL_valz00_45)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 378 */
			return bgl_setsockopt(BgL_socketz00_43, BgL_optionz00_44, BgL_valz00_45);
		}
	}



/* _socket-option-set! */
	obj_t BGl__socketzd2optionzd2setz12z12zz__socketz00(obj_t BgL_envz00_1849,
		obj_t BgL_socketz00_1850, obj_t BgL_optionz00_1851, obj_t BgL_valz00_1852)
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 378 */
			{	/* Llib/socket.scm 379 */
				obj_t BgL_socketz00_1929;

				obj_t BgL_optionz00_1930;

				if (SOCKETP(BgL_socketz00_1850))
					{	/* Llib/socket.scm 379 */
						BgL_socketz00_1929 = BgL_socketz00_1850;
					}
				else
					{	/* Llib/socket.scm 379 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string2329z00zz__socketz00, BGl_string2274z00zz__socketz00,
							BgL_socketz00_1850, BGl_string2277z00zz__socketz00,
							BINT(((long) 16410)));
						exit(-1);
					}
				if (KEYWORDP(BgL_optionz00_1851))
					{	/* Llib/socket.scm 379 */
						BgL_optionz00_1930 = BgL_optionz00_1851;
					}
				else
					{	/* Llib/socket.scm 379 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string2329z00zz__socketz00, BGl_string2328z00zz__socketz00,
							BgL_optionz00_1851, BGl_string2277z00zz__socketz00,
							BINT(((long) 16410)));
						exit(-1);
					}
				return
					bgl_setsockopt(BgL_socketz00_1929, BgL_optionz00_1930,
					BgL_valz00_1852);
			}
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zz__socketz00()
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 14 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zz__socketz00()
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 14 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zz__socketz00()
	{
		AN_OBJECT;
		{	/* Llib/socket.scm 14 */
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 68033950),
				BSTRING_TO_STRING(BGl_string2330z00zz__socketz00));
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 429190545),
				BSTRING_TO_STRING(BGl_string2330z00zz__socketz00));
			return
				BGl_modulezd2initializa7ationz75zz__threadz00(((long) 500588328),
				BSTRING_TO_STRING(BGl_string2330z00zz__socketz00));
		}
	}

#ifdef __cplusplus
}
#endif
