/*===========================================================================*/
/*   (Llib/tvector.scm)                                                      */
/*   Bigloo (3.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jul 1 12:14:45 CEST 2010        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -srfi enable-gmp -srfi bigloo-safe -O3 -q +rm -lib-dir /users/serrano/prgm/project/bigloo/lib/3.4a -O3 -mklib -cc gcc -fsharing -q -unsafev -eval (set! *indent* 4) -copt -fPIC -c Llib/tvector.scm -indent -o objs/obj_s/Llib/tvector.c)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif
static obj_t BGl__tvectorzd2ze3vectorz31zz__tvectorz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_tvectorzd2refzd2zz__tvectorz00(obj_t);
static obj_t BGl__listzd2ze3tvectorz31zz__tvectorz00(obj_t, obj_t, obj_t);
extern obj_t bstring_to_symbol(obj_t);
BGL_EXPORTED_DECL obj_t BGl_declarezd2tvectorz12zc0zz__tvectorz00(char *, obj_t, obj_t, obj_t);
static obj_t BGl_list2367z00zz__tvectorz00 = BUNSPEC;
static obj_t BGl_requirezd2initializa7ationz75zz__tvectorz00 = BUNSPEC;
static obj_t BGl_list2377z00zz__tvectorz00 = BUNSPEC;
static obj_t BGl_list2401z00zz__tvectorz00 = BUNSPEC;
static obj_t BGl_list2395z00zz__tvectorz00 = BUNSPEC;
BGL_EXPORTED_DECL obj_t BGl_vectorzd2ze3tvectorz31zz__tvectorz00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__tvectorz00();
static obj_t BGl__tvectorzf3zf3zz__tvectorz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_listzd2ze3tvectorz31zz__tvectorz00(obj_t, obj_t);
extern obj_t create_struct(obj_t, int);
static obj_t BGl__tvectorzd2lengthzd2zz__tvectorz00(obj_t, obj_t);
extern obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl__tvectorzd2idzd2zz__tvectorz00(obj_t, obj_t);
static obj_t BGl__vectorzd2ze3tvectorz31zz__tvectorz00(obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__tvectorz00();
static obj_t BGl_za2tvectorzd2tableza2zd2zz__tvectorz00 = BUNSPEC;
static obj_t BGl__tvectorzd2refzd2zz__tvectorz00(obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__tvectorz00();
extern obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
extern obj_t BGl_stringzd2upcasezd2zz__r4_strings_6_7z00(obj_t);
static obj_t BGl__getzd2tvectorzd2descriptorz00zz__tvectorz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t get_tvector_descriptor(obj_t);
BGL_EXPORTED_DECL int BGl_tvectorzd2lengthzd2zz__tvectorz00(obj_t);
extern obj_t string_append_3(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__hashz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
static obj_t BGl_symbol2347z00zz__tvectorz00 = BUNSPEC;
static obj_t BGl_symbol2354z00zz__tvectorz00 = BUNSPEC;
static obj_t BGl_toplevelzd2initzd2zz__tvectorz00();
static obj_t BGl_symbol2356z00zz__tvectorz00 = BUNSPEC;
static obj_t BGl_symbol2368z00zz__tvectorz00 = BUNSPEC;
static obj_t BGl_symbol2370z00zz__tvectorz00 = BUNSPEC;
extern long bgl_list_length(obj_t);
static obj_t BGl_symbol2372z00zz__tvectorz00 = BUNSPEC;
static obj_t BGl_symbol2378z00zz__tvectorz00 = BUNSPEC;
static obj_t BGl_symbol2380z00zz__tvectorz00 = BUNSPEC;
static obj_t BGl_symbol2382z00zz__tvectorz00 = BUNSPEC;
static obj_t BGl_symbol2384z00zz__tvectorz00 = BUNSPEC;
static obj_t BGl__declarezd2tvectorz12zc0zz__tvectorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_symbol2391z00zz__tvectorz00 = BUNSPEC;
static obj_t BGl_symbol2402z00zz__tvectorz00 = BUNSPEC;
static obj_t BGl_symbol2404z00zz__tvectorz00 = BUNSPEC;
static obj_t BGl_symbol2406z00zz__tvectorz00 = BUNSPEC;
static obj_t BGl_symbol2396z00zz__tvectorz00 = BUNSPEC;
extern obj_t string_to_symbol(char *);
BGL_EXPORTED_DECL obj_t BGl_tvectorzd2idzd2zz__tvectorz00(obj_t);
extern obj_t string_to_bstring(char *);
extern obj_t BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(long, long);
extern obj_t BGl_bigloozd2casezd2sensitivityz00zz__readerz00();
BGL_EXPORTED_DECL obj_t BGl_tvectorzd2ze3vectorz31zz__tvectorz00(obj_t);
extern obj_t BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL bool_t BGl_tvectorzf3zf3zz__tvectorz00(obj_t);
extern obj_t BGl_stringzd2downcasezd2zz__r4_strings_6_7z00(obj_t);
static obj_t BGl_methodzd2initzd2zz__tvectorz00();
static obj_t *__cnst;


DEFINE_STRING( BGl_string2365z00zz__tvectorz00, BgL_bgl_string2365za700za7za7_2412za7, "list->tvector", 13 );
DEFINE_STRING( BGl_string2366z00zz__tvectorz00, BgL_bgl_string2366za700za7za7_2413za7, "list->tvector:Wrong number of arguments", 39 );
DEFINE_STRING( BGl_string2369z00zz__tvectorz00, BgL_bgl_string2369za700za7za7_2414za7, "funcall", 7 );
DEFINE_STRING( BGl_string2371z00zz__tvectorz00, BgL_bgl_string2371za700za7za7_2415za7, "allocate", 8 );
DEFINE_STRING( BGl_string2373z00zz__tvectorz00, BgL_bgl_string2373za700za7za7_2416za7, "len", 3 );
DEFINE_STRING( BGl_string2374z00zz__tvectorz00, BgL_bgl_string2374za700za7za7_2417za7, "loop", 4 );
DEFINE_STRING( BGl_string2375z00zz__tvectorz00, BgL_bgl_string2375za700za7za7_2418za7, "pair", 4 );
DEFINE_STRING( BGl_string2376z00zz__tvectorz00, BgL_bgl_string2376za700za7za7_2419za7, "loop:Wrong number of arguments", 30 );
DEFINE_STRING( BGl_string2379z00zz__tvectorz00, BgL_bgl_string2379za700za7za7_2420za7, "set", 3 );
DEFINE_STRING( BGl_string2381z00zz__tvectorz00, BgL_bgl_string2381za700za7za7_2421za7, "tvec", 4 );
DEFINE_STRING( BGl_string2383z00zz__tvectorz00, BgL_bgl_string2383za700za7za7_2422za7, "i", 1 );
DEFINE_STRING( BGl_string2385z00zz__tvectorz00, BgL_bgl_string2385za700za7za7_2423za7, "arg1874", 7 );
DEFINE_STRING( BGl_string2386z00zz__tvectorz00, BgL_bgl_string2386za700za7za7_2424za7, "Unable to convert to such tvector", 33 );
DEFINE_STRING( BGl_string2387z00zz__tvectorz00, BgL_bgl_string2387za700za7za7_2425za7, "Undeclared tvector", 18 );
DEFINE_STRING( BGl_string2388z00zz__tvectorz00, BgL_bgl_string2388za700za7za7_2426za7, "_list->tvector", 14 );
DEFINE_STRING( BGl_string2400z00zz__tvectorz00, BgL_bgl_string2400za700za7za7_2427za7, "tvector->vector", 15 );
DEFINE_STRING( BGl_string2390z00zz__tvectorz00, BgL_bgl_string2390za700za7za7_2428za7, "vector->tvector:Wrong number of arguments", 41 );
DEFINE_STRING( BGl_string2389z00zz__tvectorz00, BgL_bgl_string2389za700za7za7_2429za7, "vector->tvector", 15 );
DEFINE_STRING( BGl_string2392z00zz__tvectorz00, BgL_bgl_string2392za700za7za7_2430za7, "vector-ref", 10 );
DEFINE_STRING( BGl_string2403z00zz__tvectorz00, BgL_bgl_string2403za700za7za7_2431za7, "ref", 3 );
DEFINE_STRING( BGl_string2393z00zz__tvectorz00, BgL_bgl_string2393za700za7za7_2432za7, "index out of range [0..", 23 );
DEFINE_STRING( BGl_string2394z00zz__tvectorz00, BgL_bgl_string2394za700za7za7_2433za7, "]", 1 );
DEFINE_STRING( BGl_string2405z00zz__tvectorz00, BgL_bgl_string2405za700za7za7_2434za7, "tv", 2 );
DEFINE_STRING( BGl_string2407z00zz__tvectorz00, BgL_bgl_string2407za700za7za7_2435za7, "vector-set!", 11 );
DEFINE_STRING( BGl_string2397z00zz__tvectorz00, BgL_bgl_string2397za700za7za7_2436za7, "arg1884", 7 );
DEFINE_STRING( BGl_string2408z00zz__tvectorz00, BgL_bgl_string2408za700za7za7_2437za7, "_tvector->vector", 16 );
DEFINE_STRING( BGl_string2398z00zz__tvectorz00, BgL_bgl_string2398za700za7za7_2438za7, "_vector->tvector", 16 );
DEFINE_STRING( BGl_string2409z00zz__tvectorz00, BgL_bgl_string2409za700za7za7_2439za7, "__tvector", 9 );
DEFINE_STRING( BGl_string2399z00zz__tvectorz00, BgL_bgl_string2399za700za7za7_2440za7, "vector", 6 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_getzd2tvectorzd2descriptorzd2envzd2zz__tvectorz00, BgL_bgl__getza7d2tvectorza7d2441z00, BGl__getzd2tvectorzd2descriptorz00zz__tvectorz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_listzd2ze3tvectorzd2envze3zz__tvectorz00, BgL_bgl__listza7d2za7e3tvect2442z00, BGl__listzd2ze3tvectorz31zz__tvectorz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_vectorzd2ze3tvectorzd2envze3zz__tvectorz00, BgL_bgl__vectorza7d2za7e3tve2443z00, BGl__vectorzd2ze3tvectorz31zz__tvectorz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_tvectorzd2refzd2envz00zz__tvectorz00, BgL_bgl__tvectorza7d2refza7d2444z00, BGl__tvectorzd2refzd2zz__tvectorz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_tvectorzd2idzd2envz00zz__tvectorz00, BgL_bgl__tvectorza7d2idza7d22445z00, BGl__tvectorzd2idzd2zz__tvectorz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_tvectorzf3zd2envz21zz__tvectorz00, BgL_bgl__tvectorza7f3za7f3za7za72446z00, BGl__tvectorzf3zf3zz__tvectorz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_declarezd2tvectorz12zd2envz12zz__tvectorz00, BgL_bgl__declareza7d2tvect2447za7, BGl__declarezd2tvectorz12zc0zz__tvectorz00, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_tvectorzd2ze3vectorzd2envze3zz__tvectorz00, BgL_bgl__tvectorza7d2za7e3ve2448z00, BGl__tvectorzd2ze3vectorz31zz__tvectorz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_tvectorzd2lengthzd2envz00zz__tvectorz00, BgL_bgl__tvectorza7d2lengt2449za7, BGl__tvectorzd2lengthzd2zz__tvectorz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2341z00zz__tvectorz00, BgL_bgl_string2341za700za7za7_2450za7, "_tvector-length", 15 );
DEFINE_STRING( BGl_string2342z00zz__tvectorz00, BgL_bgl_string2342za700za7za7_2451za7, "tvector", 7 );
DEFINE_STRING( BGl_string2343z00zz__tvectorz00, BgL_bgl_string2343za700za7za7_2452za7, "/tmp/bigloo/runtime/Llib/tvector.scm", 36 );
DEFINE_STRING( BGl_string2344z00zz__tvectorz00, BgL_bgl_string2344za700za7za7_2453za7, "tvector-id", 10 );
DEFINE_STRING( BGl_string2345z00zz__tvectorz00, BgL_bgl_string2345za700za7za7_2454za7, "struct", 6 );
DEFINE_STRING( BGl_string2346z00zz__tvectorz00, BgL_bgl_string2346za700za7za7_2455za7, "symbol", 6 );
DEFINE_STRING( BGl_string2348z00zz__tvectorz00, BgL_bgl_string2348za700za7za7_2456za7, "tvect-descr", 11 );
DEFINE_STRING( BGl_string2350z00zz__tvectorz00, BgL_bgl_string2350za700za7za7_2457za7, "_tvector-id", 11 );
DEFINE_STRING( BGl_string2349z00zz__tvectorz00, BgL_bgl_string2349za700za7za7_2458za7, "struct-ref:not an instance of", 29 );
DEFINE_STRING( BGl_string2351z00zz__tvectorz00, BgL_bgl_string2351za700za7za7_2459za7, "get-tvector-descriptor", 22 );
DEFINE_STRING( BGl_string2352z00zz__tvectorz00, BgL_bgl_string2352za700za7za7_2460za7, "pair-nil", 8 );
DEFINE_STRING( BGl_string2353z00zz__tvectorz00, BgL_bgl_string2353za700za7za7_2461za7, "_get-tvector-descriptor", 23 );
DEFINE_STRING( BGl_string2355z00zz__tvectorz00, BgL_bgl_string2355za700za7za7_2462za7, "upcase", 6 );
DEFINE_STRING( BGl_string2357z00zz__tvectorz00, BgL_bgl_string2357za700za7za7_2463za7, "downcase", 8 );
DEFINE_STRING( BGl_string2358z00zz__tvectorz00, BgL_bgl_string2358za700za7za7_2464za7, "declare-tvector!", 16 );
DEFINE_STRING( BGl_string2360z00zz__tvectorz00, BgL_bgl_string2360za700za7za7_2465za7, "_declare-tvector!", 17 );
DEFINE_STRING( BGl_string2359z00zz__tvectorz00, BgL_bgl_string2359za700za7za7_2466za7, "struct-set!:not an instance of", 30 );
DEFINE_STRING( BGl_string2361z00zz__tvectorz00, BgL_bgl_string2361za700za7za7_2467za7, "string", 6 );
DEFINE_STRING( BGl_string2362z00zz__tvectorz00, BgL_bgl_string2362za700za7za7_2468za7, "procedure", 9 );
DEFINE_STRING( BGl_string2363z00zz__tvectorz00, BgL_bgl_string2363za700za7za7_2469za7, "tvector-ref", 11 );
DEFINE_STRING( BGl_string2364z00zz__tvectorz00, BgL_bgl_string2364za700za7za7_2470za7, "_tvector-ref", 12 );



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long BgL_checksumz00_1936, char * BgL_fromz00_1937)
{ AN_OBJECT;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__tvectorz00))
{ 
BGl_requirezd2initializa7ationz75zz__tvectorz00 = 
BBOOL(((bool_t)0)); 
BGl_cnstzd2initzd2zz__tvectorz00(); 
BGl_importedzd2moduleszd2initz00zz__tvectorz00(); 
BGl_toplevelzd2initzd2zz__tvectorz00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__tvectorz00()
{ AN_OBJECT;
{ /* Llib/tvector.scm 14 */
BGl_symbol2347z00zz__tvectorz00 = 
bstring_to_symbol(BGl_string2348z00zz__tvectorz00); 
BGl_symbol2354z00zz__tvectorz00 = 
bstring_to_symbol(BGl_string2355z00zz__tvectorz00); 
BGl_symbol2356z00zz__tvectorz00 = 
bstring_to_symbol(BGl_string2357z00zz__tvectorz00); 
BGl_symbol2368z00zz__tvectorz00 = 
bstring_to_symbol(BGl_string2369z00zz__tvectorz00); 
BGl_symbol2370z00zz__tvectorz00 = 
bstring_to_symbol(BGl_string2371z00zz__tvectorz00); 
BGl_symbol2372z00zz__tvectorz00 = 
bstring_to_symbol(BGl_string2373z00zz__tvectorz00); 
BGl_list2367z00zz__tvectorz00 = 
MAKE_PAIR(BGl_symbol2368z00zz__tvectorz00, 
MAKE_PAIR(BGl_symbol2370z00zz__tvectorz00, 
MAKE_PAIR(BGl_symbol2370z00zz__tvectorz00, 
MAKE_PAIR(BGl_symbol2372z00zz__tvectorz00, BNIL)))); 
BGl_symbol2378z00zz__tvectorz00 = 
bstring_to_symbol(BGl_string2379z00zz__tvectorz00); 
BGl_symbol2380z00zz__tvectorz00 = 
bstring_to_symbol(BGl_string2381z00zz__tvectorz00); 
BGl_symbol2382z00zz__tvectorz00 = 
bstring_to_symbol(BGl_string2383z00zz__tvectorz00); 
BGl_symbol2384z00zz__tvectorz00 = 
bstring_to_symbol(BGl_string2385z00zz__tvectorz00); 
BGl_list2377z00zz__tvectorz00 = 
MAKE_PAIR(BGl_symbol2368z00zz__tvectorz00, 
MAKE_PAIR(BGl_symbol2378z00zz__tvectorz00, 
MAKE_PAIR(BGl_symbol2378z00zz__tvectorz00, 
MAKE_PAIR(BGl_symbol2380z00zz__tvectorz00, 
MAKE_PAIR(BGl_symbol2382z00zz__tvectorz00, 
MAKE_PAIR(BGl_symbol2384z00zz__tvectorz00, BNIL)))))); 
BGl_symbol2391z00zz__tvectorz00 = 
bstring_to_symbol(BGl_string2392z00zz__tvectorz00); 
BGl_symbol2396z00zz__tvectorz00 = 
bstring_to_symbol(BGl_string2397z00zz__tvectorz00); 
BGl_list2395z00zz__tvectorz00 = 
MAKE_PAIR(BGl_symbol2368z00zz__tvectorz00, 
MAKE_PAIR(BGl_symbol2378z00zz__tvectorz00, 
MAKE_PAIR(BGl_symbol2378z00zz__tvectorz00, 
MAKE_PAIR(BGl_symbol2380z00zz__tvectorz00, 
MAKE_PAIR(BGl_symbol2382z00zz__tvectorz00, 
MAKE_PAIR(BGl_symbol2396z00zz__tvectorz00, BNIL)))))); 
BGl_symbol2402z00zz__tvectorz00 = 
bstring_to_symbol(BGl_string2403z00zz__tvectorz00); 
BGl_symbol2404z00zz__tvectorz00 = 
bstring_to_symbol(BGl_string2405z00zz__tvectorz00); 
BGl_list2401z00zz__tvectorz00 = 
MAKE_PAIR(BGl_symbol2368z00zz__tvectorz00, 
MAKE_PAIR(BGl_symbol2402z00zz__tvectorz00, 
MAKE_PAIR(BGl_symbol2402z00zz__tvectorz00, 
MAKE_PAIR(BGl_symbol2404z00zz__tvectorz00, 
MAKE_PAIR(BGl_symbol2382z00zz__tvectorz00, BNIL))))); 
return ( 
BGl_symbol2406z00zz__tvectorz00 = 
bstring_to_symbol(BGl_string2407z00zz__tvectorz00), BUNSPEC) ;} 
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__tvectorz00()
{ AN_OBJECT;
{ /* Llib/tvector.scm 14 */
return ( 
BGl_za2tvectorzd2tableza2zd2zz__tvectorz00 = BNIL, BUNSPEC) ;} 
}



/* tvector? */
BGL_EXPORTED_DEF bool_t BGl_tvectorzf3zf3zz__tvectorz00(obj_t BgL_objz00_1)
{ AN_OBJECT;
{ /* Llib/tvector.scm 90 */
return 
TVECTORP(BgL_objz00_1);} 
}



/* _tvector? */
obj_t BGl__tvectorzf3zf3zz__tvectorz00(obj_t BgL_envz00_1797, obj_t BgL_objz00_1798)
{ AN_OBJECT;
{ /* Llib/tvector.scm 90 */
return 
BBOOL(
TVECTORP(BgL_objz00_1798));} 
}



/* tvector-length */
BGL_EXPORTED_DEF int BGl_tvectorzd2lengthzd2zz__tvectorz00(obj_t BgL_objz00_2)
{ AN_OBJECT;
{ /* Llib/tvector.scm 96 */
return 
TVECTOR_LENGTH(BgL_objz00_2);} 
}



/* _tvector-length */
obj_t BGl__tvectorzd2lengthzd2zz__tvectorz00(obj_t BgL_envz00_1799, obj_t BgL_objz00_1800)
{ AN_OBJECT;
{ /* Llib/tvector.scm 96 */
{ /* Llib/tvector.scm 97 */
int BgL_auxz00_1984;
{ /* Llib/tvector.scm 97 */
obj_t BgL_objz00_1925;
if(
TVECTORP(BgL_objz00_1800))
{ /* Llib/tvector.scm 97 */
BgL_objz00_1925 = BgL_objz00_1800; }  else 
{ /* Llib/tvector.scm 97 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2341z00zz__tvectorz00, BGl_string2342z00zz__tvectorz00, BgL_objz00_1800, BGl_string2343z00zz__tvectorz00, 
BINT(((long)3514))); 
exit( -1 );} 
BgL_auxz00_1984 = 
TVECTOR_LENGTH(BgL_objz00_1925); } 
return 
BINT(BgL_auxz00_1984);} } 
}



/* tvector-id */
BGL_EXPORTED_DEF obj_t BGl_tvectorzd2idzd2zz__tvectorz00(obj_t BgL_tvectz00_3)
{ AN_OBJECT;
{ /* Llib/tvector.scm 102 */
{ /* Llib/tvector.scm 103 */
obj_t BgL_arg1827z00_1340;
BgL_arg1827z00_1340 = 
TVECTOR_DESCR(BgL_tvectz00_3); 
{ /* Llib/tvector.scm 103 */
bool_t BgL_testz00_1993;
{ /* Llib/tvector.scm 103 */
obj_t BgL_auxz00_1994;
{ /* Llib/tvector.scm 103 */
obj_t BgL_res2208z00_1346;
{ /* Llib/tvector.scm 103 */
obj_t BgL_sz00_1345;
if(
STRUCTP(BgL_arg1827z00_1340))
{ /* Llib/tvector.scm 103 */
BgL_sz00_1345 = BgL_arg1827z00_1340; }  else 
{ /* Llib/tvector.scm 103 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2344z00zz__tvectorz00, BGl_string2345z00zz__tvectorz00, BgL_arg1827z00_1340, BGl_string2343z00zz__tvectorz00, 
BINT(((long)3807))); 
exit( -1 );} 
{ /* Llib/tvector.scm 103 */
obj_t BgL_aux2247z00_1825;
BgL_aux2247z00_1825 = 
STRUCT_KEY(BgL_sz00_1345); 
if(
SYMBOLP(BgL_aux2247z00_1825))
{ /* Llib/tvector.scm 103 */
BgL_res2208z00_1346 = BgL_aux2247z00_1825; }  else 
{ /* Llib/tvector.scm 103 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2344z00zz__tvectorz00, BGl_string2346z00zz__tvectorz00, BgL_aux2247z00_1825, BGl_string2343z00zz__tvectorz00, 
BINT(((long)3807))); 
exit( -1 );} } } 
BgL_auxz00_1994 = BgL_res2208z00_1346; } 
BgL_testz00_1993 = 
(BgL_auxz00_1994==BGl_symbol2347z00zz__tvectorz00); } 
if(BgL_testz00_1993)
{ /* Llib/tvector.scm 103 */
int BgL_auxz00_2007;
BgL_auxz00_2007 = 
(int)(((long)0)); 
return 
STRUCT_REF(BgL_arg1827z00_1340, BgL_auxz00_2007);}  else 
{ /* Llib/tvector.scm 103 */
return 
BGl_errorz00zz__errorz00(BGl_string2349z00zz__tvectorz00, BGl_string2348z00zz__tvectorz00, BgL_arg1827z00_1340);} } } } 
}



/* _tvector-id */
obj_t BGl__tvectorzd2idzd2zz__tvectorz00(obj_t BgL_envz00_1801, obj_t BgL_tvectz00_1802)
{ AN_OBJECT;
{ /* Llib/tvector.scm 102 */
{ /* Llib/tvector.scm 103 */
obj_t BgL_auxz00_2011;
if(
TVECTORP(BgL_tvectz00_1802))
{ /* Llib/tvector.scm 103 */
BgL_auxz00_2011 = BgL_tvectz00_1802
; }  else 
{ /* Llib/tvector.scm 103 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2350z00zz__tvectorz00, BGl_string2342z00zz__tvectorz00, BgL_tvectz00_1802, BGl_string2343z00zz__tvectorz00, 
BINT(((long)3807))); 
exit( -1 );} 
return 
BGl_tvectorzd2idzd2zz__tvectorz00(BgL_auxz00_2011);} } 
}



/* get-tvector-descriptor */
BGL_EXPORTED_DEF obj_t get_tvector_descriptor(obj_t BgL_idz00_22)
{ AN_OBJECT;
{ /* Llib/tvector.scm 125 */
if(
PAIRP(BGl_za2tvectorzd2tableza2zd2zz__tvectorz00))
{ /* Llib/tvector.scm 127 */
obj_t BgL_cellz00_797;
{ /* Llib/tvector.scm 127 */
obj_t BgL_auxz00_2020;
{ /* Llib/tvector.scm 127 */
obj_t BgL_aux2251z00_1829;
BgL_aux2251z00_1829 = BGl_za2tvectorzd2tableza2zd2zz__tvectorz00; 
{ /* Llib/tvector.scm 127 */
bool_t BgL_testz00_2021;
if(
PAIRP(BgL_aux2251z00_1829))
{ /* Llib/tvector.scm 127 */
BgL_testz00_2021 = ((bool_t)1)
; }  else 
{ /* Llib/tvector.scm 127 */
BgL_testz00_2021 = 
NULLP(BgL_aux2251z00_1829)
; } 
if(BgL_testz00_2021)
{ /* Llib/tvector.scm 127 */
BgL_auxz00_2020 = BgL_aux2251z00_1829
; }  else 
{ /* Llib/tvector.scm 127 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2351z00zz__tvectorz00, BGl_string2352z00zz__tvectorz00, BgL_aux2251z00_1829, BGl_string2343z00zz__tvectorz00, 
BINT(((long)5103))); 
exit( -1 );} } } 
BgL_cellz00_797 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_idz00_22, BgL_auxz00_2020); } 
if(
PAIRP(BgL_cellz00_797))
{ /* Llib/tvector.scm 128 */
return 
CDR(BgL_cellz00_797);}  else 
{ /* Llib/tvector.scm 128 */
return BFALSE;} }  else 
{ /* Llib/tvector.scm 126 */
return BFALSE;} } 
}



/* _get-tvector-descriptor */
obj_t BGl__getzd2tvectorzd2descriptorz00zz__tvectorz00(obj_t BgL_envz00_1803, obj_t BgL_idz00_1804)
{ AN_OBJECT;
{ /* Llib/tvector.scm 125 */
{ /* Llib/tvector.scm 126 */
obj_t BgL_auxz00_2032;
if(
SYMBOLP(BgL_idz00_1804))
{ /* Llib/tvector.scm 126 */
BgL_auxz00_2032 = BgL_idz00_1804
; }  else 
{ /* Llib/tvector.scm 126 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2353z00zz__tvectorz00, BGl_string2346z00zz__tvectorz00, BgL_idz00_1804, BGl_string2343z00zz__tvectorz00, 
BINT(((long)5057))); 
exit( -1 );} 
return 
get_tvector_descriptor(BgL_auxz00_2032);} } 
}



/* declare-tvector! */
BGL_EXPORTED_DEF obj_t BGl_declarezd2tvectorz12zc0zz__tvectorz00(char * BgL_idz00_23, obj_t BgL_allocatez00_24, obj_t BgL_refz00_25, obj_t BgL_setz00_26)
{ AN_OBJECT;
{ /* Llib/tvector.scm 139 */
{ /* Llib/tvector.scm 140 */
obj_t BgL_idz00_799;
{ /* Llib/tvector.scm 140 */
obj_t BgL_arg1865z00_804;
{ /* Llib/tvector.scm 140 */
obj_t BgL_casezd2valuezd2_805;
BgL_casezd2valuezd2_805 = 
BGl_bigloozd2casezd2sensitivityz00zz__readerz00(); 
if(
(BgL_casezd2valuezd2_805==BGl_symbol2354z00zz__tvectorz00))
{ /* Llib/tvector.scm 140 */
BgL_arg1865z00_804 = 
BGl_stringzd2upcasezd2zz__r4_strings_6_7z00(
string_to_bstring(BgL_idz00_23)); }  else 
{ /* Llib/tvector.scm 140 */
if(
(BgL_casezd2valuezd2_805==BGl_symbol2356z00zz__tvectorz00))
{ /* Llib/tvector.scm 140 */
BgL_arg1865z00_804 = 
BGl_stringzd2downcasezd2zz__r4_strings_6_7z00(
string_to_bstring(BgL_idz00_23)); }  else 
{ /* Llib/tvector.scm 140 */
BgL_arg1865z00_804 = 
string_to_bstring(BgL_idz00_23); } } } 
BgL_idz00_799 = 
string_to_symbol(
BSTRING_TO_STRING(BgL_arg1865z00_804)); } 
{ /* Llib/tvector.scm 140 */
obj_t BgL_oldz00_800;
BgL_oldz00_800 = 
get_tvector_descriptor(BgL_idz00_799); 
{ /* Llib/tvector.scm 147 */

{ /* Llib/tvector.scm 148 */
bool_t BgL_testz00_2052;
if(
STRUCTP(BgL_oldz00_800))
{ /* Llib/tvector.scm 148 */
obj_t BgL_auxz00_2055;
{ /* Llib/tvector.scm 148 */
obj_t BgL_res2222z00_1436;
{ /* Llib/tvector.scm 148 */
obj_t BgL_sz00_1435;
BgL_sz00_1435 = BgL_oldz00_800; 
{ /* Llib/tvector.scm 148 */
obj_t BgL_aux2259z00_1837;
BgL_aux2259z00_1837 = 
STRUCT_KEY(BgL_sz00_1435); 
if(
SYMBOLP(BgL_aux2259z00_1837))
{ /* Llib/tvector.scm 148 */
BgL_res2222z00_1436 = BgL_aux2259z00_1837; }  else 
{ /* Llib/tvector.scm 148 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2358z00zz__tvectorz00, BGl_string2346z00zz__tvectorz00, BgL_aux2259z00_1837, BGl_string2343z00zz__tvectorz00, 
BINT(((long)6032))); 
exit( -1 );} } } 
BgL_auxz00_2055 = BgL_res2222z00_1436; } 
BgL_testz00_2052 = 
(BgL_auxz00_2055==BGl_symbol2347z00zz__tvectorz00); }  else 
{ /* Llib/tvector.scm 148 */
BgL_testz00_2052 = ((bool_t)0)
; } 
if(BgL_testz00_2052)
{ /* Llib/tvector.scm 148 */
return BgL_oldz00_800;}  else 
{ /* Llib/tvector.scm 149 */
obj_t BgL_newz00_802;
{ /* Llib/tvector.scm 149 */
obj_t BgL_newz00_1441;
BgL_newz00_1441 = 
create_struct(BGl_symbol2347z00zz__tvectorz00, 
(int)(((long)4))); 
{ /* Llib/tvector.scm 149 */
bool_t BgL_testz00_2065;
{ /* Llib/tvector.scm 149 */
obj_t BgL_auxz00_2066;
{ /* Llib/tvector.scm 149 */
obj_t BgL_res2223z00_1448;
{ /* Llib/tvector.scm 149 */
obj_t BgL_aux2261z00_1839;
BgL_aux2261z00_1839 = 
STRUCT_KEY(BgL_newz00_1441); 
if(
SYMBOLP(BgL_aux2261z00_1839))
{ /* Llib/tvector.scm 149 */
BgL_res2223z00_1448 = BgL_aux2261z00_1839; }  else 
{ /* Llib/tvector.scm 149 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2358z00zz__tvectorz00, BGl_string2346z00zz__tvectorz00, BgL_aux2261z00_1839, BGl_string2343z00zz__tvectorz00, 
BINT(((long)6066))); 
exit( -1 );} } 
BgL_auxz00_2066 = BgL_res2223z00_1448; } 
BgL_testz00_2065 = 
(BgL_auxz00_2066==BGl_symbol2347z00zz__tvectorz00); } 
if(BgL_testz00_2065)
{ /* Llib/tvector.scm 149 */
int BgL_auxz00_2074;
BgL_auxz00_2074 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_1441, BgL_auxz00_2074, BgL_setz00_26); }  else 
{ /* Llib/tvector.scm 149 */
BGl_errorz00zz__errorz00(BGl_string2359z00zz__tvectorz00, BGl_string2348z00zz__tvectorz00, BgL_newz00_1441); } } 
{ /* Llib/tvector.scm 149 */
bool_t BgL_testz00_2078;
{ /* Llib/tvector.scm 149 */
obj_t BgL_auxz00_2079;
{ /* Llib/tvector.scm 149 */
obj_t BgL_res2224z00_1455;
{ /* Llib/tvector.scm 149 */
obj_t BgL_aux2263z00_1841;
BgL_aux2263z00_1841 = 
STRUCT_KEY(BgL_newz00_1441); 
if(
SYMBOLP(BgL_aux2263z00_1841))
{ /* Llib/tvector.scm 149 */
BgL_res2224z00_1455 = BgL_aux2263z00_1841; }  else 
{ /* Llib/tvector.scm 149 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2358z00zz__tvectorz00, BGl_string2346z00zz__tvectorz00, BgL_aux2263z00_1841, BGl_string2343z00zz__tvectorz00, 
BINT(((long)6066))); 
exit( -1 );} } 
BgL_auxz00_2079 = BgL_res2224z00_1455; } 
BgL_testz00_2078 = 
(BgL_auxz00_2079==BGl_symbol2347z00zz__tvectorz00); } 
if(BgL_testz00_2078)
{ /* Llib/tvector.scm 149 */
int BgL_auxz00_2087;
BgL_auxz00_2087 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_1441, BgL_auxz00_2087, BgL_refz00_25); }  else 
{ /* Llib/tvector.scm 149 */
BGl_errorz00zz__errorz00(BGl_string2359z00zz__tvectorz00, BGl_string2348z00zz__tvectorz00, BgL_newz00_1441); } } 
{ /* Llib/tvector.scm 149 */
bool_t BgL_testz00_2091;
{ /* Llib/tvector.scm 149 */
obj_t BgL_auxz00_2092;
{ /* Llib/tvector.scm 149 */
obj_t BgL_res2225z00_1462;
{ /* Llib/tvector.scm 149 */
obj_t BgL_aux2265z00_1843;
BgL_aux2265z00_1843 = 
STRUCT_KEY(BgL_newz00_1441); 
if(
SYMBOLP(BgL_aux2265z00_1843))
{ /* Llib/tvector.scm 149 */
BgL_res2225z00_1462 = BgL_aux2265z00_1843; }  else 
{ /* Llib/tvector.scm 149 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2358z00zz__tvectorz00, BGl_string2346z00zz__tvectorz00, BgL_aux2265z00_1843, BGl_string2343z00zz__tvectorz00, 
BINT(((long)6066))); 
exit( -1 );} } 
BgL_auxz00_2092 = BgL_res2225z00_1462; } 
BgL_testz00_2091 = 
(BgL_auxz00_2092==BGl_symbol2347z00zz__tvectorz00); } 
if(BgL_testz00_2091)
{ /* Llib/tvector.scm 149 */
int BgL_auxz00_2100;
BgL_auxz00_2100 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_1441, BgL_auxz00_2100, BgL_allocatez00_24); }  else 
{ /* Llib/tvector.scm 149 */
BGl_errorz00zz__errorz00(BGl_string2359z00zz__tvectorz00, BGl_string2348z00zz__tvectorz00, BgL_newz00_1441); } } 
{ /* Llib/tvector.scm 149 */
bool_t BgL_testz00_2104;
{ /* Llib/tvector.scm 149 */
obj_t BgL_auxz00_2105;
{ /* Llib/tvector.scm 149 */
obj_t BgL_res2226z00_1469;
{ /* Llib/tvector.scm 149 */
obj_t BgL_aux2267z00_1845;
BgL_aux2267z00_1845 = 
STRUCT_KEY(BgL_newz00_1441); 
if(
SYMBOLP(BgL_aux2267z00_1845))
{ /* Llib/tvector.scm 149 */
BgL_res2226z00_1469 = BgL_aux2267z00_1845; }  else 
{ /* Llib/tvector.scm 149 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2358z00zz__tvectorz00, BGl_string2346z00zz__tvectorz00, BgL_aux2267z00_1845, BGl_string2343z00zz__tvectorz00, 
BINT(((long)6066))); 
exit( -1 );} } 
BgL_auxz00_2105 = BgL_res2226z00_1469; } 
BgL_testz00_2104 = 
(BgL_auxz00_2105==BGl_symbol2347z00zz__tvectorz00); } 
if(BgL_testz00_2104)
{ /* Llib/tvector.scm 149 */
int BgL_auxz00_2113;
BgL_auxz00_2113 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_1441, BgL_auxz00_2113, BgL_idz00_799); }  else 
{ /* Llib/tvector.scm 149 */
BGl_errorz00zz__errorz00(BGl_string2359z00zz__tvectorz00, BGl_string2348z00zz__tvectorz00, BgL_newz00_1441); } } 
BgL_newz00_802 = BgL_newz00_1441; } 
{ /* Llib/tvector.scm 150 */
obj_t BgL_arg1864z00_803;
BgL_arg1864z00_803 = 
MAKE_PAIR(BgL_idz00_799, BgL_newz00_802); 
BGl_za2tvectorzd2tableza2zd2zz__tvectorz00 = 
MAKE_PAIR(BgL_arg1864z00_803, BGl_za2tvectorzd2tableza2zd2zz__tvectorz00); } 
return BgL_newz00_802;} } } } } } 
}



/* _declare-tvector! */
obj_t BGl__declarezd2tvectorz12zc0zz__tvectorz00(obj_t BgL_envz00_1805, obj_t BgL_idz00_1806, obj_t BgL_allocatez00_1807, obj_t BgL_refz00_1808, obj_t BgL_setz00_1809)
{ AN_OBJECT;
{ /* Llib/tvector.scm 139 */
{ /* Llib/tvector.scm 140 */
obj_t BgL_auxz00_2127;char * BgL_auxz00_2119;
if(
PROCEDUREP(BgL_allocatez00_1807))
{ /* Llib/tvector.scm 140 */
BgL_auxz00_2127 = BgL_allocatez00_1807
; }  else 
{ /* Llib/tvector.scm 140 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2360z00zz__tvectorz00, BGl_string2362z00zz__tvectorz00, BgL_allocatez00_1807, BGl_string2343z00zz__tvectorz00, 
BINT(((long)5746))); 
exit( -1 );} 
{ /* Llib/tvector.scm 140 */
obj_t BgL_auxz00_2120;
if(
STRINGP(BgL_idz00_1806))
{ /* Llib/tvector.scm 140 */
BgL_auxz00_2120 = BgL_idz00_1806
; }  else 
{ /* Llib/tvector.scm 140 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2360z00zz__tvectorz00, BGl_string2361z00zz__tvectorz00, BgL_idz00_1806, BGl_string2343z00zz__tvectorz00, 
BINT(((long)5746))); 
exit( -1 );} 
BgL_auxz00_2119 = 
BSTRING_TO_STRING(BgL_auxz00_2120); } 
return 
BGl_declarezd2tvectorz12zc0zz__tvectorz00(BgL_auxz00_2119, BgL_auxz00_2127, BgL_refz00_1808, BgL_setz00_1809);} } 
}



/* tvector-ref */
BGL_EXPORTED_DEF obj_t BGl_tvectorzd2refzd2zz__tvectorz00(obj_t BgL_tvectorz00_27)
{ AN_OBJECT;
{ /* Llib/tvector.scm 157 */
{ /* Llib/tvector.scm 158 */
obj_t BgL_arg1870z00_1470;
BgL_arg1870z00_1470 = 
TVECTOR_DESCR(BgL_tvectorz00_27); 
{ /* Llib/tvector.scm 158 */
bool_t BgL_testz00_2135;
{ /* Llib/tvector.scm 158 */
obj_t BgL_auxz00_2136;
{ /* Llib/tvector.scm 158 */
obj_t BgL_res2227z00_1476;
{ /* Llib/tvector.scm 158 */
obj_t BgL_sz00_1475;
if(
STRUCTP(BgL_arg1870z00_1470))
{ /* Llib/tvector.scm 158 */
BgL_sz00_1475 = BgL_arg1870z00_1470; }  else 
{ /* Llib/tvector.scm 158 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2363z00zz__tvectorz00, BGl_string2345z00zz__tvectorz00, BgL_arg1870z00_1470, BGl_string2343z00zz__tvectorz00, 
BINT(((long)6467))); 
exit( -1 );} 
{ /* Llib/tvector.scm 158 */
obj_t BgL_aux2275z00_1853;
BgL_aux2275z00_1853 = 
STRUCT_KEY(BgL_sz00_1475); 
if(
SYMBOLP(BgL_aux2275z00_1853))
{ /* Llib/tvector.scm 158 */
BgL_res2227z00_1476 = BgL_aux2275z00_1853; }  else 
{ /* Llib/tvector.scm 158 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2363z00zz__tvectorz00, BGl_string2346z00zz__tvectorz00, BgL_aux2275z00_1853, BGl_string2343z00zz__tvectorz00, 
BINT(((long)6467))); 
exit( -1 );} } } 
BgL_auxz00_2136 = BgL_res2227z00_1476; } 
BgL_testz00_2135 = 
(BgL_auxz00_2136==BGl_symbol2347z00zz__tvectorz00); } 
if(BgL_testz00_2135)
{ /* Llib/tvector.scm 158 */
int BgL_auxz00_2149;
BgL_auxz00_2149 = 
(int)(((long)2)); 
return 
STRUCT_REF(BgL_arg1870z00_1470, BgL_auxz00_2149);}  else 
{ /* Llib/tvector.scm 158 */
return 
BGl_errorz00zz__errorz00(BGl_string2349z00zz__tvectorz00, BGl_string2348z00zz__tvectorz00, BgL_arg1870z00_1470);} } } } 
}



/* _tvector-ref */
obj_t BGl__tvectorzd2refzd2zz__tvectorz00(obj_t BgL_envz00_1810, obj_t BgL_tvectorz00_1811)
{ AN_OBJECT;
{ /* Llib/tvector.scm 157 */
{ /* Llib/tvector.scm 158 */
obj_t BgL_auxz00_2153;
if(
TVECTORP(BgL_tvectorz00_1811))
{ /* Llib/tvector.scm 158 */
BgL_auxz00_2153 = BgL_tvectorz00_1811
; }  else 
{ /* Llib/tvector.scm 158 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2364z00zz__tvectorz00, BGl_string2342z00zz__tvectorz00, BgL_tvectorz00_1811, BGl_string2343z00zz__tvectorz00, 
BINT(((long)6467))); 
exit( -1 );} 
return 
BGl_tvectorzd2refzd2zz__tvectorz00(BgL_auxz00_2153);} } 
}



/* list->tvector */
BGL_EXPORTED_DEF obj_t BGl_listzd2ze3tvectorz31zz__tvectorz00(obj_t BgL_idz00_28, obj_t BgL_lz00_29)
{ AN_OBJECT;
{ /* Llib/tvector.scm 163 */
{ /* Llib/tvector.scm 164 */
obj_t BgL_descrz00_811;
BgL_descrz00_811 = 
get_tvector_descriptor(BgL_idz00_28); 
if(
CBOOL(BgL_descrz00_811))
{ /* Llib/tvector.scm 167 */
obj_t BgL_allocatez00_812;obj_t BgL_setz00_813;
{ /* Llib/tvector.scm 167 */
bool_t BgL_testz00_2163;
{ /* Llib/tvector.scm 167 */
obj_t BgL_auxz00_2164;
{ /* Llib/tvector.scm 167 */
obj_t BgL_res2228z00_1482;
{ /* Llib/tvector.scm 167 */
obj_t BgL_sz00_1481;
if(
STRUCTP(BgL_descrz00_811))
{ /* Llib/tvector.scm 167 */
BgL_sz00_1481 = BgL_descrz00_811; }  else 
{ /* Llib/tvector.scm 167 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2365z00zz__tvectorz00, BGl_string2345z00zz__tvectorz00, BgL_descrz00_811, BGl_string2343z00zz__tvectorz00, 
BINT(((long)6902))); 
exit( -1 );} 
{ /* Llib/tvector.scm 167 */
obj_t BgL_aux2281z00_1859;
BgL_aux2281z00_1859 = 
STRUCT_KEY(BgL_sz00_1481); 
if(
SYMBOLP(BgL_aux2281z00_1859))
{ /* Llib/tvector.scm 167 */
BgL_res2228z00_1482 = BgL_aux2281z00_1859; }  else 
{ /* Llib/tvector.scm 167 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2365z00zz__tvectorz00, BGl_string2346z00zz__tvectorz00, BgL_aux2281z00_1859, BGl_string2343z00zz__tvectorz00, 
BINT(((long)6902))); 
exit( -1 );} } } 
BgL_auxz00_2164 = BgL_res2228z00_1482; } 
BgL_testz00_2163 = 
(BgL_auxz00_2164==BGl_symbol2347z00zz__tvectorz00); } 
if(BgL_testz00_2163)
{ /* Llib/tvector.scm 167 */
int BgL_auxz00_2177;
BgL_auxz00_2177 = 
(int)(((long)1)); 
BgL_allocatez00_812 = 
STRUCT_REF(BgL_descrz00_811, BgL_auxz00_2177); }  else 
{ /* Llib/tvector.scm 167 */
BgL_allocatez00_812 = 
BGl_errorz00zz__errorz00(BGl_string2349z00zz__tvectorz00, BGl_string2348z00zz__tvectorz00, BgL_descrz00_811); } } 
{ /* Llib/tvector.scm 168 */
bool_t BgL_testz00_2181;
{ /* Llib/tvector.scm 168 */
obj_t BgL_auxz00_2182;
{ /* Llib/tvector.scm 168 */
obj_t BgL_res2229z00_1488;
{ /* Llib/tvector.scm 168 */
obj_t BgL_sz00_1487;
if(
STRUCTP(BgL_descrz00_811))
{ /* Llib/tvector.scm 168 */
BgL_sz00_1487 = BgL_descrz00_811; }  else 
{ /* Llib/tvector.scm 168 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2365z00zz__tvectorz00, BGl_string2345z00zz__tvectorz00, BgL_descrz00_811, BGl_string2343z00zz__tvectorz00, 
BINT(((long)6944))); 
exit( -1 );} 
{ /* Llib/tvector.scm 168 */
obj_t BgL_aux2285z00_1863;
BgL_aux2285z00_1863 = 
STRUCT_KEY(BgL_sz00_1487); 
if(
SYMBOLP(BgL_aux2285z00_1863))
{ /* Llib/tvector.scm 168 */
BgL_res2229z00_1488 = BgL_aux2285z00_1863; }  else 
{ /* Llib/tvector.scm 168 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2365z00zz__tvectorz00, BGl_string2346z00zz__tvectorz00, BgL_aux2285z00_1863, BGl_string2343z00zz__tvectorz00, 
BINT(((long)6944))); 
exit( -1 );} } } 
BgL_auxz00_2182 = BgL_res2229z00_1488; } 
BgL_testz00_2181 = 
(BgL_auxz00_2182==BGl_symbol2347z00zz__tvectorz00); } 
if(BgL_testz00_2181)
{ /* Llib/tvector.scm 168 */
int BgL_auxz00_2195;
BgL_auxz00_2195 = 
(int)(((long)3)); 
BgL_setz00_813 = 
STRUCT_REF(BgL_descrz00_811, BgL_auxz00_2195); }  else 
{ /* Llib/tvector.scm 168 */
BgL_setz00_813 = 
BGl_errorz00zz__errorz00(BGl_string2349z00zz__tvectorz00, BGl_string2348z00zz__tvectorz00, BgL_descrz00_811); } } 
if(
PROCEDUREP(BgL_setz00_813))
{ /* Llib/tvector.scm 173 */
long BgL_lenz00_815;
BgL_lenz00_815 = 
bgl_list_length(BgL_lz00_29); 
{ /* Llib/tvector.scm 173 */
obj_t BgL_tvecz00_816;
{ /* Llib/tvector.scm 174 */
obj_t BgL_funz00_1867;
if(
PROCEDUREP(BgL_allocatez00_812))
{ /* Llib/tvector.scm 174 */
BgL_funz00_1867 = BgL_allocatez00_812; }  else 
{ /* Llib/tvector.scm 174 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2365z00zz__tvectorz00, BGl_string2362z00zz__tvectorz00, BgL_allocatez00_812, BGl_string2343z00zz__tvectorz00, 
BINT(((long)7112))); 
exit( -1 );} 
if(
PROCEDURE_CORRECT_ARITYP(BgL_funz00_1867, ((long)1)))
{ /* Llib/tvector.scm 174 */
BgL_tvecz00_816 = 
PROCEDURE_ENTRY(BgL_funz00_1867)(BgL_allocatez00_812, 
BINT(BgL_lenz00_815), BEOA); }  else 
{ /* Llib/tvector.scm 174 */
FAILURE(BGl_string2366z00zz__tvectorz00,BGl_list2367z00zz__tvectorz00,BgL_funz00_1867);} } 
{ /* Llib/tvector.scm 174 */

{ 
obj_t BgL_lz00_818;long BgL_iz00_819;
BgL_lz00_818 = BgL_lz00_29; 
BgL_iz00_819 = ((long)0); 
BgL_zc3anonymousza31872ze3z83_820:
if(
NULLP(BgL_lz00_818))
{ /* Llib/tvector.scm 177 */
return BgL_tvecz00_816;}  else 
{ /* Llib/tvector.scm 177 */
{ /* Llib/tvector.scm 180 */
obj_t BgL_arg1874z00_822;
{ /* Llib/tvector.scm 180 */
obj_t BgL_pairz00_1491;
if(
PAIRP(BgL_lz00_818))
{ /* Llib/tvector.scm 180 */
BgL_pairz00_1491 = BgL_lz00_818; }  else 
{ /* Llib/tvector.scm 180 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2374z00zz__tvectorz00, BGl_string2375z00zz__tvectorz00, BgL_lz00_818, BGl_string2343z00zz__tvectorz00, 
BINT(((long)7242))); 
exit( -1 );} 
BgL_arg1874z00_822 = 
CAR(BgL_pairz00_1491); } 
{ /* Llib/tvector.scm 180 */
obj_t BgL_funz00_1874;
BgL_funz00_1874 = BgL_setz00_813; 
if(
PROCEDURE_CORRECT_ARITYP(BgL_funz00_1874, ((long)3)))
{ /* Llib/tvector.scm 180 */
PROCEDURE_ENTRY(BgL_funz00_1874)(BgL_setz00_813, BgL_tvecz00_816, 
BINT(BgL_iz00_819), BgL_arg1874z00_822, BEOA); }  else 
{ /* Llib/tvector.scm 180 */
FAILURE(BGl_string2376z00zz__tvectorz00,BGl_list2377z00zz__tvectorz00,BgL_funz00_1874);} } } 
{ /* Llib/tvector.scm 181 */
obj_t BgL_arg1877z00_823;long BgL_arg1879z00_824;
{ /* Llib/tvector.scm 181 */
obj_t BgL_pairz00_1492;
if(
PAIRP(BgL_lz00_818))
{ /* Llib/tvector.scm 181 */
BgL_pairz00_1492 = BgL_lz00_818; }  else 
{ /* Llib/tvector.scm 181 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2374z00zz__tvectorz00, BGl_string2375z00zz__tvectorz00, BgL_lz00_818, BGl_string2343z00zz__tvectorz00, 
BINT(((long)7266))); 
exit( -1 );} 
BgL_arg1877z00_823 = 
CDR(BgL_pairz00_1492); } 
BgL_arg1879z00_824 = 
(BgL_iz00_819+((long)1)); 
{ 
long BgL_iz00_2235;obj_t BgL_lz00_2234;
BgL_lz00_2234 = BgL_arg1877z00_823; 
BgL_iz00_2235 = BgL_arg1879z00_824; 
BgL_iz00_819 = BgL_iz00_2235; 
BgL_lz00_818 = BgL_lz00_2234; 
goto BgL_zc3anonymousza31872ze3z83_820;} } } } } } }  else 
{ /* Llib/tvector.scm 169 */
return 
BGl_errorz00zz__errorz00(BGl_string2365z00zz__tvectorz00, BGl_string2386z00zz__tvectorz00, BgL_idz00_28);} }  else 
{ /* Llib/tvector.scm 165 */
return 
BGl_errorz00zz__errorz00(BGl_string2365z00zz__tvectorz00, BGl_string2387z00zz__tvectorz00, BgL_idz00_28);} } } 
}



/* _list->tvector */
obj_t BGl__listzd2ze3tvectorz31zz__tvectorz00(obj_t BgL_envz00_1812, obj_t BgL_idz00_1813, obj_t BgL_lz00_1814)
{ AN_OBJECT;
{ /* Llib/tvector.scm 163 */
{ /* Llib/tvector.scm 164 */
obj_t BgL_auxz00_2244;obj_t BgL_auxz00_2238;
{ /* Llib/tvector.scm 164 */
bool_t BgL_testz00_2245;
if(
PAIRP(BgL_lz00_1814))
{ /* Llib/tvector.scm 164 */
BgL_testz00_2245 = ((bool_t)1)
; }  else 
{ /* Llib/tvector.scm 164 */
BgL_testz00_2245 = 
NULLP(BgL_lz00_1814)
; } 
if(BgL_testz00_2245)
{ /* Llib/tvector.scm 164 */
BgL_auxz00_2244 = BgL_lz00_1814
; }  else 
{ /* Llib/tvector.scm 164 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2388z00zz__tvectorz00, BGl_string2352z00zz__tvectorz00, BgL_lz00_1814, BGl_string2343z00zz__tvectorz00, 
BINT(((long)6767))); 
exit( -1 );} } 
if(
SYMBOLP(BgL_idz00_1813))
{ /* Llib/tvector.scm 164 */
BgL_auxz00_2238 = BgL_idz00_1813
; }  else 
{ /* Llib/tvector.scm 164 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2388z00zz__tvectorz00, BGl_string2346z00zz__tvectorz00, BgL_idz00_1813, BGl_string2343z00zz__tvectorz00, 
BINT(((long)6767))); 
exit( -1 );} 
return 
BGl_listzd2ze3tvectorz31zz__tvectorz00(BgL_auxz00_2238, BgL_auxz00_2244);} } 
}



/* vector->tvector */
BGL_EXPORTED_DEF obj_t BGl_vectorzd2ze3tvectorz31zz__tvectorz00(obj_t BgL_idz00_30, obj_t BgL_vz00_31)
{ AN_OBJECT;
{ /* Llib/tvector.scm 186 */
{ /* Llib/tvector.scm 187 */
obj_t BgL_descrz00_826;
BgL_descrz00_826 = 
get_tvector_descriptor(BgL_idz00_30); 
if(
CBOOL(BgL_descrz00_826))
{ /* Llib/tvector.scm 190 */
obj_t BgL_allocatez00_827;obj_t BgL_setz00_828;
{ /* Llib/tvector.scm 190 */
bool_t BgL_testz00_2256;
{ /* Llib/tvector.scm 190 */
obj_t BgL_auxz00_2257;
{ /* Llib/tvector.scm 190 */
obj_t BgL_res2230z00_1500;
{ /* Llib/tvector.scm 190 */
obj_t BgL_sz00_1499;
if(
STRUCTP(BgL_descrz00_826))
{ /* Llib/tvector.scm 190 */
BgL_sz00_1499 = BgL_descrz00_826; }  else 
{ /* Llib/tvector.scm 190 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2389z00zz__tvectorz00, BGl_string2345z00zz__tvectorz00, BgL_descrz00_826, BGl_string2343z00zz__tvectorz00, 
BINT(((long)7699))); 
exit( -1 );} 
{ /* Llib/tvector.scm 190 */
obj_t BgL_aux2305z00_1885;
BgL_aux2305z00_1885 = 
STRUCT_KEY(BgL_sz00_1499); 
if(
SYMBOLP(BgL_aux2305z00_1885))
{ /* Llib/tvector.scm 190 */
BgL_res2230z00_1500 = BgL_aux2305z00_1885; }  else 
{ /* Llib/tvector.scm 190 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2389z00zz__tvectorz00, BGl_string2346z00zz__tvectorz00, BgL_aux2305z00_1885, BGl_string2343z00zz__tvectorz00, 
BINT(((long)7699))); 
exit( -1 );} } } 
BgL_auxz00_2257 = BgL_res2230z00_1500; } 
BgL_testz00_2256 = 
(BgL_auxz00_2257==BGl_symbol2347z00zz__tvectorz00); } 
if(BgL_testz00_2256)
{ /* Llib/tvector.scm 190 */
int BgL_auxz00_2270;
BgL_auxz00_2270 = 
(int)(((long)1)); 
BgL_allocatez00_827 = 
STRUCT_REF(BgL_descrz00_826, BgL_auxz00_2270); }  else 
{ /* Llib/tvector.scm 190 */
BgL_allocatez00_827 = 
BGl_errorz00zz__errorz00(BGl_string2349z00zz__tvectorz00, BGl_string2348z00zz__tvectorz00, BgL_descrz00_826); } } 
{ /* Llib/tvector.scm 191 */
bool_t BgL_testz00_2274;
{ /* Llib/tvector.scm 191 */
obj_t BgL_auxz00_2275;
{ /* Llib/tvector.scm 191 */
obj_t BgL_res2231z00_1506;
{ /* Llib/tvector.scm 191 */
obj_t BgL_sz00_1505;
if(
STRUCTP(BgL_descrz00_826))
{ /* Llib/tvector.scm 191 */
BgL_sz00_1505 = BgL_descrz00_826; }  else 
{ /* Llib/tvector.scm 191 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2389z00zz__tvectorz00, BGl_string2345z00zz__tvectorz00, BgL_descrz00_826, BGl_string2343z00zz__tvectorz00, 
BINT(((long)7741))); 
exit( -1 );} 
{ /* Llib/tvector.scm 191 */
obj_t BgL_aux2309z00_1889;
BgL_aux2309z00_1889 = 
STRUCT_KEY(BgL_sz00_1505); 
if(
SYMBOLP(BgL_aux2309z00_1889))
{ /* Llib/tvector.scm 191 */
BgL_res2231z00_1506 = BgL_aux2309z00_1889; }  else 
{ /* Llib/tvector.scm 191 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2389z00zz__tvectorz00, BGl_string2346z00zz__tvectorz00, BgL_aux2309z00_1889, BGl_string2343z00zz__tvectorz00, 
BINT(((long)7741))); 
exit( -1 );} } } 
BgL_auxz00_2275 = BgL_res2231z00_1506; } 
BgL_testz00_2274 = 
(BgL_auxz00_2275==BGl_symbol2347z00zz__tvectorz00); } 
if(BgL_testz00_2274)
{ /* Llib/tvector.scm 191 */
int BgL_auxz00_2288;
BgL_auxz00_2288 = 
(int)(((long)3)); 
BgL_setz00_828 = 
STRUCT_REF(BgL_descrz00_826, BgL_auxz00_2288); }  else 
{ /* Llib/tvector.scm 191 */
BgL_setz00_828 = 
BGl_errorz00zz__errorz00(BGl_string2349z00zz__tvectorz00, BGl_string2348z00zz__tvectorz00, BgL_descrz00_826); } } 
if(
PROCEDUREP(BgL_setz00_828))
{ /* Llib/tvector.scm 196 */
int BgL_lenz00_830;
BgL_lenz00_830 = 
VECTOR_LENGTH(BgL_vz00_31); 
{ /* Llib/tvector.scm 196 */
obj_t BgL_tvecz00_831;
{ /* Llib/tvector.scm 197 */
obj_t BgL_funz00_1893;
if(
PROCEDUREP(BgL_allocatez00_827))
{ /* Llib/tvector.scm 197 */
BgL_funz00_1893 = BgL_allocatez00_827; }  else 
{ /* Llib/tvector.scm 197 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2389z00zz__tvectorz00, BGl_string2362z00zz__tvectorz00, BgL_allocatez00_827, BGl_string2343z00zz__tvectorz00, 
BINT(((long)7918))); 
exit( -1 );} 
if(
PROCEDURE_CORRECT_ARITYP(BgL_funz00_1893, ((long)1)))
{ /* Llib/tvector.scm 197 */
BgL_tvecz00_831 = 
PROCEDURE_ENTRY(BgL_funz00_1893)(BgL_allocatez00_827, 
BINT(BgL_lenz00_830), BEOA); }  else 
{ /* Llib/tvector.scm 197 */
FAILURE(BGl_string2390z00zz__tvectorz00,BGl_list2367z00zz__tvectorz00,BgL_funz00_1893);} } 
{ /* Llib/tvector.scm 197 */

{ /* Llib/tvector.scm 198 */
long BgL_g1770z00_832;
BgL_g1770z00_832 = 
(
(long)(BgL_lenz00_830)-((long)1)); 
{ 
long BgL_iz00_834;
BgL_iz00_834 = BgL_g1770z00_832; 
BgL_zc3anonymousza31881ze3z83_835:
if(
(BgL_iz00_834==((long)-1)))
{ /* Llib/tvector.scm 199 */
return BgL_tvecz00_831;}  else 
{ /* Llib/tvector.scm 199 */
{ /* Llib/tvector.scm 202 */
obj_t BgL_arg1884z00_837;
{ /* Llib/tvector.scm 202 */
obj_t BgL_vectorz00_1513;int BgL_kz00_1514;
BgL_vectorz00_1513 = BgL_vz00_31; 
BgL_kz00_1514 = 
(int)(BgL_iz00_834); 
{ /* Llib/tvector.scm 202 */
bool_t BgL_testz00_2311;
{ /* Llib/tvector.scm 202 */
int BgL_arg2113z00_1516;
BgL_arg2113z00_1516 = 
VECTOR_LENGTH(BgL_vectorz00_1513); 
BgL_testz00_2311 = 
BOUND_CHECK(BgL_kz00_1514, BgL_arg2113z00_1516); } 
if(BgL_testz00_2311)
{ /* Llib/tvector.scm 202 */
BgL_arg1884z00_837 = 
VECTOR_REF(BgL_vectorz00_1513,BgL_kz00_1514); }  else 
{ /* Llib/tvector.scm 202 */
obj_t BgL_arg2104z00_1517;obj_t BgL_arg2105z00_1518;
BgL_arg2104z00_1517 = BGl_symbol2391z00zz__tvectorz00; 
{ /* Llib/tvector.scm 202 */
obj_t BgL_arg2107z00_1520;
{ /* Llib/tvector.scm 202 */
long BgL_arg2110z00_1522;
{ /* Llib/tvector.scm 202 */
int BgL_arg2111z00_1523;
BgL_arg2111z00_1523 = 
VECTOR_LENGTH(BgL_vectorz00_1513); 
BgL_arg2110z00_1522 = 
(
(long)(BgL_arg2111z00_1523)-((long)1)); } 
{ /* Llib/tvector.scm 202 */

BgL_arg2107z00_1520 = 
BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(BgL_arg2110z00_1522, ((long)10)); } } 
BgL_arg2105z00_1518 = 
string_append_3(BGl_string2393z00zz__tvectorz00, BgL_arg2107z00_1520, BGl_string2394z00zz__tvectorz00); } 
BgL_arg1884z00_837 = 
BGl_errorz00zz__errorz00(BgL_arg2104z00_1517, BgL_arg2105z00_1518, 
BINT(BgL_kz00_1514)); } } } 
{ /* Llib/tvector.scm 202 */
obj_t BgL_funz00_1898;
BgL_funz00_1898 = BgL_setz00_828; 
if(
PROCEDURE_CORRECT_ARITYP(BgL_funz00_1898, ((long)3)))
{ /* Llib/tvector.scm 202 */
PROCEDURE_ENTRY(BgL_funz00_1898)(BgL_setz00_828, BgL_tvecz00_831, 
BINT(BgL_iz00_834), BgL_arg1884z00_837, BEOA); }  else 
{ /* Llib/tvector.scm 202 */
FAILURE(BGl_string2376z00zz__tvectorz00,BGl_list2395z00zz__tvectorz00,BgL_funz00_1898);} } } 
{ 
long BgL_iz00_2328;
BgL_iz00_2328 = 
(BgL_iz00_834-((long)1)); 
BgL_iz00_834 = BgL_iz00_2328; 
goto BgL_zc3anonymousza31881ze3z83_835;} } } } } } }  else 
{ /* Llib/tvector.scm 192 */
return 
BGl_errorz00zz__errorz00(BGl_string2389z00zz__tvectorz00, BGl_string2386z00zz__tvectorz00, BgL_idz00_30);} }  else 
{ /* Llib/tvector.scm 188 */
return 
BGl_errorz00zz__errorz00(BGl_string2389z00zz__tvectorz00, BGl_string2387z00zz__tvectorz00, BgL_idz00_30);} } } 
}



/* _vector->tvector */
obj_t BGl__vectorzd2ze3tvectorz31zz__tvectorz00(obj_t BgL_envz00_1815, obj_t BgL_idz00_1816, obj_t BgL_vz00_1817)
{ AN_OBJECT;
{ /* Llib/tvector.scm 186 */
{ /* Llib/tvector.scm 187 */
obj_t BgL_auxz00_2338;obj_t BgL_auxz00_2332;
if(
VECTORP(BgL_vz00_1817))
{ /* Llib/tvector.scm 187 */
BgL_auxz00_2338 = BgL_vz00_1817
; }  else 
{ /* Llib/tvector.scm 187 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2398z00zz__tvectorz00, BGl_string2399z00zz__tvectorz00, BgL_vz00_1817, BGl_string2343z00zz__tvectorz00, 
BINT(((long)7562))); 
exit( -1 );} 
if(
SYMBOLP(BgL_idz00_1816))
{ /* Llib/tvector.scm 187 */
BgL_auxz00_2332 = BgL_idz00_1816
; }  else 
{ /* Llib/tvector.scm 187 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2398z00zz__tvectorz00, BGl_string2346z00zz__tvectorz00, BgL_idz00_1816, BGl_string2343z00zz__tvectorz00, 
BINT(((long)7562))); 
exit( -1 );} 
return 
BGl_vectorzd2ze3tvectorz31zz__tvectorz00(BgL_auxz00_2332, BgL_auxz00_2338);} } 
}



/* tvector->vector */
BGL_EXPORTED_DEF obj_t BGl_tvectorzd2ze3vectorz31zz__tvectorz00(obj_t BgL_tvz00_32)
{ AN_OBJECT;
{ /* Llib/tvector.scm 208 */
{ /* Llib/tvector.scm 209 */
obj_t BgL_descrz00_840;
BgL_descrz00_840 = 
TVECTOR_DESCR(BgL_tvz00_32); 
{ /* Llib/tvector.scm 210 */
obj_t BgL_allocatez00_841;obj_t BgL_refz00_842;
{ /* Llib/tvector.scm 210 */
bool_t BgL_testz00_2346;
{ /* Llib/tvector.scm 210 */
obj_t BgL_auxz00_2347;
{ /* Llib/tvector.scm 210 */
obj_t BgL_res2232z00_1538;
{ /* Llib/tvector.scm 210 */
obj_t BgL_sz00_1537;
if(
STRUCTP(BgL_descrz00_840))
{ /* Llib/tvector.scm 210 */
BgL_sz00_1537 = BgL_descrz00_840; }  else 
{ /* Llib/tvector.scm 210 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2400z00zz__tvectorz00, BGl_string2345z00zz__tvectorz00, BgL_descrz00_840, BGl_string2343z00zz__tvectorz00, 
BINT(((long)8411))); 
exit( -1 );} 
{ /* Llib/tvector.scm 210 */
obj_t BgL_aux2325z00_1907;
BgL_aux2325z00_1907 = 
STRUCT_KEY(BgL_sz00_1537); 
if(
SYMBOLP(BgL_aux2325z00_1907))
{ /* Llib/tvector.scm 210 */
BgL_res2232z00_1538 = BgL_aux2325z00_1907; }  else 
{ /* Llib/tvector.scm 210 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2400z00zz__tvectorz00, BGl_string2346z00zz__tvectorz00, BgL_aux2325z00_1907, BGl_string2343z00zz__tvectorz00, 
BINT(((long)8411))); 
exit( -1 );} } } 
BgL_auxz00_2347 = BgL_res2232z00_1538; } 
BgL_testz00_2346 = 
(BgL_auxz00_2347==BGl_symbol2347z00zz__tvectorz00); } 
if(BgL_testz00_2346)
{ /* Llib/tvector.scm 210 */
int BgL_auxz00_2360;
BgL_auxz00_2360 = 
(int)(((long)1)); 
BgL_allocatez00_841 = 
STRUCT_REF(BgL_descrz00_840, BgL_auxz00_2360); }  else 
{ /* Llib/tvector.scm 210 */
BgL_allocatez00_841 = 
BGl_errorz00zz__errorz00(BGl_string2349z00zz__tvectorz00, BGl_string2348z00zz__tvectorz00, BgL_descrz00_840); } } 
{ /* Llib/tvector.scm 211 */
bool_t BgL_testz00_2364;
{ /* Llib/tvector.scm 211 */
obj_t BgL_auxz00_2365;
{ /* Llib/tvector.scm 211 */
obj_t BgL_res2233z00_1544;
{ /* Llib/tvector.scm 211 */
obj_t BgL_sz00_1543;
if(
STRUCTP(BgL_descrz00_840))
{ /* Llib/tvector.scm 211 */
BgL_sz00_1543 = BgL_descrz00_840; }  else 
{ /* Llib/tvector.scm 211 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2400z00zz__tvectorz00, BGl_string2345z00zz__tvectorz00, BgL_descrz00_840, BGl_string2343z00zz__tvectorz00, 
BINT(((long)8456))); 
exit( -1 );} 
{ /* Llib/tvector.scm 211 */
obj_t BgL_aux2329z00_1911;
BgL_aux2329z00_1911 = 
STRUCT_KEY(BgL_sz00_1543); 
if(
SYMBOLP(BgL_aux2329z00_1911))
{ /* Llib/tvector.scm 211 */
BgL_res2233z00_1544 = BgL_aux2329z00_1911; }  else 
{ /* Llib/tvector.scm 211 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2400z00zz__tvectorz00, BGl_string2346z00zz__tvectorz00, BgL_aux2329z00_1911, BGl_string2343z00zz__tvectorz00, 
BINT(((long)8456))); 
exit( -1 );} } } 
BgL_auxz00_2365 = BgL_res2233z00_1544; } 
BgL_testz00_2364 = 
(BgL_auxz00_2365==BGl_symbol2347z00zz__tvectorz00); } 
if(BgL_testz00_2364)
{ /* Llib/tvector.scm 211 */
int BgL_auxz00_2378;
BgL_auxz00_2378 = 
(int)(((long)2)); 
BgL_refz00_842 = 
STRUCT_REF(BgL_descrz00_840, BgL_auxz00_2378); }  else 
{ /* Llib/tvector.scm 211 */
BgL_refz00_842 = 
BGl_errorz00zz__errorz00(BGl_string2349z00zz__tvectorz00, BGl_string2348z00zz__tvectorz00, BgL_descrz00_840); } } 
if(
PROCEDUREP(BgL_refz00_842))
{ /* Llib/tvector.scm 216 */
int BgL_lenz00_844;
BgL_lenz00_844 = 
TVECTOR_LENGTH(BgL_tvz00_32); 
{ /* Llib/tvector.scm 216 */
obj_t BgL_vecz00_845;
BgL_vecz00_845 = 
create_vector(BgL_lenz00_844); 
{ /* Llib/tvector.scm 217 */

{ /* Llib/tvector.scm 218 */
long BgL_g1771z00_846;
BgL_g1771z00_846 = 
(
(long)(BgL_lenz00_844)-((long)1)); 
{ 
long BgL_iz00_848;
BgL_iz00_848 = BgL_g1771z00_846; 
BgL_zc3anonymousza31887ze3z83_849:
if(
(BgL_iz00_848==((long)-1)))
{ /* Llib/tvector.scm 219 */
return BgL_vecz00_845;}  else 
{ /* Llib/tvector.scm 219 */
{ /* Llib/tvector.scm 222 */
obj_t BgL_arg1889z00_851;
{ /* Llib/tvector.scm 222 */
obj_t BgL_funz00_1915;
BgL_funz00_1915 = BgL_refz00_842; 
if(
PROCEDURE_CORRECT_ARITYP(BgL_funz00_1915, ((long)2)))
{ /* Llib/tvector.scm 222 */
BgL_arg1889z00_851 = 
PROCEDURE_ENTRY(BgL_funz00_1915)(BgL_refz00_842, BgL_tvz00_32, 
BINT(BgL_iz00_848), BEOA); }  else 
{ /* Llib/tvector.scm 222 */
FAILURE(BGl_string2376z00zz__tvectorz00,BGl_list2401z00zz__tvectorz00,BgL_funz00_1915);} } 
{ /* Llib/tvector.scm 222 */
obj_t BgL_vectorz00_1551;int BgL_kz00_1552;obj_t BgL_objz00_1553;
BgL_vectorz00_1551 = BgL_vecz00_845; 
BgL_kz00_1552 = 
(int)(BgL_iz00_848); 
BgL_objz00_1553 = BgL_arg1889z00_851; 
{ /* Llib/tvector.scm 222 */
bool_t BgL_testz00_2397;
{ /* Llib/tvector.scm 222 */
int BgL_arg2102z00_1555;
BgL_arg2102z00_1555 = 
VECTOR_LENGTH(BgL_vectorz00_1551); 
BgL_testz00_2397 = 
BOUND_CHECK(BgL_kz00_1552, BgL_arg2102z00_1555); } 
if(BgL_testz00_2397)
{ /* Llib/tvector.scm 222 */
VECTOR_SET(BgL_vectorz00_1551,BgL_kz00_1552,BgL_objz00_1553); }  else 
{ /* Llib/tvector.scm 222 */
obj_t BgL_arg2094z00_1556;obj_t BgL_arg2095z00_1557;
BgL_arg2094z00_1556 = BGl_symbol2406z00zz__tvectorz00; 
{ /* Llib/tvector.scm 222 */
obj_t BgL_arg2097z00_1559;
{ /* Llib/tvector.scm 222 */
long BgL_arg2099z00_1561;
{ /* Llib/tvector.scm 222 */
int BgL_arg2100z00_1562;
BgL_arg2100z00_1562 = 
VECTOR_LENGTH(BgL_vectorz00_1551); 
BgL_arg2099z00_1561 = 
(
(long)(BgL_arg2100z00_1562)-((long)1)); } 
{ /* Llib/tvector.scm 222 */

BgL_arg2097z00_1559 = 
BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(BgL_arg2099z00_1561, ((long)10)); } } 
BgL_arg2095z00_1557 = 
string_append_3(BGl_string2393z00zz__tvectorz00, BgL_arg2097z00_1559, BGl_string2394z00zz__tvectorz00); } 
BGl_errorz00zz__errorz00(BgL_arg2094z00_1556, BgL_arg2095z00_1557, 
BINT(BgL_kz00_1552)); } } } } 
{ 
long BgL_iz00_2408;
BgL_iz00_2408 = 
(BgL_iz00_848-((long)1)); 
BgL_iz00_848 = BgL_iz00_2408; 
goto BgL_zc3anonymousza31887ze3z83_849;} } } } } } }  else 
{ /* Llib/tvector.scm 213 */
obj_t BgL_arg1893z00_856;
{ /* Llib/tvector.scm 215 */
obj_t BgL_arg1827z00_1573;
BgL_arg1827z00_1573 = 
TVECTOR_DESCR(BgL_tvz00_32); 
{ /* Llib/tvector.scm 215 */
bool_t BgL_testz00_2411;
{ /* Llib/tvector.scm 215 */
obj_t BgL_auxz00_2412;
{ /* Llib/tvector.scm 215 */
obj_t BgL_res2234z00_1579;
{ /* Llib/tvector.scm 215 */
obj_t BgL_sz00_1578;
if(
STRUCTP(BgL_arg1827z00_1573))
{ /* Llib/tvector.scm 215 */
BgL_sz00_1578 = BgL_arg1827z00_1573; }  else 
{ /* Llib/tvector.scm 215 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2400z00zz__tvectorz00, BGl_string2345z00zz__tvectorz00, BgL_arg1827z00_1573, BGl_string2343z00zz__tvectorz00, 
BINT(((long)8590))); 
exit( -1 );} 
{ /* Llib/tvector.scm 215 */
obj_t BgL_aux2337z00_1920;
BgL_aux2337z00_1920 = 
STRUCT_KEY(BgL_sz00_1578); 
if(
SYMBOLP(BgL_aux2337z00_1920))
{ /* Llib/tvector.scm 215 */
BgL_res2234z00_1579 = BgL_aux2337z00_1920; }  else 
{ /* Llib/tvector.scm 215 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2400z00zz__tvectorz00, BGl_string2346z00zz__tvectorz00, BgL_aux2337z00_1920, BGl_string2343z00zz__tvectorz00, 
BINT(((long)8590))); 
exit( -1 );} } } 
BgL_auxz00_2412 = BgL_res2234z00_1579; } 
BgL_testz00_2411 = 
(BgL_auxz00_2412==BGl_symbol2347z00zz__tvectorz00); } 
if(BgL_testz00_2411)
{ /* Llib/tvector.scm 215 */
int BgL_auxz00_2425;
BgL_auxz00_2425 = 
(int)(((long)0)); 
BgL_arg1893z00_856 = 
STRUCT_REF(BgL_arg1827z00_1573, BgL_auxz00_2425); }  else 
{ /* Llib/tvector.scm 215 */
BgL_arg1893z00_856 = 
BGl_errorz00zz__errorz00(BGl_string2349z00zz__tvectorz00, BGl_string2348z00zz__tvectorz00, BgL_arg1827z00_1573); } } } 
return 
BGl_errorz00zz__errorz00(BGl_string2400z00zz__tvectorz00, BGl_string2386z00zz__tvectorz00, BgL_arg1893z00_856);} } } } 
}



/* _tvector->vector */
obj_t BGl__tvectorzd2ze3vectorz31zz__tvectorz00(obj_t BgL_envz00_1818, obj_t BgL_tvz00_1819)
{ AN_OBJECT;
{ /* Llib/tvector.scm 208 */
{ /* Llib/tvector.scm 209 */
obj_t BgL_auxz00_2430;
if(
TVECTORP(BgL_tvz00_1819))
{ /* Llib/tvector.scm 209 */
BgL_auxz00_2430 = BgL_tvz00_1819
; }  else 
{ /* Llib/tvector.scm 209 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string2408z00zz__tvectorz00, BGl_string2342z00zz__tvectorz00, BgL_tvz00_1819, BGl_string2343z00zz__tvectorz00, 
BINT(((long)8355))); 
exit( -1 );} 
return 
BGl_tvectorzd2ze3vectorz31zz__tvectorz00(BgL_auxz00_2430);} } 
}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__tvectorz00()
{ AN_OBJECT;
{ /* Llib/tvector.scm 14 */
return BUNSPEC;} 
}



/* method-init */
obj_t BGl_methodzd2initzd2zz__tvectorz00()
{ AN_OBJECT;
{ /* Llib/tvector.scm 14 */
return BUNSPEC;} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__tvectorz00()
{ AN_OBJECT;
{ /* Llib/tvector.scm 14 */
BGl_modulezd2initializa7ationz75zz__errorz00(((long)68033950), 
BSTRING_TO_STRING(BGl_string2409z00zz__tvectorz00)); 
BGl_modulezd2initializa7ationz75zz__hashz00(((long)81619416), 
BSTRING_TO_STRING(BGl_string2409z00zz__tvectorz00)); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)484239619), 
BSTRING_TO_STRING(BGl_string2409z00zz__tvectorz00)); 
BGl_modulezd2initializa7ationz75zz__paramz00(((long)327583589), 
BSTRING_TO_STRING(BGl_string2409z00zz__tvectorz00)); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)3491337), 
BSTRING_TO_STRING(BGl_string2409z00zz__tvectorz00)); 
BGl_modulezd2initializa7ationz75zz__bignumz00(((long)318625392), 
BSTRING_TO_STRING(BGl_string2409z00zz__tvectorz00)); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)429190545), 
BSTRING_TO_STRING(BGl_string2409z00zz__tvectorz00)); 
return 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)500588328), 
BSTRING_TO_STRING(BGl_string2409z00zz__tvectorz00));} 
}

#ifdef __cplusplus
}
#endif
