/*===========================================================================*/
/*   (Llib/bigloo.scm)                                                       */
/*   Bigloo (3.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jul 1 12:14:45 CEST 2010        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -srfi enable-gmp -srfi bigloo-unsafe -O3 -q +rm -lib-dir /users/serrano/prgm/project/bigloo/lib/3.4a -mklib -cc gcc -fsharing -q -no-hello -copt -fPIC -unsafe -safee -O4 -c Llib/bigloo.scm -indent -o objs/obj_u/Llib/bigloo.c)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__configurez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_symbol2337z00zz__biglooz00 = BUNSPEC;
	extern obj_t bgl_bmem_reset();
	BGL_EXPORTED_DECL bool_t BGl_opaquezf3zf3zz__biglooz00(obj_t);
	extern obj_t make_string(long, unsigned char);
	static obj_t BGl_toplevelzd2initzd2zz__biglooz00();
	static obj_t BGl_symbol2369z00zz__biglooz00 = BUNSPEC;
	BGL_EXPORTED_DECL bool_t bigloo_class_mangledp(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_opaquezd2nilzd2zz__biglooz00();
	BGL_EXPORTED_DECL obj_t BGl_procedurezd2attrzd2zz__biglooz00(obj_t);
	extern obj_t bstring_to_symbol(obj_t);
	static obj_t BGl__bigloozd2classzd2mangledzf3zf3zz__biglooz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zz__biglooz00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t bgl_exit_mutex();
	extern obj_t string_append(obj_t, obj_t);
	static obj_t BGl__bigloozd2exitzd2applyz00zz__biglooz00(obj_t, obj_t);
	static obj_t BGl__bigloozd2mangledzf3z21zz__biglooz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t bigloo_mangle(obj_t);
	static obj_t BGl__timez00zz__biglooz00(obj_t, obj_t);
	static long BGl_manglezd2atz12zc0zz__biglooz00(obj_t, obj_t, long, long);
	extern obj_t blit_string(obj_t, long, obj_t, long, long);
	static obj_t BGl__procedurezd2arityzd2zz__biglooz00(obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zz__biglooz00();
	extern obj_t c_substring(obj_t, long, long);
	BGL_EXPORTED_DECL obj_t bigloo_demangle(obj_t);
	extern obj_t string_to_bstring(char *);
	extern bool_t bigloo_strcmp(obj_t, obj_t);
	static obj_t BGl_za2releaseza2z00zz__biglooz00 = BUNSPEC;
	extern bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
	static obj_t BGl__bmemzd2resetz12zc0zz__biglooz00(obj_t);
	static obj_t BGl__registerzd2exitzd2functionz12z12zz__biglooz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t bigloo_module_mangle(obj_t, obj_t);
	static obj_t BGl__opaquezd2nilzd2zz__biglooz00(obj_t);
	static obj_t BGl_za2bigloozd2exitzd2functionsza2z00zz__biglooz00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t bigloo_class_demangle(obj_t);
	static obj_t BGl_za2modulesza2z00zz__biglooz00 = BUNSPEC;
	extern obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
	static obj_t BGl__checkzd2versionz12zc0zz__biglooz00(obj_t, obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_procedurezd2attrzd2setz12z12zz__biglooz00(obj_t,
		obj_t);
	static obj_t BGl__unspecifiedz00zz__biglooz00(obj_t);
	static obj_t BGl__bigloozd2modulezd2manglez00zz__biglooz00(obj_t, obj_t,
		obj_t);
	static long BGl_charzd2ze3digitz31zz__biglooz00(unsigned char);
	static obj_t BGl__procedurezd2attrzd2setz12z12zz__biglooz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl__bigloozd2classzd2demanglez00zz__biglooz00(obj_t, obj_t);
	BGL_EXPORTED_DECL bool_t BGl_cnstzf3zf3zz__biglooz00(obj_t);
	static obj_t BGl_cnstzd2initzd2zz__biglooz00();
	static obj_t BGl__bigloozd2exitzd2mutexz00zz__biglooz00(obj_t);
	static obj_t BGl_za2levelza2z00zz__biglooz00 = BUNSPEC;
	static obj_t BGl__bigloozd2demanglezd2zz__biglooz00(obj_t, obj_t);
	static obj_t BGl__procedurezd2attrzd2zz__biglooz00(obj_t, obj_t);
	static long BGl_getzd28bitszd2integerz00zz__biglooz00(obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zz__biglooz00();
	BGL_EXPORTED_DECL obj_t
		BGl_registerzd2exitzd2functionz12z12zz__biglooz00(obj_t);
	extern obj_t BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_bmemzd2resetz12zc0zz__biglooz00();
	extern obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_za2exitzd2mutexza2zd2zz__biglooz00 = BUNSPEC;
	static obj_t BGl_bigloozd2demanglezd2atz00zz__biglooz00(obj_t, long, obj_t);
	BGL_EXPORTED_DECL obj_t bigloo_exit_apply(obj_t);
	BGL_EXPORTED_DECL bool_t
		BGl_bigloozd2needzd2manglingzf3zf3zz__biglooz00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_timez00zz__biglooz00(obj_t);
	BGL_EXPORTED_DECL bool_t bigloo_mangledp(obj_t);
	extern bool_t bigloo_strncmp(obj_t, obj_t, long);
	BGL_EXPORTED_DECL obj_t BGl_unspecifiedz00zz__biglooz00();
	static obj_t BGl__bigloozd2needzd2manglingzf3zf3zz__biglooz00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zz__biglooz00();
	static obj_t BGl__cnstzf3zf3zz__biglooz00(obj_t, obj_t);
	BGL_EXPORTED_DECL int BGl_procedurezd2arityzd2zz__biglooz00(obj_t);
	static obj_t BGl__opaquezf3zf3zz__biglooz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_checkzd2versionz12zc0zz__biglooz00(obj_t, char *,
		obj_t);
	static obj_t BGl__bigloozd2manglezd2zz__biglooz00(obj_t, obj_t);
	static obj_t *__cnst;


	   
		 
		DEFINE_STRING(BGl_string2365z00zz__biglooz00,
		BgL_bgl_string2365za700za7za7_2373za7, "_bigloo-class-demangle", 22);
	      DEFINE_STRING(BGl_string2366z00zz__biglooz00,
		BgL_bgl_string2366za700za7za7_2374za7, "bigloo-exit-register!", 21);
	      DEFINE_STRING(BGl_string2367z00zz__biglooz00,
		BgL_bgl_string2367za700za7za7_2375za7, "Wrong procedure arity", 21);
	      DEFINE_STRING(BGl_string2368z00zz__biglooz00,
		BgL_bgl_string2368za700za7za7_2376za7, "_register-exit-function!", 24);
	      DEFINE_STRING(BGl_string2370z00zz__biglooz00,
		BgL_bgl_string2370za700za7za7_2377za7, "time", 4);
	      DEFINE_STRING(BGl_string2371z00zz__biglooz00,
		BgL_bgl_string2371za700za7za7_2378za7, "_time", 5);
	      DEFINE_STRING(BGl_string2372z00zz__biglooz00,
		BgL_bgl_string2372za700za7za7_2379za7, "__bigloo", 8);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_bigloozd2classzd2demanglezd2envzd2zz__biglooz00,
		BgL_bgl__biglooza7d2classza72380z00,
		BGl__bigloozd2classzd2demanglez00zz__biglooz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_bmemzd2resetz12zd2envz12zz__biglooz00,
		BgL_bgl__bmemza7d2resetza7122381z00, BGl__bmemzd2resetz12zc0zz__biglooz00,
		0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_bigloozd2modulezd2manglezd2envzd2zz__biglooz00,
		BgL_bgl__biglooza7d2module2382za7,
		BGl__bigloozd2modulezd2manglez00zz__biglooz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_procedurezd2attrzd2setz12zd2envzc0zz__biglooz00,
		BgL_bgl__procedureza7d2att2383za7,
		BGl__procedurezd2attrzd2setz12z12zz__biglooz00, 0L, BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_unspecifiedzd2envzd2zz__biglooz00,
		BgL_bgl__unspecifiedza700za72384z00, BGl__unspecifiedz00zz__biglooz00, 0L,
		BUNSPEC, 0);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_opaquezf3zd2envz21zz__biglooz00,
		BgL_bgl__opaqueza7f3za7f3za7za7_2385z00, BGl__opaquezf3zf3zz__biglooz00, 0L,
		BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_bigloozd2exitzd2mutexzd2envzd2zz__biglooz00,
		BgL_bgl__biglooza7d2exitza7d2386z00,
		BGl__bigloozd2exitzd2mutexz00zz__biglooz00, 0L, BUNSPEC, 0);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_procedurezd2arityzd2envz00zz__biglooz00,
		BgL_bgl__procedureza7d2ari2387za7, BGl__procedurezd2arityzd2zz__biglooz00,
		0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_bigloozd2exitzd2applyzd2envzd2zz__biglooz00,
		BgL_bgl__biglooza7d2exitza7d2388z00,
		BGl__bigloozd2exitzd2applyz00zz__biglooz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_bigloozd2needzd2manglingzf3zd2envz21zz__biglooz00,
		BgL_bgl__biglooza7d2needza7d2389z00,
		BGl__bigloozd2needzd2manglingzf3zf3zz__biglooz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_cnstzf3zd2envz21zz__biglooz00,
		BgL_bgl__cnstza7f3za7f3za7za7__b2390z00, BGl__cnstzf3zf3zz__biglooz00, 0L,
		BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_bigloozd2manglezd2envz00zz__biglooz00,
		BgL_bgl__biglooza7d2mangle2391za7, BGl__bigloozd2manglezd2zz__biglooz00, 0L,
		BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_bigloozd2mangledzf3zd2envzf3zz__biglooz00,
		BgL_bgl__biglooza7d2mangle2392za7, BGl__bigloozd2mangledzf3z21zz__biglooz00,
		0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_procedurezd2attrzd2envz00zz__biglooz00,
		BgL_bgl__procedureza7d2att2393za7, BGl__procedurezd2attrzd2zz__biglooz00,
		0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_bigloozd2classzd2mangledzf3zd2envz21zz__biglooz00,
		BgL_bgl__biglooza7d2classza72394z00,
		BGl__bigloozd2classzd2mangledzf3zf3zz__biglooz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_opaquezd2nilzd2envz00zz__biglooz00,
		BgL_bgl__opaqueza7d2nilza7d22395z00, BGl__opaquezd2nilzd2zz__biglooz00, 0L,
		BUNSPEC, 0);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_timezd2envzd2zz__biglooz00,
		BgL_bgl__timeza700za7za7__bigl2396za7, BGl__timez00zz__biglooz00, 0L,
		BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_checkzd2versionz12zd2envz12zz__biglooz00,
		BgL_bgl__checkza7d2version2397za7, BGl__checkzd2versionz12zc0zz__biglooz00,
		0L, BUNSPEC, 3);
	extern obj_t BGl_stringzd2envzd2zz__r4_strings_6_7z00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_bigloozd2demanglezd2envz00zz__biglooz00,
		BgL_bgl__biglooza7d2demang2398za7, BGl__bigloozd2demanglezd2zz__biglooz00,
		0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2338z00zz__biglooz00,
		BgL_bgl_string2338za700za7za7_2399za7, "bigloo-exit", 11);
	      DEFINE_STRING(BGl_string2340z00zz__biglooz00,
		BgL_bgl_string2340za700za7za7_2400za7,
		"Some modules have been compiled by: ", 36);
	      DEFINE_STRING(BGl_string2339z00zz__biglooz00,
		BgL_bgl_string2339za700za7za7_2401za7, " (level 0)", 10);
	      DEFINE_STRING(BGl_string2341z00zz__biglooz00,
		BgL_bgl_string2341za700za7za7_2402za7, "and other by: ", 14);
	      DEFINE_STRING(BGl_string2342z00zz__biglooz00,
		BgL_bgl_string2342za700za7za7_2403za7, "_check-version!", 15);
	      DEFINE_STRING(BGl_string2343z00zz__biglooz00,
		BgL_bgl_string2343za700za7za7_2404za7, "string", 6);
	      DEFINE_STRING(BGl_string2344z00zz__biglooz00,
		BgL_bgl_string2344za700za7za7_2405za7,
		"/tmp/bigloo/runtime/Llib/bigloo.scm", 35);
	      DEFINE_STRING(BGl_string2345z00zz__biglooz00,
		BgL_bgl_string2345za700za7za7_2406za7, "_procedure-arity", 16);
	      DEFINE_STRING(BGl_string2346z00zz__biglooz00,
		BgL_bgl_string2346za700za7za7_2407za7, "procedure", 9);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_registerzd2exitzd2functionz12zd2envzc0zz__biglooz00,
		BgL_bgl__registerza7d2exit2408za7,
		BGl__registerzd2exitzd2functionz12z12zz__biglooz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2347z00zz__biglooz00,
		BgL_bgl_string2347za700za7za7_2409za7, "_procedure-attr", 15);
	      DEFINE_STRING(BGl_string2348z00zz__biglooz00,
		BgL_bgl_string2348za700za7za7_2410za7, "_procedure-attr-set!", 20);
	      DEFINE_STRING(BGl_string2350z00zz__biglooz00,
		BgL_bgl_string2350za700za7za7_2411za7, "bigloo-mangle-string", 20);
	      DEFINE_STRING(BGl_string2349z00zz__biglooz00,
		BgL_bgl_string2349za700za7za7_2412za7, "0123456789abcdef", 16);
	      DEFINE_STRING(BGl_string2351z00zz__biglooz00,
		BgL_bgl_string2351za700za7za7_2413za7, "Can't mangle empty string", 25);
	      DEFINE_STRING(BGl_string2352z00zz__biglooz00,
		BgL_bgl_string2352za700za7za7_2414za7, "BgL_", 4);
	      DEFINE_STRING(BGl_string2353z00zz__biglooz00,
		BgL_bgl_string2353za700za7za7_2415za7, "_bigloo-mangle", 14);
	      DEFINE_STRING(BGl_string2354z00zz__biglooz00,
		BgL_bgl_string2354za700za7za7_2416za7, "bstring", 7);
	      DEFINE_STRING(BGl_string2355z00zz__biglooz00,
		BgL_bgl_string2355za700za7za7_2417za7, "BGl_", 4);
	      DEFINE_STRING(BGl_string2356z00zz__biglooz00,
		BgL_bgl_string2356za700za7za7_2418za7, "_bigloo-module-mangle", 21);
	      DEFINE_STRING(BGl_string2357z00zz__biglooz00,
		BgL_bgl_string2357za700za7za7_2419za7, "_bigloo-mangled?", 16);
	      DEFINE_STRING(BGl_string2358z00zz__biglooz00,
		BgL_bgl_string2358za700za7za7_2420za7, "_bigloo-need-mangling?", 22);
	      DEFINE_STRING(BGl_string2360z00zz__biglooz00,
		BgL_bgl_string2360za700za7za7_2421za7, "Not a Bigloo mangled identifier",
		31);
	      DEFINE_STRING(BGl_string2359z00zz__biglooz00,
		BgL_bgl_string2359za700za7za7_2422za7, "bigloo-demangle", 15);
	      DEFINE_STRING(BGl_string2361z00zz__biglooz00,
		BgL_bgl_string2361za700za7za7_2423za7, "Illegal mangling on", 19);
	      DEFINE_STRING(BGl_string2362z00zz__biglooz00,
		BgL_bgl_string2362za700za7za7_2424za7, "_bigloo-demangle", 16);
	      DEFINE_STRING(BGl_string2363z00zz__biglooz00,
		BgL_bgl_string2363za700za7za7_2425za7, "_bigloo-class-mangled?", 22);
	      DEFINE_STRING(BGl_string2364z00zz__biglooz00,
		BgL_bgl_string2364za700za7za7_2426za7, "_bglt", 5);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long
		BgL_checksumz00_2142, char *BgL_fromz00_2143)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zz__biglooz00))
				{
					BGl_requirezd2initializa7ationz75zz__biglooz00 = BBOOL(((bool_t) 0));
					BGl_cnstzd2initzd2zz__biglooz00();
					BGl_importedzd2moduleszd2initz00zz__biglooz00();
					BGl_toplevelzd2initzd2zz__biglooz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zz__biglooz00()
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 14 */
			BGl_symbol2337z00zz__biglooz00 =
				bstring_to_symbol(BGl_string2338z00zz__biglooz00);
			return (BGl_symbol2369z00zz__biglooz00 =
				bstring_to_symbol(BGl_string2370z00zz__biglooz00), BUNSPEC);
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zz__biglooz00()
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 14 */
			BGl_za2releaseza2z00zz__biglooz00 = BFALSE;
			BGl_za2levelza2z00zz__biglooz00 = BFALSE;
			BGl_za2modulesza2z00zz__biglooz00 = BNIL;
			BGl_za2exitzd2mutexza2zd2zz__biglooz00 =
				bgl_make_mutex(BGl_symbol2337z00zz__biglooz00);
			return (BGl_za2bigloozd2exitzd2functionsza2z00zz__biglooz00 =
				BNIL, BUNSPEC);
		}
	}



/* check-version! */
	BGL_EXPORTED_DEF obj_t BGl_checkzd2versionz12zc0zz__biglooz00(obj_t
		BgL_modulez00_1, char *BgL_releasez00_2, obj_t BgL_levelz00_3)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 333 */
			if (STRINGP(BGl_za2releaseza2z00zz__biglooz00))
				{	/* Llib/bigloo.scm 339 */
					bool_t BgL_testz00_2155;

					{	/* Llib/bigloo.scm 339 */
						bool_t BgL_testz00_2156;

						{	/* Llib/bigloo.scm 339 */
							long BgL_minz00_797;

							{	/* Llib/bigloo.scm 339 */
								long BgL_arg1865z00_801;

								{	/* Llib/bigloo.scm 339 */
									long BgL_xz00_803;

									long BgL_yz00_804;

									BgL_xz00_803 =
										STRING_LENGTH(string_to_bstring(BgL_releasez00_2));
									BgL_yz00_804 =
										STRING_LENGTH(BGl_za2releaseza2z00zz__biglooz00);
									if ((BgL_xz00_803 < BgL_yz00_804))
										{	/* Llib/bigloo.scm 339 */
											BgL_arg1865z00_801 = BgL_xz00_803;
										}
									else
										{	/* Llib/bigloo.scm 339 */
											BgL_arg1865z00_801 = BgL_yz00_804;
										}
								}
								BgL_minz00_797 = (BgL_arg1865z00_801 - ((long) 1));
							}
							if (bigloo_strcmp(c_substring(string_to_bstring(BgL_releasez00_2),
										((long) 0), BgL_minz00_797),
									c_substring(BGl_za2releaseza2z00zz__biglooz00, ((long) 0),
										BgL_minz00_797)))
								{	/* Llib/bigloo.scm 342 */
									BgL_testz00_2156 = ((bool_t) 0);
								}
							else
								{	/* Llib/bigloo.scm 342 */
									BgL_testz00_2156 = ((bool_t) 1);
								}
						}
						if (BgL_testz00_2156)
							{	/* Llib/bigloo.scm 339 */
								BgL_testz00_2155 = ((bool_t) 1);
							}
						else
							{	/* Llib/bigloo.scm 339 */
								if (CHARP(BgL_levelz00_3))
									{	/* Llib/bigloo.scm 344 */
										if (CHARP(BGl_za2levelza2z00zz__biglooz00))
											{	/* Llib/bigloo.scm 344 */
												if (
													(CCHAR(BGl_za2levelza2z00zz__biglooz00) ==
														CCHAR(BgL_levelz00_3)))
													{	/* Llib/bigloo.scm 344 */
														BgL_testz00_2155 = ((bool_t) 0);
													}
												else
													{	/* Llib/bigloo.scm 344 */
														BgL_testz00_2155 = ((bool_t) 1);
													}
											}
										else
											{	/* Llib/bigloo.scm 344 */
												BgL_testz00_2155 = ((bool_t) 0);
											}
									}
								else
									{	/* Llib/bigloo.scm 344 */
										BgL_testz00_2155 = ((bool_t) 0);
									}
							}
					}
					if (BgL_testz00_2155)
						{	/* Llib/bigloo.scm 351 */
							obj_t BgL_arg1851z00_780;

							obj_t BgL_arg1852z00_781;

							obj_t BgL_arg1853z00_782;

							{	/* Llib/bigloo.scm 351 */
								obj_t BgL_arg1855z00_784;

								{	/* Llib/bigloo.scm 352 */
									obj_t BgL_releasez00_1512;

									obj_t BgL_levelz00_1513;

									BgL_releasez00_1512 = BGl_za2releaseza2z00zz__biglooz00;
									BgL_levelz00_1513 = BGl_za2levelza2z00zz__biglooz00;
									if (CHARP(BgL_levelz00_1513))
										{	/* Llib/bigloo.scm 352 */
											obj_t BgL_sz00_1515;

											BgL_sz00_1515 =
												BGl_stringzd2copyzd2zz__r4_strings_6_7z00
												(BGl_string2339z00zz__biglooz00);
											{	/* Llib/bigloo.scm 352 */
												unsigned char BgL_auxz00_2179;

												BgL_auxz00_2179 = CCHAR(BgL_levelz00_1513);
												STRING_SET(BgL_sz00_1515, ((long) 8), BgL_auxz00_2179);
											}
											BgL_arg1855z00_784 =
												string_append(BgL_releasez00_1512, BgL_sz00_1515);
										}
									else
										{	/* Llib/bigloo.scm 352 */
											BgL_arg1855z00_784 = BgL_releasez00_1512;
										}
								}
								BgL_arg1851z00_780 =
									string_append(BGl_string2340z00zz__biglooz00,
									BgL_arg1855z00_784);
							}
							{	/* Llib/bigloo.scm 353 */
								obj_t BgL_arg1857z00_786;

								if (CHARP(BgL_levelz00_3))
									{	/* Llib/bigloo.scm 354 */
										obj_t BgL_sz00_1523;

										BgL_sz00_1523 =
											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
											(BGl_string2339z00zz__biglooz00);
										{	/* Llib/bigloo.scm 354 */
											unsigned char BgL_auxz00_2187;

											BgL_auxz00_2187 = CCHAR(BgL_levelz00_3);
											STRING_SET(BgL_sz00_1523, ((long) 8), BgL_auxz00_2187);
										}
										BgL_arg1857z00_786 =
											string_append(string_to_bstring(BgL_releasez00_2),
											BgL_sz00_1523);
									}
								else
									{	/* Llib/bigloo.scm 354 */
										BgL_arg1857z00_786 = string_to_bstring(BgL_releasez00_2);
									}
								BgL_arg1852z00_781 =
									string_append(BGl_string2341z00zz__biglooz00,
									BgL_arg1857z00_786);
							}
							BgL_arg1853z00_782 =
								MAKE_PAIR(BgL_modulez00_1, BGl_za2modulesza2z00zz__biglooz00);
							return
								BGl_errorz00zz__errorz00(BgL_arg1851z00_780, BgL_arg1852z00_781,
								BgL_arg1853z00_782);
						}
					else
						{	/* Llib/bigloo.scm 339 */
							return (BGl_za2modulesza2z00zz__biglooz00 =
								MAKE_PAIR(BgL_modulez00_1, BGl_za2modulesza2z00zz__biglooz00),
								BUNSPEC);
						}
				}
			else
				{	/* Llib/bigloo.scm 335 */
					{	/* Llib/bigloo.scm 336 */
						obj_t BgL_list1868z00_806;

						BgL_list1868z00_806 = MAKE_PAIR(BgL_modulez00_1, BNIL);
						BGl_za2modulesza2z00zz__biglooz00 = BgL_list1868z00_806;
					}
					BGl_za2releaseza2z00zz__biglooz00 =
						string_to_bstring(BgL_releasez00_2);
					return (BGl_za2levelza2z00zz__biglooz00 = BgL_levelz00_3, BUNSPEC);
				}
		}
	}



/* _check-version! */
	obj_t BGl__checkzd2versionz12zc0zz__biglooz00(obj_t BgL_envz00_2062,
		obj_t BgL_modulez00_2063, obj_t BgL_releasez00_2064,
		obj_t BgL_levelz00_2065)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 333 */
			{	/* Llib/bigloo.scm 335 */
				char *BgL_auxz00_2199;

				{	/* Llib/bigloo.scm 335 */
					obj_t BgL_auxz00_2200;

					if (STRINGP(BgL_releasez00_2064))
						{	/* Llib/bigloo.scm 335 */
							BgL_auxz00_2200 = BgL_releasez00_2064;
						}
					else
						{	/* Llib/bigloo.scm 335 */
							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
								(BGl_string2342z00zz__biglooz00, BGl_string2343z00zz__biglooz00,
								BgL_releasez00_2064, BGl_string2344z00zz__biglooz00,
								BINT(((long) 11784)));
							exit(-1);
						}
					BgL_auxz00_2199 = BSTRING_TO_STRING(BgL_auxz00_2200);
				}
				return
					BGl_checkzd2versionz12zc0zz__biglooz00(BgL_modulez00_2063,
					BgL_auxz00_2199, BgL_levelz00_2065);
			}
		}
	}



/* procedure-arity */
	BGL_EXPORTED_DEF int BGl_procedurezd2arityzd2zz__biglooz00(obj_t
		BgL_procz00_4)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 369 */
			return PROCEDURE_ARITY(BgL_procz00_4);
		}
	}



/* _procedure-arity */
	obj_t BGl__procedurezd2arityzd2zz__biglooz00(obj_t BgL_envz00_2066,
		obj_t BgL_procz00_2067)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 369 */
			{	/* Llib/bigloo.scm 370 */
				int BgL_auxz00_2209;

				{	/* Llib/bigloo.scm 370 */
					obj_t BgL_procz00_2136;

					if (PROCEDUREP(BgL_procz00_2067))
						{	/* Llib/bigloo.scm 370 */
							BgL_procz00_2136 = BgL_procz00_2067;
						}
					else
						{	/* Llib/bigloo.scm 370 */
							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
								(BGl_string2345z00zz__biglooz00, BGl_string2346z00zz__biglooz00,
								BgL_procz00_2067, BGl_string2344z00zz__biglooz00,
								BINT(((long) 13200)));
							exit(-1);
						}
					BgL_auxz00_2209 = PROCEDURE_ARITY(BgL_procz00_2136);
				}
				return BINT(BgL_auxz00_2209);
			}
		}
	}



/* procedure-attr */
	BGL_EXPORTED_DEF obj_t BGl_procedurezd2attrzd2zz__biglooz00(obj_t
		BgL_procz00_5)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 375 */
			return PROCEDURE_ATTR(BgL_procz00_5);
		}
	}



/* _procedure-attr */
	obj_t BGl__procedurezd2attrzd2zz__biglooz00(obj_t BgL_envz00_2068,
		obj_t BgL_procz00_2069)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 375 */
			{	/* Llib/bigloo.scm 376 */
				obj_t BgL_procz00_2137;

				if (PROCEDUREP(BgL_procz00_2069))
					{	/* Llib/bigloo.scm 376 */
						BgL_procz00_2137 = BgL_procz00_2069;
					}
				else
					{	/* Llib/bigloo.scm 376 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string2347z00zz__biglooz00, BGl_string2346z00zz__biglooz00,
							BgL_procz00_2069, BGl_string2344z00zz__biglooz00,
							BINT(((long) 13488)));
						exit(-1);
					}
				return PROCEDURE_ATTR(BgL_procz00_2137);
			}
		}
	}



/* procedure-attr-set! */
	BGL_EXPORTED_DEF obj_t BGl_procedurezd2attrzd2setz12z12zz__biglooz00(obj_t
		BgL_procz00_6, obj_t BgL_objz00_7)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 381 */
			PROCEDURE_ATTR_SET(BgL_procz00_6, BgL_objz00_7);
			return BgL_objz00_7;
		}
	}



/* _procedure-attr-set! */
	obj_t BGl__procedurezd2attrzd2setz12z12zz__biglooz00(obj_t BgL_envz00_2070,
		obj_t BgL_procz00_2071, obj_t BgL_objz00_2072)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 381 */
			{	/* Llib/bigloo.scm 383 */
				obj_t BgL_procz00_2138;

				if (PROCEDUREP(BgL_procz00_2071))
					{	/* Llib/bigloo.scm 383 */
						BgL_procz00_2138 = BgL_procz00_2071;
					}
				else
					{	/* Llib/bigloo.scm 383 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string2348z00zz__biglooz00, BGl_string2346z00zz__biglooz00,
							BgL_procz00_2071, BGl_string2344z00zz__biglooz00,
							BINT(((long) 13819)));
						exit(-1);
					}
				PROCEDURE_ATTR_SET(BgL_procz00_2138, BgL_objz00_2072);
				return BgL_objz00_2072;
			}
		}
	}



/* unspecified */
	BGL_EXPORTED_DEF obj_t BGl_unspecifiedz00zz__biglooz00()
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 388 */
			return BUNSPEC;
		}
	}



/* _unspecified */
	obj_t BGl__unspecifiedz00zz__biglooz00(obj_t BgL_envz00_2073)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 388 */
			return BUNSPEC;
		}
	}



/* cnst? */
	BGL_EXPORTED_DEF bool_t BGl_cnstzf3zf3zz__biglooz00(obj_t BgL_objz00_8)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 394 */
			return CNSTP(BgL_objz00_8);
		}
	}



/* _cnst? */
	obj_t BGl__cnstzf3zf3zz__biglooz00(obj_t BgL_envz00_2074,
		obj_t BgL_objz00_2075)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 394 */
			return BBOOL(CNSTP(BgL_objz00_2075));
		}
	}



/* opaque? */
	BGL_EXPORTED_DEF bool_t BGl_opaquezf3zf3zz__biglooz00(obj_t BgL_objz00_9)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 400 */
			return OPAQUEP(BgL_objz00_9);
		}
	}



/* _opaque? */
	obj_t BGl__opaquezf3zf3zz__biglooz00(obj_t BgL_envz00_2076,
		obj_t BgL_objz00_2077)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 400 */
			return BBOOL(OPAQUEP(BgL_objz00_2077));
		}
	}



/* opaque-nil */
	BGL_EXPORTED_DEF obj_t BGl_opaquezd2nilzd2zz__biglooz00()
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 406 */
			return BGL_OPAQUE_NIL();
		}
	}



/* _opaque-nil */
	obj_t BGl__opaquezd2nilzd2zz__biglooz00(obj_t BgL_envz00_2078)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 406 */
			return BGL_OPAQUE_NIL();
		}
	}



/* mangle-at! */
	long BGl_manglezd2atz12zc0zz__biglooz00(obj_t BgL_newz00_11,
		obj_t BgL_oldz00_12, long BgL_lenz00_13, long BgL_offsetz00_14)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 419 */
			{
				long BgL_rz00_809;

				long BgL_wz00_810;

				long BgL_newzd2lenzd2_811;

				long BgL_checksumz00_812;

				BgL_rz00_809 = ((long) 0);
				BgL_wz00_810 = BgL_offsetz00_14;
				BgL_newzd2lenzd2_811 = BgL_offsetz00_14;
				BgL_checksumz00_812 = ((long) 0);
			BgL_zc3anonymousza31869ze3z83_813:
				if ((BgL_rz00_809 == BgL_lenz00_13))
					{	/* Llib/bigloo.scm 424 */
						STRING_SET(BgL_newz00_11, BgL_wz00_810, ((unsigned char) 'z'));
						{	/* Llib/bigloo.scm 427 */
							unsigned char BgL_auxz00_2244;

							long BgL_auxz00_2242;

							BgL_auxz00_2244 =
								STRING_REF(BGl_string2349z00zz__biglooz00,
								(BgL_checksumz00_812 & ((long) 15)));
							BgL_auxz00_2242 = (BgL_wz00_810 + ((long) 1));
							STRING_SET(BgL_newz00_11, BgL_auxz00_2242, BgL_auxz00_2244);
						}
						{	/* Llib/bigloo.scm 430 */
							unsigned char BgL_auxz00_2250;

							long BgL_auxz00_2248;

							BgL_auxz00_2250 =
								STRING_REF(BGl_string2349z00zz__biglooz00,
								((BgL_checksumz00_812 >> (int) (((long) 4))) & ((long) 15)));
							BgL_auxz00_2248 = (BgL_wz00_810 + ((long) 2));
							STRING_SET(BgL_newz00_11, BgL_auxz00_2248, BgL_auxz00_2250);
						}
						return (BgL_wz00_810 + ((long) 3));
					}
				else
					{	/* Llib/bigloo.scm 434 */
						unsigned char BgL_cz00_823;

						BgL_cz00_823 = STRING_REF(BgL_oldz00_12, BgL_rz00_809);
						{	/* Llib/bigloo.scm 435 */
							bool_t BgL_testz00_2258;

							{	/* Llib/bigloo.scm 435 */
								bool_t BgL_testz00_2259;

								if (isalpha(BgL_cz00_823))
									{	/* Llib/bigloo.scm 435 */
										if ((BgL_cz00_823 == ((unsigned char) 'z')))
											{	/* Llib/bigloo.scm 435 */
												BgL_testz00_2259 = ((bool_t) 0);
											}
										else
											{	/* Llib/bigloo.scm 435 */
												BgL_testz00_2259 = ((bool_t) 1);
											}
									}
								else
									{	/* Llib/bigloo.scm 435 */
										BgL_testz00_2259 = ((bool_t) 0);
									}
								if (BgL_testz00_2259)
									{	/* Llib/bigloo.scm 435 */
										BgL_testz00_2258 = ((bool_t) 1);
									}
								else
									{	/* Llib/bigloo.scm 435 */
										if (isdigit(BgL_cz00_823))
											{	/* Llib/bigloo.scm 436 */
												BgL_testz00_2258 = ((bool_t) 1);
											}
										else
											{	/* Llib/bigloo.scm 436 */
												BgL_testz00_2258 =
													(BgL_cz00_823 == ((unsigned char) '_'));
							}}}
							if (BgL_testz00_2258)
								{	/* Llib/bigloo.scm 435 */
									STRING_SET(BgL_newz00_11, BgL_wz00_810, BgL_cz00_823);
									{
										long BgL_newzd2lenzd2_2272;

										long BgL_wz00_2270;

										long BgL_rz00_2268;

										BgL_rz00_2268 = (BgL_rz00_809 + ((long) 1));
										BgL_wz00_2270 = (BgL_wz00_810 + ((long) 1));
										BgL_newzd2lenzd2_2272 = (BgL_newzd2lenzd2_811 + ((long) 1));
										BgL_newzd2lenzd2_811 = BgL_newzd2lenzd2_2272;
										BgL_wz00_810 = BgL_wz00_2270;
										BgL_rz00_809 = BgL_rz00_2268;
										goto BgL_zc3anonymousza31869ze3z83_813;
									}
								}
							else
								{	/* Llib/bigloo.scm 444 */
									long BgL_icz00_828;

									BgL_icz00_828 = (BgL_cz00_823);
									STRING_SET(BgL_newz00_11, BgL_wz00_810,
										((unsigned char) 'z'));
									{	/* Llib/bigloo.scm 446 */
										unsigned char BgL_auxz00_2278;

										long BgL_auxz00_2276;

										BgL_auxz00_2278 =
											STRING_REF(BGl_string2349z00zz__biglooz00,
											(BgL_icz00_828 & ((long) 15)));
										BgL_auxz00_2276 = (BgL_wz00_810 + ((long) 1));
										STRING_SET(BgL_newz00_11, BgL_auxz00_2276, BgL_auxz00_2278);
									}
									{	/* Llib/bigloo.scm 449 */
										unsigned char BgL_auxz00_2284;

										long BgL_auxz00_2282;

										BgL_auxz00_2284 =
											STRING_REF(BGl_string2349z00zz__biglooz00,
											((BgL_icz00_828 >> (int) (((long) 4))) & ((long) 15)));
										BgL_auxz00_2282 = (BgL_wz00_810 + ((long) 2));
										STRING_SET(BgL_newz00_11, BgL_auxz00_2282, BgL_auxz00_2284);
									}
									{
										long BgL_checksumz00_2296;

										long BgL_newzd2lenzd2_2294;

										long BgL_wz00_2292;

										long BgL_rz00_2290;

										BgL_rz00_2290 = (BgL_rz00_809 + ((long) 1));
										BgL_wz00_2292 = (BgL_wz00_810 + ((long) 3));
										BgL_newzd2lenzd2_2294 = (BgL_newzd2lenzd2_811 + ((long) 3));
										BgL_checksumz00_2296 =
											(BgL_checksumz00_812 ^ (BgL_cz00_823));
										BgL_checksumz00_812 = BgL_checksumz00_2296;
										BgL_newzd2lenzd2_811 = BgL_newzd2lenzd2_2294;
										BgL_wz00_810 = BgL_wz00_2292;
										BgL_rz00_809 = BgL_rz00_2290;
										goto BgL_zc3anonymousza31869ze3z83_813;
									}
								}
						}
					}
			}
		}
	}



/* bigloo-mangle */
	BGL_EXPORTED_DEF obj_t bigloo_mangle(obj_t BgL_stringz00_15)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 460 */
			{	/* Llib/bigloo.scm 461 */
				long BgL_lenz00_847;

				BgL_lenz00_847 = STRING_LENGTH(BgL_stringz00_15);
				{	/* Llib/bigloo.scm 461 */
					obj_t BgL_newz00_848;

					BgL_newz00_848 =
						make_string(
						((BgL_lenz00_847 * ((long) 3)) + ((long) 7)),
						((unsigned char) ' '));
					{	/* Llib/bigloo.scm 462 */

						if ((BgL_lenz00_847 == ((long) 0)))
							{	/* Llib/bigloo.scm 463 */
								return
									BGl_errorz00zz__errorz00(BGl_string2350z00zz__biglooz00,
									BGl_string2351z00zz__biglooz00, BgL_stringz00_15);
							}
						else
							{	/* Llib/bigloo.scm 465 */
								long BgL_stopz00_850;

								BgL_stopz00_850 =
									BGl_manglezd2atz12zc0zz__biglooz00(BgL_newz00_848,
									BgL_stringz00_15, BgL_lenz00_847, ((long) 4));
								blit_string(BGl_string2352z00zz__biglooz00, ((long) 0),
									BgL_newz00_848, ((long) 0), ((long) 4));
								return c_substring(BgL_newz00_848, ((long) 0), BgL_stopz00_850);
		}}}}}
	}



/* _bigloo-mangle */
	obj_t BGl__bigloozd2manglezd2zz__biglooz00(obj_t BgL_envz00_2079,
		obj_t BgL_stringz00_2080)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 460 */
			{	/* Llib/bigloo.scm 461 */
				obj_t BgL_auxz00_2309;

				if (STRINGP(BgL_stringz00_2080))
					{	/* Llib/bigloo.scm 461 */
						BgL_auxz00_2309 = BgL_stringz00_2080;
					}
				else
					{	/* Llib/bigloo.scm 461 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string2353z00zz__biglooz00, BGl_string2354z00zz__biglooz00,
							BgL_stringz00_2080, BGl_string2344z00zz__biglooz00,
							BINT(((long) 16663)));
						exit(-1);
					}
				return bigloo_mangle(BgL_auxz00_2309);
			}
		}
	}



/* bigloo-module-mangle */
	BGL_EXPORTED_DEF obj_t bigloo_module_mangle(obj_t BgL_idz00_16,
		obj_t BgL_modulez00_17)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 472 */
			{	/* Llib/bigloo.scm 473 */
				long BgL_lenz00_855;

				BgL_lenz00_855 =
					(STRING_LENGTH(BgL_idz00_16) + STRING_LENGTH(BgL_modulez00_17));
				{	/* Llib/bigloo.scm 473 */
					obj_t BgL_newz00_856;

					BgL_newz00_856 =
						make_string(
						((BgL_lenz00_855 * ((long) 3)) + ((long) 12)),
						((unsigned char) ' '));
					{	/* Llib/bigloo.scm 474 */

						if ((BgL_lenz00_855 == ((long) 0)))
							{	/* Llib/bigloo.scm 475 */
								return
									BGl_errorz00zz__errorz00(BGl_string2350z00zz__biglooz00,
									BGl_string2351z00zz__biglooz00,
									BGl_stringzd2envzd2zz__r4_strings_6_7z00);
							}
						else
							{	/* Llib/bigloo.scm 477 */
								long BgL_modzd2startzd2_858;

								BgL_modzd2startzd2_858 =
									BGl_manglezd2atz12zc0zz__biglooz00(BgL_newz00_856,
									BgL_idz00_16, STRING_LENGTH(BgL_idz00_16), ((long) 4));
								STRING_SET(BgL_newz00_856, BgL_modzd2startzd2_858,
									((unsigned char) 'z'));
								{	/* Llib/bigloo.scm 479 */
									long BgL_auxz00_2328;

									BgL_auxz00_2328 = (((long) 1) + BgL_modzd2startzd2_858);
									STRING_SET(BgL_newz00_856, BgL_auxz00_2328,
										((unsigned char) 'z'));
								}
								{	/* Llib/bigloo.scm 480 */
									long BgL_stopz00_860;

									BgL_stopz00_860 =
										BGl_manglezd2atz12zc0zz__biglooz00(BgL_newz00_856,
										BgL_modulez00_17, STRING_LENGTH(BgL_modulez00_17),
										(BgL_modzd2startzd2_858 + ((long) 2)));
									blit_string(BGl_string2355z00zz__biglooz00, ((long) 0),
										BgL_newz00_856, ((long) 0), ((long) 4));
									return c_substring(BgL_newz00_856, ((long) 0),
										BgL_stopz00_860);
		}}}}}}
	}



/* _bigloo-module-mangle */
	obj_t BGl__bigloozd2modulezd2manglez00zz__biglooz00(obj_t BgL_envz00_2081,
		obj_t BgL_idz00_2082, obj_t BgL_modulez00_2083)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 472 */
			{	/* Llib/bigloo.scm 473 */
				obj_t BgL_auxz00_2342;

				obj_t BgL_auxz00_2336;

				if (STRINGP(BgL_modulez00_2083))
					{	/* Llib/bigloo.scm 473 */
						BgL_auxz00_2342 = BgL_modulez00_2083;
					}
				else
					{	/* Llib/bigloo.scm 473 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string2356z00zz__biglooz00, BGl_string2354z00zz__biglooz00,
							BgL_modulez00_2083, BGl_string2344z00zz__biglooz00,
							BINT(((long) 17219)));
						exit(-1);
					}
				if (STRINGP(BgL_idz00_2082))
					{	/* Llib/bigloo.scm 473 */
						BgL_auxz00_2336 = BgL_idz00_2082;
					}
				else
					{	/* Llib/bigloo.scm 473 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string2356z00zz__biglooz00, BGl_string2354z00zz__biglooz00,
							BgL_idz00_2082, BGl_string2344z00zz__biglooz00,
							BINT(((long) 17219)));
						exit(-1);
					}
				return bigloo_module_mangle(BgL_auxz00_2336, BgL_auxz00_2342);
			}
		}
	}



/* bigloo-mangled? */
	BGL_EXPORTED_DEF bool_t bigloo_mangledp(obj_t BgL_stringz00_18)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 489 */
			{	/* Llib/bigloo.scm 490 */
				long BgL_lenz00_871;

				BgL_lenz00_871 = STRING_LENGTH(BgL_stringz00_18);
				if ((BgL_lenz00_871 > ((long) 7)))
					{	/* Llib/bigloo.scm 492 */
						bool_t BgL_testz00_2352;

						{	/* Llib/bigloo.scm 492 */
							bool_t BgL__ortest_1775z00_888;

							BgL__ortest_1775z00_888 =
								bigloo_strncmp(BgL_stringz00_18, BGl_string2352z00zz__biglooz00,
								((long) 4));
							if (BgL__ortest_1775z00_888)
								{	/* Llib/bigloo.scm 492 */
									BgL_testz00_2352 = BgL__ortest_1775z00_888;
								}
							else
								{	/* Llib/bigloo.scm 492 */
									BgL_testz00_2352 =
										bigloo_strncmp(BgL_stringz00_18,
										BGl_string2355z00zz__biglooz00, ((long) 4));
						}}
						if (BgL_testz00_2352)
							{	/* Llib/bigloo.scm 492 */
								if (
									(STRING_REF(BgL_stringz00_18,
											(BgL_lenz00_871 - ((long) 3))) == ((unsigned char) 'z')))
									{	/* Llib/bigloo.scm 495 */
										bool_t BgL_testz00_2360;

										{	/* Llib/bigloo.scm 495 */
											bool_t BgL__ortest_1776z00_881;

											{	/* Llib/bigloo.scm 495 */
												unsigned char BgL_auxz00_2361;

												BgL_auxz00_2361 =
													STRING_REF(BgL_stringz00_18,
													(BgL_lenz00_871 - ((long) 2)));
												BgL__ortest_1776z00_881 = isalpha(BgL_auxz00_2361);
											}
											if (BgL__ortest_1776z00_881)
												{	/* Llib/bigloo.scm 495 */
													BgL_testz00_2360 = BgL__ortest_1776z00_881;
												}
											else
												{	/* Llib/bigloo.scm 496 */
													unsigned char BgL_auxz00_2366;

													BgL_auxz00_2366 =
														STRING_REF(BgL_stringz00_18,
														(BgL_lenz00_871 - ((long) 2)));
													BgL_testz00_2360 = isdigit(BgL_auxz00_2366);
										}}
										if (BgL_testz00_2360)
											{	/* Llib/bigloo.scm 497 */
												bool_t BgL__ortest_1777z00_876;

												{	/* Llib/bigloo.scm 497 */
													unsigned char BgL_auxz00_2370;

													BgL_auxz00_2370 =
														STRING_REF(BgL_stringz00_18,
														(BgL_lenz00_871 - ((long) 1)));
													BgL__ortest_1777z00_876 = isalpha(BgL_auxz00_2370);
												}
												if (BgL__ortest_1777z00_876)
													{	/* Llib/bigloo.scm 497 */
														return BgL__ortest_1777z00_876;
													}
												else
													{	/* Llib/bigloo.scm 498 */
														unsigned char BgL_auxz00_2375;

														BgL_auxz00_2375 =
															STRING_REF(BgL_stringz00_18,
															(BgL_lenz00_871 - ((long) 1)));
														return isdigit(BgL_auxz00_2375);
													}
											}
										else
											{	/* Llib/bigloo.scm 495 */
												return ((bool_t) 0);
											}
									}
								else
									{	/* Llib/bigloo.scm 494 */
										return ((bool_t) 0);
									}
							}
						else
							{	/* Llib/bigloo.scm 492 */
								return ((bool_t) 0);
							}
					}
				else
					{	/* Llib/bigloo.scm 491 */
						return ((bool_t) 0);
					}
			}
		}
	}



/* _bigloo-mangled? */
	obj_t BGl__bigloozd2mangledzf3z21zz__biglooz00(obj_t BgL_envz00_2086,
		obj_t BgL_stringz00_2087)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 489 */
			{	/* Llib/bigloo.scm 490 */
				bool_t BgL_auxz00_2379;

				{	/* Llib/bigloo.scm 490 */
					obj_t BgL_auxz00_2380;

					if (STRINGP(BgL_stringz00_2087))
						{	/* Llib/bigloo.scm 490 */
							BgL_auxz00_2380 = BgL_stringz00_2087;
						}
					else
						{	/* Llib/bigloo.scm 490 */
							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
								(BGl_string2357z00zz__biglooz00, BGl_string2354z00zz__biglooz00,
								BgL_stringz00_2087, BGl_string2344z00zz__biglooz00,
								BINT(((long) 17989)));
							exit(-1);
						}
					BgL_auxz00_2379 = bigloo_mangledp(BgL_auxz00_2380);
				}
				return BBOOL(BgL_auxz00_2379);
			}
		}
	}



/* bigloo-need-mangling? */
	BGL_EXPORTED_DEF bool_t BGl_bigloozd2needzd2manglingzf3zf3zz__biglooz00(obj_t
		BgL_stringz00_19)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 503 */
			{	/* Llib/bigloo.scm 504 */
				long BgL_lenz00_889;

				BgL_lenz00_889 = STRING_LENGTH(BgL_stringz00_19);
				if ((BgL_lenz00_889 > ((long) 0)))
					{	/* Llib/bigloo.scm 506 */
						bool_t BgL__ortest_1779z00_891;

						{	/* Llib/bigloo.scm 506 */
							bool_t BgL_testz00_2391;

							{	/* Llib/bigloo.scm 506 */
								bool_t BgL_testz00_2392;

								{	/* Llib/bigloo.scm 506 */
									unsigned char BgL_auxz00_2393;

									BgL_auxz00_2393 = STRING_REF(BgL_stringz00_19, ((long) 0));
									BgL_testz00_2392 = isalpha(BgL_auxz00_2393);
								}
								if (BgL_testz00_2392)
									{	/* Llib/bigloo.scm 506 */
										BgL_testz00_2391 = ((bool_t) 1);
									}
								else
									{	/* Llib/bigloo.scm 506 */
										BgL_testz00_2391 =
											(STRING_REF(BgL_stringz00_19,
												((long) 0)) == ((unsigned char) '_'));
							}}
							if (BgL_testz00_2391)
								{	/* Llib/bigloo.scm 506 */
									BgL__ortest_1779z00_891 = ((bool_t) 0);
								}
							else
								{	/* Llib/bigloo.scm 506 */
									BgL__ortest_1779z00_891 = ((bool_t) 1);
								}
						}
						if (BgL__ortest_1779z00_891)
							{	/* Llib/bigloo.scm 506 */
								return BgL__ortest_1779z00_891;
							}
						else
							{
								long BgL_iz00_893;

								BgL_iz00_893 = ((long) 1);
							BgL_zc3anonymousza31932ze3z83_894:
								if ((BgL_iz00_893 >= BgL_lenz00_889))
									{	/* Llib/bigloo.scm 509 */
										return ((bool_t) 0);
									}
								else
									{	/* Llib/bigloo.scm 511 */
										unsigned char BgL_cz00_896;

										BgL_cz00_896 = STRING_REF(BgL_stringz00_19, BgL_iz00_893);
										{	/* Llib/bigloo.scm 512 */
											bool_t BgL_testz00_2402;

											if (isalpha(BgL_cz00_896))
												{	/* Llib/bigloo.scm 512 */
													BgL_testz00_2402 = ((bool_t) 1);
												}
											else
												{	/* Llib/bigloo.scm 512 */
													if (isdigit(BgL_cz00_896))
														{	/* Llib/bigloo.scm 513 */
															BgL_testz00_2402 = ((bool_t) 1);
														}
													else
														{	/* Llib/bigloo.scm 513 */
															BgL_testz00_2402 =
																(BgL_cz00_896 == ((unsigned char) '_'));
												}}
											if (BgL_testz00_2402)
												{
													long BgL_iz00_2408;

													BgL_iz00_2408 = (BgL_iz00_893 + ((long) 1));
													BgL_iz00_893 = BgL_iz00_2408;
													goto BgL_zc3anonymousza31932ze3z83_894;
												}
											else
												{	/* Llib/bigloo.scm 512 */
													return ((bool_t) 1);
												}
										}
									}
							}
					}
				else
					{	/* Llib/bigloo.scm 505 */
						return ((bool_t) 0);
					}
			}
		}
	}



/* _bigloo-need-mangling? */
	obj_t BGl__bigloozd2needzd2manglingzf3zf3zz__biglooz00(obj_t BgL_envz00_2088,
		obj_t BgL_stringz00_2089)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 503 */
			{	/* Llib/bigloo.scm 504 */
				bool_t BgL_auxz00_2410;

				{	/* Llib/bigloo.scm 504 */
					obj_t BgL_auxz00_2411;

					if (STRINGP(BgL_stringz00_2089))
						{	/* Llib/bigloo.scm 504 */
							BgL_auxz00_2411 = BgL_stringz00_2089;
						}
					else
						{	/* Llib/bigloo.scm 504 */
							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
								(BGl_string2358z00zz__biglooz00, BGl_string2354z00zz__biglooz00,
								BgL_stringz00_2089, BGl_string2344z00zz__biglooz00,
								BINT(((long) 18674)));
							exit(-1);
						}
					BgL_auxz00_2410 =
						BGl_bigloozd2needzd2manglingzf3zf3zz__biglooz00(BgL_auxz00_2411);
				}
				return BBOOL(BgL_auxz00_2410);
			}
		}
	}



/* bigloo-demangle */
	BGL_EXPORTED_DEF obj_t bigloo_demangle(obj_t BgL_stringz00_20)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 521 */
			{	/* Llib/bigloo.scm 522 */
				long BgL_lenz00_906;

				BgL_lenz00_906 = STRING_LENGTH(BgL_stringz00_20);
				{	/* Llib/bigloo.scm 522 */
					long BgL_clenz00_907;

					BgL_clenz00_907 = (BgL_lenz00_906 - ((long) 3));
					{	/* Llib/bigloo.scm 523 */

						{

							if ((BgL_lenz00_906 < ((long) 8)))
								{	/* Llib/bigloo.scm 572 */
									return
										BGl_errorz00zz__errorz00(BGl_string2359z00zz__biglooz00,
										BGl_string2360z00zz__biglooz00, BgL_stringz00_20);
								}
							else
								{	/* Llib/bigloo.scm 572 */
									if (bigloo_strncmp(BgL_stringz00_20,
											BGl_string2352z00zz__biglooz00, ((long) 4)))
										{	/* Llib/bigloo.scm 574 */
											{	/* Llib/bigloo.scm 562 */
												obj_t BgL_strz00_925;

												BgL_strz00_925 =
													BGl_bigloozd2demanglezd2atz00zz__biglooz00
													(BgL_stringz00_20, BgL_clenz00_907, BINT(((long) 4)));
												{	/* Llib/bigloo.scm 564 */
													obj_t BgL_offsetz00_926;

													{	/* Llib/bigloo.scm 564 */
														int BgL_auxz00_2428;

														BgL_auxz00_2428 = (int) (((long) 1));
														BgL_offsetz00_926 =
															BGL_MVALUES_VAL(BgL_auxz00_2428);
													}
													{	/* Llib/bigloo.scm 564 */
														int BgL_auxz00_2431;

														BgL_auxz00_2431 = (int) (((long) 2));
														BGL_MVALUES_NUMBER_SET(BgL_auxz00_2431);
													}
													{	/* Llib/bigloo.scm 564 */
														int BgL_auxz00_2434;

														BgL_auxz00_2434 = (int) (((long) 1));
														BGL_MVALUES_VAL_SET(BgL_auxz00_2434, BUNSPEC);
													}
													return BgL_strz00_925;
												}
											}
										}
									else
										{	/* Llib/bigloo.scm 574 */
											if (bigloo_strncmp(BgL_stringz00_20,
													BGl_string2355z00zz__biglooz00, ((long) 4)))
												{	/* Llib/bigloo.scm 576 */
													{	/* Llib/bigloo.scm 566 */
														obj_t BgL_idz00_918;

														BgL_idz00_918 =
															BGl_bigloozd2demanglezd2atz00zz__biglooz00
															(BgL_stringz00_20, BgL_clenz00_907,
															BINT(((long) 4)));
														{	/* Llib/bigloo.scm 568 */
															obj_t BgL_offsetz00_919;

															{	/* Llib/bigloo.scm 568 */
																int BgL_auxz00_2441;

																BgL_auxz00_2441 = (int) (((long) 1));
																BgL_offsetz00_919 =
																	BGL_MVALUES_VAL(BgL_auxz00_2441);
															}
															{	/* Llib/bigloo.scm 568 */
																obj_t BgL_modulez00_920;

																BgL_modulez00_920 =
																	BGl_bigloozd2demanglezd2atz00zz__biglooz00
																	(BgL_stringz00_20, BgL_clenz00_907,
																	BgL_offsetz00_919);
																{	/* Llib/bigloo.scm 570 */
																	obj_t BgL_offsetz00_921;

																	{	/* Llib/bigloo.scm 570 */
																		int BgL_auxz00_2445;

																		BgL_auxz00_2445 = (int) (((long) 1));
																		BgL_offsetz00_921 =
																			BGL_MVALUES_VAL(BgL_auxz00_2445);
																	}
																	{	/* Llib/bigloo.scm 570 */
																		int BgL_auxz00_2448;

																		BgL_auxz00_2448 = (int) (((long) 2));
																		BGL_MVALUES_NUMBER_SET(BgL_auxz00_2448);
																	}
																	{	/* Llib/bigloo.scm 570 */
																		int BgL_auxz00_2451;

																		BgL_auxz00_2451 = (int) (((long) 1));
																		BGL_MVALUES_VAL_SET(BgL_auxz00_2451,
																			BgL_modulez00_920);
																	}
																	return BgL_idz00_918;
																}
															}
														}
													}
												}
											else
												{	/* Llib/bigloo.scm 576 */
													return BgL_stringz00_20;
												}
										}
								}
						}
					}
				}
			}
		}
	}



/* bigloo-demangle-at */
	obj_t BGl_bigloozd2demanglezd2atz00zz__biglooz00(obj_t BgL_stringz00_2105,
		long BgL_clenz00_2104, obj_t BgL_offsetz00_929)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 560 */
			{	/* Llib/bigloo.scm 537 */
				obj_t BgL_newz00_931;

				BgL_newz00_931 = make_string(BgL_clenz00_2104, ((unsigned char) ' '));
				{
					obj_t BgL_rz00_933;

					long BgL_wz00_934;

					long BgL_checksumz00_935;

					BgL_rz00_933 = BgL_offsetz00_929;
					BgL_wz00_934 = ((long) 0);
					BgL_checksumz00_935 = ((long) 0);
				BgL_zc3anonymousza31949ze3z83_936:
					if (((long) CINT(BgL_rz00_933) == BgL_clenz00_2104))
						{	/* Llib/bigloo.scm 541 */
							if (
								(BgL_checksumz00_935 ==
									BGl_getzd28bitszd2integerz00zz__biglooz00(BgL_stringz00_2105,
										BgL_rz00_933)))
								{	/* Llib/bigloo.scm 544 */
									obj_t BgL_val0_1810z00_939;

									long BgL_val1_1811z00_940;

									BgL_val0_1810z00_939 =
										c_substring(BgL_newz00_931, ((long) 0), BgL_wz00_934);
									BgL_val1_1811z00_940 =
										((long) CINT(BgL_rz00_933) + ((long) 3));
									{	/* Llib/bigloo.scm 544 */
										int BgL_auxz00_2464;

										BgL_auxz00_2464 = (int) (((long) 2));
										BGL_MVALUES_NUMBER_SET(BgL_auxz00_2464);
									}
									{	/* Llib/bigloo.scm 544 */
										obj_t BgL_auxz00_2469;

										int BgL_auxz00_2467;

										BgL_auxz00_2469 = BINT(BgL_val1_1811z00_940);
										BgL_auxz00_2467 = (int) (((long) 1));
										BGL_MVALUES_VAL_SET(BgL_auxz00_2467, BgL_auxz00_2469);
									}
									return BgL_val0_1810z00_939;
								}
							else
								{	/* Llib/bigloo.scm 543 */
									return
										BGl_errorz00zz__errorz00(BGl_string2359z00zz__biglooz00,
										BGl_string2361z00zz__biglooz00, BgL_stringz00_2105);
								}
						}
					else
						{	/* Llib/bigloo.scm 546 */
							unsigned char BgL_cz00_942;

							BgL_cz00_942 =
								STRING_REF(BgL_stringz00_2105, (long) CINT(BgL_rz00_933));
							if ((BgL_cz00_942 == ((unsigned char) 'z')))
								{	/* Llib/bigloo.scm 547 */
									if (
										(STRING_REF(BgL_stringz00_2105,
												((long) CINT(BgL_rz00_933) + ((long) 1))) ==
											((unsigned char) 'z')))
										{	/* Llib/bigloo.scm 549 */
											obj_t BgL_val0_1812z00_945;

											long BgL_val1_1813z00_946;

											BgL_val0_1812z00_945 =
												c_substring(BgL_newz00_931, ((long) 0),
												(BgL_wz00_934 - ((long) 1)));
											BgL_val1_1813z00_946 =
												((long) CINT(BgL_rz00_933) + ((long) 2));
											{	/* Llib/bigloo.scm 549 */
												int BgL_auxz00_2486;

												BgL_auxz00_2486 = (int) (((long) 2));
												BGL_MVALUES_NUMBER_SET(BgL_auxz00_2486);
											}
											{	/* Llib/bigloo.scm 549 */
												obj_t BgL_auxz00_2491;

												int BgL_auxz00_2489;

												BgL_auxz00_2491 = BINT(BgL_val1_1813z00_946);
												BgL_auxz00_2489 = (int) (((long) 1));
												BGL_MVALUES_VAL_SET(BgL_auxz00_2489, BgL_auxz00_2491);
											}
											return BgL_val0_1812z00_945;
										}
									else
										{	/* Llib/bigloo.scm 550 */
											long BgL_iz00_949;

											BgL_iz00_949 =
												BGl_getzd28bitszd2integerz00zz__biglooz00
												(BgL_stringz00_2105, BgL_rz00_933);
											{	/* Llib/bigloo.scm 550 */
												unsigned char BgL_ncz00_950;

												BgL_ncz00_950 = (BgL_iz00_949);
												{	/* Llib/bigloo.scm 551 */

													STRING_SET(BgL_newz00_931, BgL_wz00_934,
														BgL_ncz00_950);
													{	/* Llib/bigloo.scm 553 */
														long BgL_arg1957z00_951;

														long BgL_arg1958z00_952;

														long BgL_arg1959z00_953;

														BgL_arg1957z00_951 =
															((long) CINT(BgL_rz00_933) + ((long) 3));
														BgL_arg1958z00_952 = (BgL_wz00_934 + ((long) 1));
														BgL_arg1959z00_953 =
															(BgL_checksumz00_935 ^ BgL_iz00_949);
														{
															long BgL_checksumz00_2504;

															long BgL_wz00_2503;

															obj_t BgL_rz00_2501;

															BgL_rz00_2501 = BINT(BgL_arg1957z00_951);
															BgL_wz00_2503 = BgL_arg1958z00_952;
															BgL_checksumz00_2504 = BgL_arg1959z00_953;
															BgL_checksumz00_935 = BgL_checksumz00_2504;
															BgL_wz00_934 = BgL_wz00_2503;
															BgL_rz00_933 = BgL_rz00_2501;
															goto BgL_zc3anonymousza31949ze3z83_936;
														}
													}
												}
											}
										}
								}
							else
								{	/* Llib/bigloo.scm 547 */
									STRING_SET(BgL_newz00_931, BgL_wz00_934, BgL_cz00_942);
									{	/* Llib/bigloo.scm 558 */
										long BgL_arg1962z00_956;

										long BgL_arg1963z00_957;

										BgL_arg1962z00_956 =
											((long) CINT(BgL_rz00_933) + ((long) 1));
										BgL_arg1963z00_957 = (BgL_wz00_934 + ((long) 1));
										{
											long BgL_wz00_2511;

											obj_t BgL_rz00_2509;

											BgL_rz00_2509 = BINT(BgL_arg1962z00_956);
											BgL_wz00_2511 = BgL_arg1963z00_957;
											BgL_wz00_934 = BgL_wz00_2511;
											BgL_rz00_933 = BgL_rz00_2509;
											goto BgL_zc3anonymousza31949ze3z83_936;
										}
									}
								}
						}
				}
			}
		}
	}



/* get-8bits-integer */
	long BGl_getzd28bitszd2integerz00zz__biglooz00(obj_t BgL_stringz00_2106,
		obj_t BgL_rz00_960)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 535 */
			{	/* Llib/bigloo.scm 534 */

				return
					(BGl_charzd2ze3digitz31zz__biglooz00(STRING_REF(BgL_stringz00_2106,
							((long) CINT(BgL_rz00_960) + ((long) 1)))) +
					(BGl_charzd2ze3digitz31zz__biglooz00(STRING_REF(BgL_stringz00_2106,
								((long) CINT(BgL_rz00_960) + ((long) 2)))) <<
						(int) (((long) 4))));
		}}
	}



/* char->digit */
	long BGl_charzd2ze3digitz31zz__biglooz00(unsigned char BgL_cz00_969)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 529 */
			if (isdigit(BgL_cz00_969))
				{	/* Llib/bigloo.scm 527 */
					return ((BgL_cz00_969) - ((long) 48));
				}
			else
				{	/* Llib/bigloo.scm 527 */
					return (((long) 10) + ((BgL_cz00_969) - ((long) 97)));
		}}
	}



/* _bigloo-demangle */
	obj_t BGl__bigloozd2demanglezd2zz__biglooz00(obj_t BgL_envz00_2090,
		obj_t BgL_stringz00_2091)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 521 */
			{	/* Llib/bigloo.scm 522 */
				obj_t BgL_auxz00_2530;

				if (STRINGP(BgL_stringz00_2091))
					{	/* Llib/bigloo.scm 522 */
						BgL_auxz00_2530 = BgL_stringz00_2091;
					}
				else
					{	/* Llib/bigloo.scm 522 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string2362z00zz__biglooz00, BGl_string2354z00zz__biglooz00,
							BgL_stringz00_2091, BGl_string2344z00zz__biglooz00,
							BINT(((long) 19317)));
						exit(-1);
					}
				return bigloo_demangle(BgL_auxz00_2530);
			}
		}
	}



/* bigloo-class-mangled? */
	BGL_EXPORTED_DEF bool_t bigloo_class_mangledp(obj_t BgL_stringz00_21)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 584 */
			{	/* Llib/bigloo.scm 585 */
				long BgL_lenz00_985;

				BgL_lenz00_985 = STRING_LENGTH(BgL_stringz00_21);
				if ((BgL_lenz00_985 > ((long) 8)))
					{	/* Llib/bigloo.scm 586 */
						if (
							(STRING_REF(BgL_stringz00_21,
									(BgL_lenz00_985 - ((long) 1))) == ((unsigned char) 't')))
							{	/* Llib/bigloo.scm 587 */
								if (
									(STRING_REF(BgL_stringz00_21,
											(BgL_lenz00_985 - ((long) 2))) == ((unsigned char) 'l')))
									{	/* Llib/bigloo.scm 588 */
										if (
											(STRING_REF(BgL_stringz00_21,
													(BgL_lenz00_985 - ((long) 3))) ==
												((unsigned char) 'g')))
											{	/* Llib/bigloo.scm 589 */
												if (
													(STRING_REF(BgL_stringz00_21,
															(BgL_lenz00_985 - ((long) 4))) ==
														((unsigned char) 'b')))
													{	/* Llib/bigloo.scm 590 */
														if (
															(STRING_REF(BgL_stringz00_21,
																	(BgL_lenz00_985 - ((long) 5))) ==
																((unsigned char) '_')))
															{	/* Llib/bigloo.scm 591 */
																return
																	bigloo_mangledp(c_substring(BgL_stringz00_21,
																		((long) 0), (BgL_lenz00_985 - ((long) 5))));
															}
														else
															{	/* Llib/bigloo.scm 591 */
																return ((bool_t) 0);
															}
													}
												else
													{	/* Llib/bigloo.scm 590 */
														return ((bool_t) 0);
													}
											}
										else
											{	/* Llib/bigloo.scm 589 */
												return ((bool_t) 0);
											}
									}
								else
									{	/* Llib/bigloo.scm 588 */
										return ((bool_t) 0);
									}
							}
						else
							{	/* Llib/bigloo.scm 587 */
								return ((bool_t) 0);
							}
					}
				else
					{	/* Llib/bigloo.scm 586 */
						return ((bool_t) 0);
					}
			}
		}
	}



/* _bigloo-class-mangled? */
	obj_t BGl__bigloozd2classzd2mangledzf3zf3zz__biglooz00(obj_t BgL_envz00_2092,
		obj_t BgL_stringz00_2093)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 584 */
			{	/* Llib/bigloo.scm 585 */
				bool_t BgL_auxz00_2563;

				{	/* Llib/bigloo.scm 585 */
					obj_t BgL_auxz00_2564;

					if (STRINGP(BgL_stringz00_2093))
						{	/* Llib/bigloo.scm 585 */
							BgL_auxz00_2564 = BgL_stringz00_2093;
						}
					else
						{	/* Llib/bigloo.scm 585 */
							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
								(BGl_string2363z00zz__biglooz00, BGl_string2354z00zz__biglooz00,
								BgL_stringz00_2093, BGl_string2344z00zz__biglooz00,
								BINT(((long) 21451)));
							exit(-1);
						}
					BgL_auxz00_2563 = bigloo_class_mangledp(BgL_auxz00_2564);
				}
				return BBOOL(BgL_auxz00_2563);
			}
		}
	}



/* bigloo-class-demangle */
	BGL_EXPORTED_DEF obj_t bigloo_class_demangle(obj_t BgL_stringz00_22)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 597 */
			return
				string_append(bigloo_demangle(c_substring(BgL_stringz00_22, ((long) 0),
						(STRING_LENGTH(BgL_stringz00_22) - ((long) 5)))),
				BGl_string2364z00zz__biglooz00);
		}
	}



/* _bigloo-class-demangle */
	obj_t BGl__bigloozd2classzd2demanglez00zz__biglooz00(obj_t BgL_envz00_2094,
		obj_t BgL_stringz00_2095)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 597 */
			{	/* Llib/bigloo.scm 599 */
				obj_t BgL_auxz00_2577;

				if (STRINGP(BgL_stringz00_2095))
					{	/* Llib/bigloo.scm 599 */
						BgL_auxz00_2577 = BgL_stringz00_2095;
					}
				else
					{	/* Llib/bigloo.scm 599 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string2365z00zz__biglooz00, BGl_string2354z00zz__biglooz00,
							BgL_stringz00_2095, BGl_string2344z00zz__biglooz00,
							BINT(((long) 22118)));
						exit(-1);
					}
				return bigloo_class_demangle(BgL_auxz00_2577);
			}
		}
	}



/* bigloo-exit-mutex */
	BGL_EXPORTED_DEF obj_t bgl_exit_mutex()
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 610 */
			return BGl_za2exitzd2mutexza2zd2zz__biglooz00;
		}
	}



/* _bigloo-exit-mutex */
	obj_t BGl__bigloozd2exitzd2mutexz00zz__biglooz00(obj_t BgL_envz00_2096)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 610 */
			return BGl_za2exitzd2mutexza2zd2zz__biglooz00;
		}
	}



/* register-exit-function! */
	BGL_EXPORTED_DEF obj_t BGl_registerzd2exitzd2functionz12z12zz__biglooz00(obj_t
		BgL_funz00_23)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 621 */
			{	/* Llib/bigloo.scm 622 */
				obj_t BgL_arg2000z00_1012;

				BgL_arg2000z00_1012 = BGl_za2exitzd2mutexza2zd2zz__biglooz00;
				{	/* Llib/thread.scm 201 */

					if ((((long) 0) == ((long) 0)))
						{	/* Llib/thread.scm 201 */
							bgl_mutex_lock(BgL_arg2000z00_1012);
						}
					else
						{	/* Llib/thread.scm 201 */
							bgl_mutex_timed_lock(BgL_arg2000z00_1012, ((long) 0));
			}}}
			if (PROCEDURE_CORRECT_ARITYP(BgL_funz00_23, (int) (((long) 1))))
				{	/* Llib/bigloo.scm 623 */
					BGl_za2bigloozd2exitzd2functionsza2z00zz__biglooz00 =
						MAKE_PAIR(BgL_funz00_23,
						BGl_za2bigloozd2exitzd2functionsza2z00zz__biglooz00);
				}
			else
				{	/* Llib/bigloo.scm 623 */
					BGl_errorz00zz__errorz00(BGl_string2366z00zz__biglooz00,
						BGl_string2367z00zz__biglooz00, BgL_funz00_23);
				}
			{	/* Llib/bigloo.scm 628 */
				obj_t BgL_arg2002z00_1016;

				BgL_arg2002z00_1016 = BGl_za2exitzd2mutexza2zd2zz__biglooz00;
				return BBOOL(bgl_mutex_unlock(BgL_arg2002z00_1016));
			}
		}
	}



/* _register-exit-function! */
	obj_t BGl__registerzd2exitzd2functionz12z12zz__biglooz00(obj_t
		BgL_envz00_2097, obj_t BgL_funz00_2098)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 621 */
			{	/* Llib/bigloo.scm 628 */
				obj_t BgL_auxz00_2595;

				if (PROCEDUREP(BgL_funz00_2098))
					{	/* Llib/bigloo.scm 628 */
						BgL_auxz00_2595 = BgL_funz00_2098;
					}
				else
					{	/* Llib/bigloo.scm 628 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string2368z00zz__biglooz00, BGl_string2346z00zz__biglooz00,
							BgL_funz00_2098, BGl_string2344z00zz__biglooz00,
							BINT(((long) 23510)));
						exit(-1);
					}
				return
					BGl_registerzd2exitzd2functionz12z12zz__biglooz00(BgL_auxz00_2595);
			}
		}
	}



/* bigloo-exit-apply */
	BGL_EXPORTED_DEF obj_t bigloo_exit_apply(obj_t BgL_valz00_24)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 633 */
			{	/* Llib/bigloo.scm 634 */
				obj_t BgL_mutz00_1017;

				if (BGL_MUTEXP(BGl_za2exitzd2mutexza2zd2zz__biglooz00))
					{	/* Llib/bigloo.scm 634 */
						BgL_mutz00_1017 = BGl_za2exitzd2mutexza2zd2zz__biglooz00;
					}
				else
					{	/* Llib/bigloo.scm 634 */
						BgL_mutz00_1017 = bgl_make_mutex(BGl_symbol2337z00zz__biglooz00);
					}
				{	/* Llib/thread.scm 201 */

					if ((((long) 0) == ((long) 0)))
						{	/* Llib/thread.scm 201 */
							bgl_mutex_lock(BgL_mutz00_1017);
						}
					else
						{	/* Llib/thread.scm 201 */
							bgl_mutex_timed_lock(BgL_mutz00_1017, ((long) 0));
				}}
				{
					obj_t BgL_valz00_1021;

					BgL_valz00_1021 = BgL_valz00_24;
				BgL_zc3anonymousza32003ze3z83_1022:
					{	/* Llib/bigloo.scm 639 */
						obj_t BgL_valz00_1023;

						if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_valz00_1021))
							{	/* Llib/bigloo.scm 639 */
								BgL_valz00_1023 = BgL_valz00_1021;
							}
						else
							{	/* Llib/bigloo.scm 639 */
								BgL_valz00_1023 = BINT(((long) 0));
							}
						if (PAIRP(BGl_za2bigloozd2exitzd2functionsza2z00zz__biglooz00))
							{	/* Llib/bigloo.scm 643 */
								obj_t BgL_funz00_1025;

								BgL_funz00_1025 =
									CAR(BGl_za2bigloozd2exitzd2functionsza2z00zz__biglooz00);
								BGl_za2bigloozd2exitzd2functionsza2z00zz__biglooz00 =
									CDR(BGl_za2bigloozd2exitzd2functionsza2z00zz__biglooz00);
								{	/* Llib/bigloo.scm 645 */
									obj_t BgL_nvalz00_1026;

									BgL_nvalz00_1026 =
										PROCEDURE_ENTRY(BgL_funz00_1025) (BgL_funz00_1025,
										BgL_valz00_1023, BEOA);
									{	/* Llib/bigloo.scm 646 */
										obj_t BgL_arg2005z00_1027;

										if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00
											(BgL_nvalz00_1026))
											{	/* Llib/bigloo.scm 646 */
												BgL_arg2005z00_1027 = BgL_nvalz00_1026;
											}
										else
											{	/* Llib/bigloo.scm 646 */
												BgL_arg2005z00_1027 = BgL_valz00_1023;
											}
										{
											obj_t BgL_valz00_2620;

											BgL_valz00_2620 = BgL_arg2005z00_1027;
											BgL_valz00_1021 = BgL_valz00_2620;
											goto BgL_zc3anonymousza32003ze3z83_1022;
										}
									}
								}
							}
						else
							{	/* Llib/bigloo.scm 642 */
								bgl_mutex_unlock(BgL_mutz00_1017);
								return BgL_valz00_1023;
							}
					}
				}
			}
		}
	}



/* _bigloo-exit-apply */
	obj_t BGl__bigloozd2exitzd2applyz00zz__biglooz00(obj_t BgL_envz00_2099,
		obj_t BgL_valz00_2100)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 633 */
			return bigloo_exit_apply(BgL_valz00_2100);
		}
	}



/* time */
	BGL_EXPORTED_DEF obj_t BGl_timez00zz__biglooz00(obj_t BgL_procz00_25)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 654 */
			if (PROCEDURE_CORRECT_ARITYP(BgL_procz00_25, (int) (((long) 0))))
				{	/* Llib/bigloo.scm 655 */
					return bgl_time(BgL_procz00_25);
				}
			else
				{	/* Llib/bigloo.scm 655 */
					return
						BGl_errorz00zz__errorz00(BGl_symbol2369z00zz__biglooz00,
						BGl_string2367z00zz__biglooz00, BgL_procz00_25);
				}
		}
	}



/* _time */
	obj_t BGl__timez00zz__biglooz00(obj_t BgL_envz00_2101, obj_t BgL_procz00_2102)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 654 */
			{	/* Llib/bigloo.scm 655 */
				obj_t BgL_auxz00_2628;

				if (PROCEDUREP(BgL_procz00_2102))
					{	/* Llib/bigloo.scm 655 */
						BgL_auxz00_2628 = BgL_procz00_2102;
					}
				else
					{	/* Llib/bigloo.scm 655 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string2371z00zz__biglooz00, BGl_string2346z00zz__biglooz00,
							BgL_procz00_2102, BGl_string2344z00zz__biglooz00,
							BINT(((long) 24494)));
						exit(-1);
					}
				return BGl_timez00zz__biglooz00(BgL_auxz00_2628);
			}
		}
	}



/* bmem-reset! */
	BGL_EXPORTED_DEF obj_t BGl_bmemzd2resetz12zc0zz__biglooz00()
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 666 */
			return bgl_bmem_reset();
		}
	}



/* _bmem-reset! */
	obj_t BGl__bmemzd2resetz12zc0zz__biglooz00(obj_t BgL_envz00_2103)
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 666 */
			return bgl_bmem_reset();
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zz__biglooz00()
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 14 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zz__biglooz00()
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 14 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zz__biglooz00()
	{
		AN_OBJECT;
		{	/* Llib/bigloo.scm 14 */
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 68033950),
				BSTRING_TO_STRING(BGl_string2372z00zz__biglooz00));
			BGl_modulezd2initializa7ationz75zz__configurez00(((long) 306671391),
				BSTRING_TO_STRING(BGl_string2372z00zz__biglooz00));
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 327583589),
				BSTRING_TO_STRING(BGl_string2372z00zz__biglooz00));
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 429190545),
				BSTRING_TO_STRING(BGl_string2372z00zz__biglooz00));
			BGl_modulezd2initializa7ationz75zz__threadz00(((long) 500588328),
				BSTRING_TO_STRING(BGl_string2372z00zz__biglooz00));
			return
				BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 3491337),
				BSTRING_TO_STRING(BGl_string2372z00zz__biglooz00));
		}
	}

#ifdef __cplusplus
}
#endif
